/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AverageDirectionalIndexIndicatorStrategy } from "./AverageDirectionalIndexIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AverageDirectionalIndexIndicator = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new AverageDirectionalIndexIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return AverageDirectionalIndexIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(AverageDirectionalIndexIndicator.uh));
        }
        set ug(a) {
            this.h(AverageDirectionalIndexIndicator.uh, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
    }
    AverageDirectionalIndexIndicator.$t = markType(AverageDirectionalIndexIndicator, 'AverageDirectionalIndexIndicator', StrategyBasedIndicator.$);
    AverageDirectionalIndexIndicator.uh = StrategyBasedIndicator.ud(14, AverageDirectionalIndexIndicator.$);
    return AverageDirectionalIndexIndicator;
})();
//# sourceMappingURL=AverageDirectionalIndexIndicator.js.map
