/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Flattener } from "igniteui-angular-core";
/**
 * @hidden
 */
export let BollingerBandsOverlay = /*@__PURE__*/ (() => {
    class BollingerBandsOverlay extends FinancialOverlay {
        constructor() {
            super();
            this.s8 = 0;
            this.s9 = 0;
            this.s6 = new List$1(Number_$type, 0);
            this.s7 = new List$1(Number_$type, 0);
            this.ab = BollingerBandsOverlay.$;
            this.pu = new CategoryFrame(4);
            this.pw = new CategoryFrame(4);
            this.ps = new CategoryFrame(4);
        }
        lm(a, b, c, d) {
            if (this.q9().contains(b)) {
                this.s0 = false;
            }
            super.lm(a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.s0 = false;
                    this.l0(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.l0(false);
                    break;
            }
        }
        s1() {
            this.s6.clear();
            this.s7.clear();
            let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.q8), this.tb));
            let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.q8), this.tb));
            this.s9 = 1.7976931348623157E+308;
            this.s8 = -1.7976931348623157E+308;
            let c = true;
            let d = true;
            let e = this.ta;
            while (c || d) {
                if (a.moveNext()) {
                    this.s6.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.s7.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.s9 = Math.min(this.s9, a.current - b.current * e);
                    this.s8 = Math.max(this.s8, a.current + b.current * e);
                }
            }
            return true;
        }
        ap(a) {
            if (this.s6 == null || this.s7 == null || a == null || this.ch == null || a != this.qc) {
                return null;
            }
            let b = new AxisRange(this.s9, this.s8);
            return b;
        }
        sh(a, b) {
            super.sh(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pq;
            let g = this.qc;
            let h = new ScalerParams(0, c, d, f.cc, e);
            let i = new ScalerParams(0, c, d, g.cc, e);
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = typeCast(ISortingAxis_$type, this.pq);
            if (j != null && j.i$b.count != this.ch.count) {
                return;
            }
            let k = 0;
            k = this.rh(c, d, e);
            if (!this.s0) {
                this.s0 = this.s1();
                if (this.qc != null) {
                    this.qc.cw(true);
                }
            }
            i.b = this.f2();
            let l = this.pq.eb(2, h) - this.pq.eb(1, h);
            for (let m = b.bx.c; m <= b.bx.d; ++m) {
                let n;
                if (j == null) {
                    n = b.bx.getBucket(m);
                }
                else {
                    let o = j.i$b._inner[m];
                    let p = j.i$d(o);
                    let q = this.s6._inner[m];
                    let r = this.s7._inner[m];
                    let s = q;
                    let t = r;
                    let u = p;
                    let v = 1;
                    while (m < b.bx.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.s6._inner[m];
                        t += this.s7._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    let w = s - t * this.ta;
                    let x = s;
                    let y = s + t * this.ta;
                    let z = NaN;
                    if (!isNaN_(p)) {
                        z = this.pq.d8(p, h);
                    }
                    n = [z, w, x, y];
                }
                let aa = Math.max(1, l);
                if (!isNaN_(n[0]) && m * aa >= this.s2) {
                    if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.d8(n[0], h) + k;
                    }
                    n[1] = g.d8(n[1], i);
                    n[2] = g.d8(n[2], i);
                    n[3] = g.d8(n[3], i);
                    a.f.add(n);
                }
            }
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            if (c != null) {
                c.b4();
            }
        }
        f8(a, b, c) {
            if (this.s6 == null) {
                return super.f8(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            f.c = this.ca.pv;
            return this.ga(this.s6, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        g6(a, b) {
            if (this.s6 == null) {
                return super.g6(a, b);
            }
            return this.g7(a, b, this.pq, runOn(this, this.rg), this.s6);
        }
        g4(a, b) {
            if (this.s6 == null) {
                return super.g4(a, b);
            }
            return this.g5(a, b, this.pq, runOn(this, this.rg), this.s6);
        }
        e3(a, b, c) {
            let d = super.e3(a, b, c);
            if (!this.qz(this.q9())) {
                d = false;
            }
            return d;
        }
        sj(a, b) {
            super.sj(a, b);
            let c = typeCast(BollingerBandsOverlayView.$, b);
            let d = this.getEffectiveViewport1(b);
            if (b.b0(a)) {
                c.b4();
                let e = a.f.count;
                let f = (g) => a.f._inner[g][0];
                let g = (h) => a.f._inner[e - 1 - h][0];
                let h = (i) => a.f._inner[i][1];
                let i = (j) => a.f._inner[j][2];
                let j = (k) => a.f._inner[e - 1 - k][3];
                c.b5(e, f, g, h, i, j);
                b.b2(a);
            }
            this.pz.a0(this, this.qy(), runOn(this, this.pi), this.rn(b), this.rp(b));
            let k = false;
            let l = this.pz.b;
            let m = a.f;
            let n = this.ch.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                let o = new ScalerParams(0, b.bv, b.bu, this.pq.cc, d);
                this.sg(m, -1, n, this.pq, o, b.q);
            }
            let p = c.cc;
            let q = c.cd;
            let r = c.ce;
            let s = c.b7;
            this.pz.ad(q, true, false, true, true);
            this.pz.an = null;
            this.pz.am = null;
            this.pz.ad(p, true, false, false, true);
            this.pz.ad(r, true, false, false, true);
            this.pz.ad(s, false, true, false, false);
            s._opacity = this.pz.j * this.fi;
        }
        bu() {
            return new BollingerBandsOverlayView(this);
        }
        lh(a) {
            super.lh(a);
            this.s5 = typeCast(BollingerBandsOverlayView.$, a);
        }
        rq() {
            return 3;
        }
        f2() {
            return Series.f3(this.s6, null);
        }
    }
    BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:ta:te', [1, 2], 'Period:tb:tf', [1, 14]]);
    return BollingerBandsOverlay;
})();
/**
 * @hidden
 */
export let BollingerBandsBucketCalculator = /*@__PURE__*/ (() => {
    class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.a.bz.ch.count - 1);
            if (b <= c) {
                let d = this.f.b3.ta;
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = b; h <= c; ++h) {
                    if (!isNaN_(this.f.b3.s6._inner[h]) && !isNaN_(this.f.b3.s7._inner[h])) {
                        e += this.f.b3.s6._inner[h];
                        f += this.f.b3.s7._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        }
    }
    BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
})();
/**
 * @hidden
 */
export let BollingerBandsOverlayView = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b3 = null;
            this.b8 = new Polygon();
            this.cf = new Polyline();
            this.cg = new Polyline();
            this.ch = new Polyline();
            this.b6 = new Polygon();
            this.b9 = new Polyline();
            this.ca = new Polyline();
            this.cb = new Polyline();
            this.b3 = a;
        }
        as() {
            super.as();
            if (!this.q) {
            }
        }
        by() {
            return new BollingerBandsBucketCalculator(this);
        }
        b5(a, b, c, d, e, f) {
            for (let g of fromEnum(Flattener.d(a, b, d, this.e.gh))) {
                this.b8.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.cf.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
            for (let h of fromEnum(Flattener.d(a, b, e, this.e.gh))) {
                this.cg.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
            for (let i of fromEnum(Flattener.d(a, c, f, this.e.gh))) {
                this.b8.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ch.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
            this.aq();
        }
        b4() {
            this.b8.ak.clear();
            this.cf.ak.clear();
            this.cg.ak.clear();
            this.ch.ak.clear();
            this.aq();
        }
        get b7() {
            return this.b8;
        }
        get cc() {
            return this.cf;
        }
        get cd() {
            return this.cg;
        }
        get ce() {
            return this.ch;
        }
        bc() {
            super.bc();
            this.b6.ak = this.b8.ak;
            this.b9.ak = this.cf.ak;
            this.ca.ak = this.cg.ak;
            this.cb.ak = this.ch.ak;
            let a = this.bo();
            this.b6._fill = a;
            this.b6._opacity = 1;
            this.b9._stroke = a;
            this.b9.ac = this.e.fl + 3;
            this.ca._stroke = a;
            this.ca.ac = this.e.fl + 3;
            this.cb._stroke = a;
            this.cb.ac = this.e.fl + 3;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.b6);
                    a.u(this.b9);
                    a.u(this.ca);
                    a.u(this.cb);
                }
                else {
                    a.t(this.b8);
                    a.u(this.cf);
                    a.u(this.cg);
                    a.u(this.ch);
                }
            }
        }
        al(a) {
            super.al(a);
            this.e.a6.exportPolygonData(a, this.b8, "FillShape", ["Fill"]);
            this.e.a6.exportPolylineData(a, this.cf, "BottomLine", ["Lower", "Main"]);
            this.e.a6.exportPolylineData(a, this.cg, "CentralLine", ["Central"]);
            this.e.a6.exportPolylineData(a, this.ch, "TopLine", ["Upper"]);
        }
    }
    BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
})();
//# sourceMappingURL=BollingerBandsOverlay_combined.js.map
