/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentageVolumeOscillatorIndicatorStrategy } from "./PercentageVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PercentageVolumeOscillatorIndicator = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new PercentageVolumeOscillatorIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return PercentageVolumeOscillatorIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get shortPeriod() {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.uh));
        }
        set shortPeriod(a) {
            this.h(PercentageVolumeOscillatorIndicator.uh, a);
        }
        t3() {
            return this.shortPeriod;
        }
        get longPeriod() {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.ug));
        }
        set longPeriod(a) {
            this.h(PercentageVolumeOscillatorIndicator.ug, a);
        }
        t0() {
            return this.longPeriod;
        }
    }
    PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    PercentageVolumeOscillatorIndicator.uh = StrategyBasedIndicator.uf(10, PercentageVolumeOscillatorIndicator.$);
    PercentageVolumeOscillatorIndicator.ug = StrategyBasedIndicator.ub(30, PercentageVolumeOscillatorIndicator.$);
    return PercentageVolumeOscillatorIndicator;
})();
//# sourceMappingURL=PercentageVolumeOscillatorIndicator.js.map
