/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Array_$type, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RadialLineSeries = /*@__PURE__*/ (() => {
    class RadialLineSeries extends AnchoredRadialSeries {
        constructor() {
            super();
            this.ab = RadialLineSeries.$;
        }
        get_dv() {
            return true;
        }
        bu() {
            return new RadialLineSeriesView(this);
        }
        lh(a) {
            super.lh(a);
            this.tf = a;
        }
        ac() {
            super.ac();
        }
        preferredCategoryMode(a) {
            return 0;
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            c.c1();
        }
        r4(a, b) {
            super.r4(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = a.f;
            let f = e.count;
            let g = new List$1(Array_$type, 2, f);
            let h = 0;
            for (let i = 0; i < f; i++) {
                let j = new Array(4);
                g.add(j);
                j[0] = this.q7.d(a.f._inner[i][0], a.f._inner[i][1], c, d);
                j[1] = this.q7.e(a.f._inner[i][0], a.f._inner[i][1], c, d);
                j[2] = this.q7.d(a.f._inner[i][0], a.f._inner[i][2], c, d);
                let k = a.f._inner[i][2];
                j[3] = this.q7.e(a.f._inner[i][0], k, c, d);
                if (k > h) {
                    h = k;
                }
            }
            let l = this.getEffectiveViewport1(b);
            this.rd.a0(this, this.rp(), runOn(this, this.qw), this.rr(b), this.rs(b));
            let m = false;
            let n = this.rd.b;
            if (n != null) {
                m = true;
            }
            if (m) {
                let o = new ScalerParams(0, b.bv, b.bu, this.qz.cc, l);
                this.sz(e, -1, this.si.count, this.qz, o, b.q);
            }
            let p = b;
            let q = p.da;
            let r = p.db;
            let s = p.c9;
            this.rd.ad(q, true, false, true, false);
            this.rd.ad(r, true, false, true, false);
            this.rd.ad(s, false, true, false, false);
            s._opacity = 0.75 * this.rd.j;
            p.c2(f, g, false, this.tg, this.sb(g, f - 1, b), p.cs.b, this.gh);
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case RadialLineSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        }
        get_sl() {
            return true;
        }
    }
    RadialLineSeries.$t = markType(RadialLineSeries, 'RadialLineSeries', AnchoredRadialSeries.$);
    RadialLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:tg:ti', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialLineSeries;
})();
/**
 * @hidden
 */
export let RadialLineSeriesView = /*@__PURE__*/ (() => {
    class RadialLineSeriesView extends AnchoredRadialSeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.c7 = new Path();
            this.c6 = new Path();
            this.c8 = new Path();
            this.c4 = new Path();
            this.c3 = new Path();
            this.c5 = new Path();
            this.c0 = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        }
        get da() {
            return this.c7;
        }
        get db() {
            return this.c8;
        }
        get c9() {
            return this.c6;
        }
        c1() {
            this.c7.ak = null;
            this.c6.ak = null;
            this.c8.ak = null;
            this.c4.ak = null;
            this.c3.ak = null;
            this.c5.ak = null;
            this.aq();
        }
        c2(a, b, c, d, e, f, g) {
            this.cw.sd.m(this.c7, this.c6, this.c8, a, b, c, d, e, f, g);
            this.aq();
        }
        bb() {
            super.bb();
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.c3.ak = this.c6.ak;
            this.c4.ak = this.c7.ak;
            this.c5.ak = this.c8.ak;
            this.c4._stroke = a;
            this.c4.ac = this.e.fl + 3;
            this.c5._stroke = a;
            this.c5.ac = this.e.fl + 3;
            this.c3._fill = a;
            this.c3._opacity = 1;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c3);
                    a.s(this.c4);
                    a.s(this.c5);
                }
                else {
                    a.s(this.c6);
                    a.s(this.c7);
                    a.s(this.c8);
                }
            }
        }
        al(a) {
            super.al(a);
            this.e.a6.exportPathData(a, this.c7, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.c8, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.c6, "translucentShape", ["Translucent"]);
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        }
    }
    RadialLineSeriesView.$t = markType(RadialLineSeriesView, 'RadialLineSeriesView', AnchoredRadialSeriesView.$);
    return RadialLineSeriesView;
})();
//# sourceMappingURL=RadialLineSeries_combined.js.map
