/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { RelativeStrengthIndexIndicatorStrategy } from "./RelativeStrengthIndexIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RelativeStrengthIndexIndicator = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicator extends StrategyBasedIndicator {
        constructor() {
            super();
        }
        get_s2() {
            return 1;
        }
        get_tv() {
            return new RelativeStrengthIndexIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return RelativeStrengthIndexIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(RelativeStrengthIndexIndicator.uh));
        }
        set ug(a) {
            this.h(RelativeStrengthIndexIndicator.uh, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
    }
    RelativeStrengthIndexIndicator.$t = markType(RelativeStrengthIndexIndicator, 'RelativeStrengthIndexIndicator', StrategyBasedIndicator.$);
    RelativeStrengthIndexIndicator.uh = StrategyBasedIndicator.ud(14, RelativeStrengthIndexIndicator.$);
    return RelativeStrengthIndexIndicator;
})();
//# sourceMappingURL=RelativeStrengthIndexIndicator.js.map
