/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let SelectedItemChangedEventArgs = /*@__PURE__*/ (() => {
    class SelectedItemChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._oldItem = null;
            this._newItem = null;
            this.oldItem = a;
            this.newItem = b;
        }
        get oldItem() {
            return this._oldItem;
        }
        set oldItem(a) {
            this._oldItem = a;
        }
        get newItem() {
            return this._newItem;
        }
        set newItem(a) {
            this._newItem = a;
        }
    }
    SelectedItemChangedEventArgs.$t = markType(SelectedItemChangedEventArgs, 'SelectedItemChangedEventArgs', EventArgs.$);
    return SelectedItemChangedEventArgs;
})();
//# sourceMappingURL=SelectedItemChangedEventArgs.js.map
