/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ItemwiseStrategyBasedIndicator } from "./ItemwiseStrategyBasedIndicator";
import { WeightedCloseIndicatorStrategy } from "./WeightedCloseIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let WeightedCloseIndicator = /*@__PURE__*/ (() => {
    class WeightedCloseIndicator extends ItemwiseStrategyBasedIndicator {
        get_uh() {
            return new WeightedCloseIndicatorStrategy();
        }
        get uh() {
            return this.get_uh();
        }
        get_t8() {
            return WeightedCloseIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
    }
    WeightedCloseIndicator.$t = markType(WeightedCloseIndicator, 'WeightedCloseIndicator', ItemwiseStrategyBasedIndicator.$);
    return WeightedCloseIndicator;
})();
//# sourceMappingURL=WeightedCloseIndicator.js.map
