/**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*
* `IgxDataSourceSupportingCalculation` class Represents a calculation strategy that uses the calculation data source to product a column of values.
*
*     DataSourceSupportingCalculation SC = new DataSourceSupportingCalculation();
*/
export class IgxDataSourceSupportingCalculation {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}
//# sourceMappingURL=igx-data-source-supporting-calculation.js.map