import { IgxSelectedItemChangedEventArgs } from "./igx-selected-item-changed-event-args";
import { ensureBool } from "igniteui-angular-core";
/**
 * Provides data for the SelectedItemChanging event.
*/
export class IgxSelectedItemChangingEventArgs extends IgxSelectedItemChangedEventArgs {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Set this to true in order to stop the SelectedItem from changing.
    */
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}
//# sourceMappingURL=igx-selected-item-changing-event-args.js.map