/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { enumGetBox, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
var AnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeries, _super);
    function AnchoredCategorySeries() {
        var _this = _super.call(this) || this;
        _this.sz = null;
        _this.s3 = false;
        _this.s1 = null;
        _this.sw = null;
        _this.s7 = null;
        _this.q8 = new CategoryFramePreparer(1, _this, _this.rc, _this, _this, _this.rc.cr);
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeries.prototype, "s0", {
        get: function () {
            var _this = this;
            if (this.sz == null) {
                this.sz = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
            }
            return this.sz;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.getHostReferenceValue = function () {
        return this.f2();
    };
    AnchoredCategorySeries.prototype.bu = function () {
        var a = new AnchoredCategorySeriesView(this);
        return a;
    };
    AnchoredCategorySeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.sv = a;
    };
    AnchoredCategorySeries.prototype.hk = function (a, b) {
        var c = this.ja(b);
        if (c == AnchoredCategorySeries.$$p[2]) {
            return this.hl(a, b, this.tb);
        }
        return _super.prototype.hk.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
        get: function () {
            return this.s1;
        },
        set: function (a) {
            if (this.s1 != a) {
                var b = this.s1;
                this.s1 = a;
                if (!this.s3) {
                    this.raisePropertyChanged("ValueColumn", b, this.s1);
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "tt", {
        get: function () {
            return this.c(AnchoredCategorySeries.ti);
        },
        set: function (a) {
            this.h(AnchoredCategorySeries.ti, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.eh = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.fetchXAxis();
        var d = this.fetchYAxis();
        var e = this.o9(this.bx);
        var f = c != null ? this.q8.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.s0.c$a(this, this.valueColumn, c, d, f, a);
    };
    AnchoredCategorySeries.prototype.ss = function (a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.ch;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.ch.item(g);
        }
        return d;
    };
    AnchoredCategorySeries.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        if (this.sv.c3 && this.sv.c2.g$b(a, b, c, d)) {
            this.l0(false);
            this.k7();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.ce(this.tb);
                }
                var e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.cv()) {
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.ch != null) {
                    this.ch.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.ce(this.tb);
                }
                this.s7 = this.tb;
                break;
            case "ValueColumn":
                if (this.sv.c3) {
                    this.sv.c2.g$i();
                }
                var f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.cv()) {
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                }
                this.th();
                this.mj();
                break;
            case "TrendLineBrush":
                this.md();
                break;
            case "ErrorBarSettings":
                this.l0(false);
                break;
            case "TrendLineType":
                this.k7();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.l0(false);
                break;
        }
    };
    AnchoredCategorySeries.prototype.ap = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    AnchoredCategorySeries.prototype.kk = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.sv.cr.g(this.gh);
                break;
        }
        if (this.sv.c3) {
            this.sv.c2.g$e(a, b, c, d);
        }
        this.th();
        this.mj();
    };
    AnchoredCategorySeries.prototype.r2 = function () {
        return this.s4(this.rc);
    };
    AnchoredCategorySeries.prototype.s4 = function (a) {
        var b = 0;
        var c = a.bv;
        var d = a.bu;
        var e = this.getEffectiveViewport1(a);
        var f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            var g = new ScalerParams(0, c, d, f.cc, e);
            if (f.cj) {
                g.b = this.f2();
            }
            b = f.d8(f.k5, g);
        }
        return b;
    };
    AnchoredCategorySeries.prototype.tg = function (a, b, c) {
        var d = this.s4(c);
        if (a.count > 0) {
            var e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    };
    AnchoredCategorySeries.prototype.st = function (a, b, c, d) {
        return this.su(a, b, c, d, false);
    };
    AnchoredCategorySeries.prototype.su = function (a, b, c, d, e) {
        return CategorySeries.qx(a, b, c, d, e);
    };
    AnchoredCategorySeries.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        var e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cr.d < 1) {
            d = false;
        }
        return d;
    };
    AnchoredCategorySeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = b;
        c.cx();
        if (c.c3) {
            c.c2.g$d();
        }
    };
    AnchoredCategorySeries.prototype.si = function (a, b) {
        _super.prototype.si.call(this, a, b);
        this.q9(b).d(a, b);
    };
    AnchoredCategorySeries.prototype.sl = function (a, b) {
        _super.prototype.sl.call(this, a, b);
        var c = typeCast(AnchoredCategorySeriesView.$, b);
        c.b3 = true;
        if (c.c3) {
            c.c2.g$g(a.p);
        }
        if (this.pt()) {
            CategoryMarkerManager.e(this, a.m, b.cu, this.pv);
            this.sf(b, a);
            b.cm();
        }
        this.td(a, b);
    };
    AnchoredCategorySeries.prototype.lz = function (a, b, c, d, e) {
        _super.prototype.lz.call(this, a, b, c, d, e);
        var f = this.a4.a$h.item(d);
        var g = f;
        g.cr.g(this.gh);
        f.a1(c);
        if (this.ct(g)) {
            return;
        }
        if (this.sw == null) {
            this.sw = new CategoryFrame(3);
        }
        this.sw.u();
        this.si(this.sw, g);
        this.sl(this.sw, g);
    };
    AnchoredCategorySeries.prototype.td = function (a, b) {
    };
    AnchoredCategorySeries.prototype.md = function () {
        _super.prototype.md.call(this);
        if (this.g9 < 0) {
            return;
        }
        this.sv.c7();
        if (this.trendLineBrush != null) {
            this.sv.c5();
        }
        else {
            this.sv.c4();
        }
    };
    AnchoredCategorySeries.prototype.hn = function (a, b) {
        if (this.sv.c3 && a == this.sv.c2.g$j) {
            return null;
        }
        return _super.prototype.hn.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.q2()));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.q2());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.rn());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.sv.cr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.r6();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
        if (this.sx == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.b;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
        get: function () {
            return this.sv.c3 ? this.sv.c2 : null;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.kr = function (a) {
        _super.prototype.kr.call(this, a);
        if (this.sv.c3) {
            this.a6.exportTrendlineData(this, a, this.sv.c2.g$j);
        }
    };
    AnchoredCategorySeries.prototype.hh = function (a) {
        var _this = this;
        var b = this.fetchXAxis();
        var c = this.fetchYAxis();
        return this.s0.c$b(this, a, this.r3(this.bx), this.valueColumn, b, c, this.sy == 1, function (d) { return _super.prototype.hh.call(_this, d); });
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.f2 = function () {
        return Series.f3(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    };
    AnchoredCategorySeries.prototype.get_s6 = function () {
        return 0;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "s6", {
        get: function () {
            return this.get_s6();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.aq = function (a) {
        if (a.isEmpty && this.ca != null) {
            a = this.ca.pg;
        }
        if (this.valueColumn == null) {
            return null;
        }
        var b = this.o7(this.bx);
        var c = this.q2();
        var d = new ScalerParams(0, a, this.ca.pv, c.cc, this.getEffectiveViewport());
        var e = (c.eb(b.left, d));
        var f = (c.eb(b.right, d));
        if (c.cc) {
            var g = e;
            e = f;
            f = g;
        }
        e -= this.s6;
        f += this.s6;
        var h = null;
        if (c.ch) {
            h = c;
            e = h.i$f(e);
            f = h.i$f(f);
        }
        else {
            e = Math.floor(e);
            f = Math.ceil(f);
        }
        if (isNaN_(e) || isNaN_(f)) {
            return null;
        }
        e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
        f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
        var i = 1.7976931348623157E+308;
        var j = -1.7976931348623157E+308;
        if (truncate(e) <= truncate(f)) {
            for (var k = truncate(e); k <= truncate(f); k++) {
                var l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                var m = this.valueColumn.item(l);
                if (this.valueColumn.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, m);
            }
        }
        var n = new AxisRange(i, j);
        n = this.ao(n, this.rn(), a);
        return n;
    };
    AnchoredCategorySeries.prototype.th = function () {
        this.fs = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.ti = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:sy:tj', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:sx:tk', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:tb:ts', [2, null], 'TrendLineType::tq', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::tp', [1, 1.5], 'TrendLinePeriod::to', [1, 7], 'TrendLineBrush::tl', [Brush.$, null], 'TrendLineZIndex:s5:tr', [1, 1001], 'TrendLineDashArray:tu:tm', [DoubleCollection.$], 'TrendLineDashCap:tv:tn', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
}(CategorySeries));
export { AnchoredCategorySeries };
/**
 * @hidden
 */
var AnchoredCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategoryBucketCalculator, _super);
    function AnchoredCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 0;
        var h = 0;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.c0.valueColumn.count;
        this.h = this.i.c0.valueColumn.asArray();
    };
    AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
}(CategoryBucketCalculator));
export { AnchoredCategoryBucketCalculator };
/**
 * @hidden
 */
var AnchoredCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeriesView, _super);
    function AnchoredCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c0 = null;
        _this.c1 = null;
        _this.c0 = a;
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "c2", {
        get: function () {
            if (this.c1 == null) {
                this.c1 = CategoryTrendLineManagerFactory.a(this.c1, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
            return this.c1;
        },
        set: function (a) {
            this.c1 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "c3", {
        get: function () {
            return this.c1 != null;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeriesView.prototype.c7 = function () {
        this.c0.tt = null;
    };
    AnchoredCategorySeriesView.prototype.c5 = function () {
        this.c0.tt = this.c0.trendLineBrush;
    };
    AnchoredCategorySeriesView.prototype.c4 = function () {
        this.c0.tt = this.c0.of;
    };
    AnchoredCategorySeriesView.prototype.cs = function () {
        return new AnchoredCategoryBucketCalculator(this);
    };
    AnchoredCategorySeriesView.prototype.c6 = function () {
        this.cr.cacheValues();
    };
    AnchoredCategorySeriesView.prototype.c8 = function () {
        this.cr.unCacheValues();
    };
    AnchoredCategorySeriesView.prototype.c9 = function (a) {
        var b = this.cu.item(a);
        return this.cp(b);
    };
    AnchoredCategorySeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (this.c0.trendLineType != 0 && !b) {
                var c = this.c2.g$j;
                c.ac = this.c0.trendLineThickness;
                c._stroke = this.c0.tt;
                c.ai = this.c0.tu;
                c.ad = this.c0.tv;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.c0.s0.c$c(this.e, this.c0.tb);
    };
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
}(CategorySeriesView));
export { AnchoredCategorySeriesView };
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map
