/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, Boolean_$type, runOn, delegateRemove, typeCast, delegateCombine, fromEnum, fromEn, markType, markDep } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { XamDataChart } from "./XamDataChart";
import { Tuple$2 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var AnnotationLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayer, _super);
    function AnnotationLayer() {
        var _this = _super.call(this) || this;
        _this.ql = null;
        _this.pk = null;
        _this.pj = null;
        _this.pl = null;
        _this.qj = { $type: Point_$type, x: NaN, y: NaN };
        _this.pm = false;
        _this.ql = { $type: Point_$type, x: NaN, y: NaN };
        return _this;
    }
    AnnotationLayer.prototype.bu = function () {
        return new AnnotationLayerView(this);
    };
    AnnotationLayer.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.pi = a;
    };
    AnnotationLayer.prototype.pq = function (a) {
        if (a == null) {
            return false;
        }
        if (a.c6) {
            return false;
        }
        if (a.ed) {
            return false;
        }
        if (a == this) {
            return false;
        }
        return a.e3(a.bx.bu, a.bx.bv, a.bx);
    };
    AnnotationLayer.prototype.get_dd = function () {
        return this.pn;
    };
    AnnotationLayer.prototype.bo = function () {
        if (this.bp == 0) {
            return 1;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    AnnotationLayer.prototype.get_ds = function () {
        return this.ps || this.pt;
    };
    AnnotationLayer.prototype.get_isUsableInLegend = function () {
        return this.pt;
    };
    AnnotationLayer.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = c;
                var f = d;
                if (e != null) {
                    this.qc(e.series);
                    var g = e.series;
                    g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.p9));
                    if (typeCast(XamDataChart.$, e) !== null) {
                        var h = e;
                        this.qb(h.axes);
                        var i = h.axes;
                        i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.pz));
                    }
                }
                if (f != null) {
                    this.p7(f.series);
                    var j = f.series;
                    j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.p9));
                    if (typeCast(XamDataChart.$, f) !== null) {
                        var k = f;
                        this.p6(k.axes);
                        var l = k.axes;
                        l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.pz));
                    }
                }
                break;
            case AnnotationLayer.$$p[3]:
            case AnnotationLayer.$$p[2]:
                if (this.ds) {
                    if (this.g9 == -1) {
                        this.g9 = XamDataChart.rl(this);
                    }
                }
                else {
                    this.g9 = -1;
                    this.of = null;
                    this.oi = null;
                }
                if (this.ca != null) {
                    this.ca.kl();
                }
                this.l0(true);
                break;
            case "TransitionProgress":
                this.pl.c(this.gn, this.pk, this.pj);
                if (this.ct(this.bx)) {
                    return;
                }
                if (this.gn == 1) {
                    this.p8(this.pj, this.bx);
                }
                else {
                    this.p8(this.pl, this.bx);
                }
                if (this.ca != null) {
                    this.ca.ln(this);
                }
                break;
            case AnnotationLayer.$$p[1]:
                if (this.ca != null) {
                    this.ca.kj();
                }
                break;
            case AnnotationLayer.$$p[0]:
                this.ql = this.qk;
                this.lb(this.qk);
                break;
            case "ShouldRenderAsOverlay":
                if (this.ca != null) {
                    this.bx.ak(this.ca);
                    this.bx.ag(this.ca);
                }
                break;
        }
    };
    AnnotationLayer.prototype.qc = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qa));
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.qb = function (a) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.p0));
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.p7 = function (a) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qa));
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.p6 = function (a) {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.p0));
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.po = function (a) {
        if (a == null) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.p0 = function (a, b) {
        if (this.po(a)) {
            this.p2(a, b.animate);
        }
    };
    AnnotationLayer.prototype.pp = function (a) {
        if (a == null) {
            return false;
        }
        if (a.c6) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.qa = function (a, b) {
        if (this.pp(a)) {
            this.p3(a, b.animate);
        }
    };
    AnnotationLayer.prototype.p2 = function (a, b) {
    };
    AnnotationLayer.prototype.p3 = function (a, b) {
    };
    AnnotationLayer.prototype.p9 = function (a, b) {
        this.p4(b);
    };
    AnnotationLayer.prototype.pz = function (a, b) {
        this.p1(b);
    };
    AnnotationLayer.prototype.qh = function () {
        if (this.of != null) {
            return this.of;
        }
        return this.oj;
    };
    AnnotationLayer.prototype.qi = function () {
        if (this.oi != null) {
            return this.oi;
        }
        return this.oo;
    };
    AnnotationLayer.prototype.p1 = function (a) {
        var e_5, _a, e_6, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.p0));
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.p0));
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.p4 = function (a) {
        var e_7, _a, e_8, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qa));
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qa));
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.mn = function (a, b) {
        this.l0(false);
    };
    AnnotationLayer.prototype.mm = function (a, b) {
        this.l0(true);
    };
    AnnotationLayer.prototype.l1 = function (a) {
        _super.prototype.l1.call(this, a);
        if (this.ct(this.bx)) {
            return;
        }
        if (this.ei(a) && !this.em) {
            var b = this.pk;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                this.pk = this.pl;
                this.pl = b;
            }
            else {
                this.pk = this.pj;
                this.pj = b;
            }
            this.p5(this.pj, this.bx);
            this.l8();
        }
        else {
            if (!this.em) {
                this.p5(this.pj, this.bx);
            }
            this.p8(this.pj, this.bx);
        }
    };
    AnnotationLayer.prototype.get_c6 = function () {
        return true;
    };
    AnnotationLayer.prototype.p5 = function (a, b) {
    };
    AnnotationLayer.prototype.p8 = function (a, b) {
        this.pi.b1();
    };
    AnnotationLayer.prototype.py = function (a) {
        var b = { $type: Point_$type, x: this.qj.x, y: this.qj.y };
        if (a.isVertical) {
            if (isNaN_(this.qj.y)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.qj.x)) {
                b.x = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        else {
            if (isNaN_(this.qj.x)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.qj.y)) {
                b.y = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        return new Tuple$2(Boolean_$type, Point_$type, true, b);
    };
    AnnotationLayer.prototype.lb = function (a) {
        _super.prototype.lb.call(this, a);
        if (isNaN_(this.ql.x) && isNaN_(this.ql.y)) {
            if (isNaN_(a.x) && isNaN_(a.y)) {
                this.pi.b0();
                return;
            }
            else {
                this.pi.b2();
                this.qj = a;
            }
        }
        else {
            this.pi.b2();
            this.qj = this.ql;
        }
        this.l0(true);
    };
    AnnotationLayer.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        if (!this.bx.t()) {
            d = false;
            return d;
        }
        return d;
    };
    AnnotationLayer.prototype.get_ez = function () {
        return this.pr;
    };
    Object.defineProperty(AnnotationLayer.prototype, "pr", {
        get: function () {
            return this.pm;
        },
        set: function (a) {
            var b = this.pm;
            this.pm = a;
            this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.pm);
        },
        enumerable: false,
        configurable: true
    });
    AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
    AnnotationLayer.$$p = markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:qk:qd', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:pn:qe', [0, true], 'UseIndex:ps:qf', [0, false], 'UseLegend:pt:qg', [0, false]]);
    return AnnotationLayer;
}(Series));
export { AnnotationLayer };
/**
 * @hidden
 */
var AnnotationLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayerView, _super);
    function AnnotationLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.bx = null;
        _this.by = false;
        _this.bz = -1;
        _this.bx = a;
        return _this;
    }
    AnnotationLayerView.prototype.b3 = function () {
        if (this.by) {
            this.by = false;
            this.bz = -1;
            this.bx.qj = { $type: Point_$type, x: NaN, y: NaN };
            this.bx.l0(true);
        }
    };
    AnnotationLayerView.prototype.b0 = function () {
        this.by = true;
        if (this.e.gw != null) {
            this.e.gw.setTimeout(runOn(this, this.b3), 300);
        }
        else {
            this.bz = window.setTimeout(runOn(this, this.b3), 300);
        }
    };
    AnnotationLayerView.prototype.b2 = function () {
        if (this.by == true) {
            this.by = false;
            if (this.bz != -1) {
                window.clearTimeout(this.bz);
                this.bz = -1;
            }
        }
    };
    AnnotationLayerView.prototype.b1 = function () {
        this.aq();
    };
    AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
    return AnnotationLayerView;
}(SeriesView));
export { AnnotationLayerView };
//# sourceMappingURL=AnnotationLayer_combined.js.map
