/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { VerticalAnchoredCategorySeries } from "./VerticalAnchoredCategorySeries";
import { IBarSeries_$type } from "./IBarSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { typeCast, fromEnum, runOn, markType, markDep } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { List$1 } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { BarFramePreparer } from "./BarFramePreparer";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { BarTrendLineManager } from "./BarTrendLineManager";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarSeries, _super);
    function BarSeries() {
        var _this = _super.call(this) || this;
        _this.ab = BarSeries.$;
        _this.q8 = new BarFramePreparer(1, _this, _this.t7, _this, _this, _this.t7.cr);
        return _this;
    }
    BarSeries.prototype.get_c9 = function () {
        return true;
    };
    BarSeries.prototype.get_dw = function () {
        return true;
    };
    BarSeries.prototype.bu = function () {
        return new BarSeriesView(this);
    };
    BarSeries.prototype.rd = function () {
        return 1;
    };
    BarSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.t7 = a;
    };
    BarSeries.prototype.get_cy = function () {
        return true;
    };
    BarSeries.prototype.pb = function (a) {
        if (this.xAxis == null || this.yAxis == null || this.q3.f.count == 0) {
            return Rect.empty;
        }
        var b = this.bx.bv;
        var c = this.bx.bu;
        var d = this.getEffectiveViewport1(this.bx);
        var e = new ScalerParams(0, b, c, this.xAxis.cc, d);
        var f = this.ox(a);
        var g = this.g6(a, true);
        var h = this.g4(a, true);
        var i = truncate(Math.floor(g / this.r3(this.bx)));
        var j = truncate(Math.floor(h / this.r3(this.bx)));
        var k = i - this.r4(this.bx);
        var l = j - this.r4(this.bx);
        if (k < 0) {
            k = 0;
        }
        if (k > this.q3.f.count - 1) {
            k = this.q3.f.count - 1;
        }
        if (l < 0) {
            l = 0;
        }
        if (l > this.q3.f.count - 1) {
            l = this.q3.f.count - 1;
        }
        var m = this.q3.f._inner[k];
        var n = this.q3.f._inner[l];
        var o = Math.abs(f.y - m[0]);
        var p = Math.abs(f.y - n[0]);
        var q = this.s4(this.rc);
        var r = this.yAxis.ki(b, c, d);
        if (o < p) {
            var s = m[0] - 0.5 * r;
            var t = m[1];
            var u = q;
            return new Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
        }
        else {
            var v = n[0] - 0.5 * r;
            var w = n[1];
            var x = q;
            return new Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
        }
    };
    BarSeries.prototype.ep = function (a, b) {
        if (this.es(a, b)) {
            return true;
        }
        if (this.pu(a, b)) {
            return true;
        }
        return false;
    };
    BarSeries.prototype.q9 = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.q) {
            if (b.p) {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
            }
            else {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.ca.cf.o, this, b.cr);
            }
        }
        else {
            return this.q8;
        }
    };
    BarSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    BarSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    BarSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = typeCast(BarSeriesView.$, b);
        if (a && c != null && c.db != null) {
            c.db.count = 0;
        }
    };
    BarSeries.prototype.r6 = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(IBarSeries_$type, b);
                if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    BarSeries.prototype.s4 = function (a) {
        var b = 0;
        var c = a.bv;
        var d = a.bu;
        var e = this.getEffectiveViewport1(a);
        if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
            var f = new ScalerParams(0, c, d, this.xAxis.cc, e);
            b = this.xAxis.d8(this.xAxis.k5, f);
        }
        return b;
    };
    BarSeries.prototype.ap = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.xAxis) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    BarSeries.prototype.eh = function (a) {
        var b = this.bx.bv;
        b = b.copy();
        var c = this.bx.bu;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
        var f = this.o9(this.bx);
        var g = new ScalerParams(0, d, d, this.xAxis.cc, f);
        var h = new ScalerParams(0, d, d, this.yAxis.cc, f);
        var i = this.yAxis != null ? this.yAxis.d8(e, h) : NaN;
        var j = this.yAxis != null ? this.q8.r(this.yAxis, d, d, f) : 0;
        i += j;
        var k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.d8(this.valueColumn.item(e), g) : NaN;
        if (!isNaN_(k)) {
            if (k < b.left + 0.1 * b.width) {
                k = k + 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
            if (k > b.right - 0.1 * b.width) {
                k = k - 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
        }
        if (!isNaN_(i)) {
            if (i < b.top + 0.1 * b.height) {
                i = i + 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
            if (i > b.bottom - 0.1 * b.height) {
                i = i - 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
        }
        if (this.b5 != null) {
            this.b5.ap(this.ca, b, true);
        }
        return e >= 0;
    };
    BarSeries.prototype.f1 = function () {
        return this.yAxis.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
    };
    BarSeries.prototype.sl = function (a, b) {
        _super.prototype.sl.call(this, a, b);
        var c = a.f;
        if (!b.o()) {
            return;
        }
        var d = b.bv;
        var e = b.bu;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.xAxis.cc, f);
        var h = this.yAxis;
        var i = new ScalerParams(0, d, e, this.yAxis.cc, f);
        var j = this.xAxis;
        var k = j.d8(j.k5, g);
        var l = this.yAxis.ki(d, e, f);
        var m = typeCast(BarSeriesView.$, b);
        if (isNaN_(l) || isInfinity(l) || isNaN_(k)) {
            m.db.count = 0;
            return;
        }
        this.rb.a0(this, this.rv(), runOn(this, this.qw), this.r3(b), this.r4(b));
        this.rb.r = this.t8;
        this.rb.s = this.t9;
        this.rb.k = this.t8;
        this.rb.l = this.t9;
        var n = false;
        var o = this.rb.b;
        if (o != null) {
            n = true;
        }
        var p = this.xAxis.ch;
        var q = this.valueColumn.count;
        for (var r = 0; r < c.count; ++r) {
            var s = c._inner[r][0] - 0.5 * l;
            var t = c._inner[r][1];
            var u = k;
            u = Math.max(u, -100);
            t = Math.min(t, e.right + 100);
            var v = m.db.item(r);
            v.height = l;
            v.width = Math.abs(t - u);
            if (n) {
                this.sh(c, r, q, h, i, b.q);
            }
            this.rb.ad(v, false, false, false, false);
            v.am = this.rb.k;
            v.an = this.rb.l;
            m.dg(v, Math.min(t, u), s);
        }
        m.db.count = c.count;
        b.cy(a);
    };
    BarSeries.prototype.kk = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.sv.cr.g(this.gh);
                break;
        }
        if (this.sv.c3) {
            this.sv.c2.g$e(a, b, c, d);
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cv()) {
                    this.l0(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cv()) {
                    this.l0(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cv()) {
                    this.l0(true);
                }
                break;
            case 2:
                if (this.tb != null && this.sv.cr.d > 0) {
                    this.l0(true);
                }
                break;
            case 3:
                if (d == this.tb) {
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                }
                break;
        }
    };
    BarSeries.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.cn(this);
                }
                this.sv.cr.g(this.gh);
                if (this.xAxis != null && this.xAxis.cv()) {
                    this.l0(false);
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.cn(this);
                }
                if (this.sv.c3) {
                    this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.yAxis, this.mr, this, this.ck);
                }
                this.sv.cr.g(this.gh);
                this.l0(false);
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cv()) {
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                }
                break;
            case "ValueColumn":
                if (this.xAxis != null && !this.xAxis.cv()) {
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.kl(this.xAxis);
                    this.kl(this.yAxis);
                }
                if (c == null && d != null) {
                    this.lr(this.xAxis);
                    this.lr(this.yAxis);
                }
                this.sv.cr.g(this.gh);
                this.l0(false);
                break;
        }
    };
    BarSeries.prototype.getPreferredCategoryMode = function () {
        return this.preferredCategoryMode(this.yAxis);
    };
    Object.defineProperty(BarSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    BarSeries.$t = markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IBarSeries_$type]);
    BarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:t8:uc', [1, 0], 'RadiusY:t9:ud', [1, 0]]);
    return BarSeries;
}(VerticalAnchoredCategorySeries));
export { BarSeries };
/**
 * @hidden
 */
var BarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarBucketCalculator, _super);
    function BarBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    BarBucketCalculator.prototype.g = function (a) {
        var b = this.c.bv;
        var c = this.c.bu;
        var d = this.c.ct.ch;
        if (b.isEmpty || c.isEmpty || this.i.da.yAxis == null || d == null || d.count == 0) {
            this.d = 0;
            return;
        }
        var e = typeCast(BarSeries.$, this.c.ct);
        var f = e.o7(this.c);
        var g = e.getEffectiveViewport1(this.c);
        var h = new ScalerParams(0, b, c, e.yAxis.cc, g);
        var i = Math.floor(e.yAxis.ec(f.top, h, 0));
        var j = Math.ceil(e.yAxis.ec(f.bottom, h, 0));
        if (!e.yAxis.cc) {
            j = Math.ceil(e.yAxis.ec(f.top, h, 0));
            i = Math.floor(e.yAxis.ec(f.bottom, h, 0));
        }
        var k = Math.floor((j - i + 1) * a / f.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    };
    BarBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            Math.max(h, k);
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    BarBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = NaN;
        var h = NaN;
        for (var i = d; i <= e; ++i) {
            var j = b[i];
            if (!isNaN_(g)) {
                if (!isNaN_(j)) {
                    g = Math.min(g, j);
                    h = Math.max(h, j);
                }
            }
            else {
                g = j;
                h = j;
            }
        }
        if (!isNaN_(g)) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    BarBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.da.valueColumn.count;
        this.h = this.i.da.valueColumn.asArray();
    };
    BarBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    BarBucketCalculator.$t = markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
    return BarBucketCalculator;
}(CategoryBucketCalculator));
export { BarBucketCalculator };
/**
 * @hidden
 */
var BarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarSeriesView, _super);
    function BarSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.db = null;
        _this.dc = null;
        _this.dh = new Rectangle();
        _this.da = a;
        _this.db = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.di);
            $ret.activate = runOn(_this, _this.dd);
            $ret.disactivate = runOn(_this, _this.df);
            $ret.destroy = runOn(_this, _this.de);
            return $ret;
        })());
        _this.c2 = new BarTrendLineManager();
        return _this;
    }
    BarSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        this.dc = new List$1(Rectangle.$, 0);
        if (!this.q) {
            this.da.pr = Defaults.c;
            this.da.gh = Defaults.h;
            this.da.gm = Defaults.i;
        }
    };
    BarSeriesView.prototype.di = function () {
        var a = new Rectangle();
        this.dc.add(a);
        a._visibility = 1;
        return a;
    };
    BarSeriesView.prototype.dd = function (a) {
        a._visibility = 0;
    };
    BarSeriesView.prototype.df = function (a) {
        a._visibility = 1;
    };
    BarSeriesView.prototype.de = function (a) {
        this.dc.remove(a);
    };
    BarSeriesView.prototype.dg = function (a, b, c) {
        if (!this.isDirty) {
            this.aq();
        }
        a.o = c;
        a.n = b;
    };
    BarSeriesView.prototype.cs = function () {
        return new BarBucketCalculator(this);
    };
    BarSeriesView.prototype.bf = function (a, b) {
        _super.prototype.bf.call(this, a, b);
        var c = a;
        var d = this.bp(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.fl;
    };
    BarSeriesView.prototype.ac = function (a) {
        return this.dc._inner[a];
    };
    BarSeriesView.prototype.ab = function (a) {
        var b = this.dc._inner[a];
        this.dh.n = b.n;
        this.dh.o = b.o;
        this.dh.width = b.width;
        this.dh.height = b.height;
        var c = this.bp(a);
        this.dh._fill = c;
        this.dh._stroke = c;
        this.dh.ac = this.e.fl + 3;
        return this.dh;
    };
    BarSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.dc.count; c++) {
                var d = this.aa(c, b);
                this.bd(d, c, b);
                a.v(d);
            }
        }
    };
    BarSeriesView.prototype.al = function (a) {
        var e_2, _a, e_3, _b;
        _super.prototype.al.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.db.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.aa(function (e, f) {
            if (e.o > f.o) {
                return -1;
            }
            else if (e.o < f.o) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        b++;
    };
    BarSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.or = a;
        this.e.gj = 5;
        this.e.gk = 5;
        this.e.gl = -5;
    };
    BarSeriesView.$t = markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);
    return BarSeriesView;
}(AnchoredCategorySeriesView));
export { BarSeriesView };
//# sourceMappingURL=BarSeries_combined.js.map
