/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-angular-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
var FinancialIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicator, _super);
    function FinancialIndicator() {
        var _this = _super.call(this) || this;
        _this._indicatorColumn = null;
        _this.s0 = null;
        _this.pu = new CategoryFrame(3);
        _this.pw = new CategoryFrame(3);
        _this.ps = new CategoryFrame(3);
        _this.indicatorColumn = new List$1(Number_$type, 0);
        _this.s0 = new AxisRange(-100, 100);
        return _this;
    }
    FinancialIndicator.prototype.get_dj = function () {
        return true;
    };
    FinancialIndicator.prototype.bu = function () {
        return new FinancialIndicatorView(this);
    };
    FinancialIndicator.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.s1 = a;
    };
    FinancialIndicator.prototype.te = function (a) {
        if (this.qc != null && !this.qc.cv()) {
            this.l0(true);
        }
    };
    FinancialIndicator.prototype.s6 = function (a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        var d = this.qc;
        var e = 0;
        if (d != null) {
            e = d.en(d.k5);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.bo = function () {
        if (this.bp == 0) {
            return 1;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    FinancialIndicator.prototype.pb = function (a) {
        if (this.pq == null || this.qc == null) {
            return Rect.empty;
        }
        var b = this.ox(a);
        var c = this.bx.bv;
        var d = this.bx.bu;
        var e = this.getEffectiveViewport1(this.bx);
        var f = new ScalerParams(0, c, d, this.qc.cc, e);
        f.b = this.f2();
        var g = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.qc.d8(this.qc.k5, f);
        var m = 1;
        if (j < k) {
            var n = h[0] - 0.5 * m;
            var o = h[1];
            var p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            var q = i[0] - 0.5 * m;
            var r = i[1];
            var s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    };
    FinancialIndicator.prototype.ep = function (a, b) {
        var c = this.o2(this.o5(a), true, false);
        if (this.s3 == 1) {
            if (this.s6(a, c, b)) {
                return true;
            }
        }
        if (this.s3 == 1 || this.s3 == 0) {
            if (this.eo(a, b)) {
                return true;
            }
        }
        if (this.s3 == 2) {
            if (this.es(a, b)) {
                return true;
            }
        }
        return false;
    };
    FinancialIndicator.prototype.kk = function (a, b, c, d) {
        _super.prototype.kk.call(this, a, b, c, d);
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            this.pq.i$i();
        }
        if (this.s1.b7) {
            this.s1.b5.g$e(a, b, c, d);
        }
        if (d != null && this.q2.containsKey(d)) {
            var e = this.q2.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            a = 4;
            b = 0;
            c = this.ch.count;
        }
        switch (a) {
            case 3:
                if (this.s5(b, c, d)) {
                    this.tg(b, c, d);
                    this.te(true);
                }
                break;
            case 2:
                if (this.s5(b, this.ch.count - b, d)) {
                    this.tg(b, this.ch.count - b, d);
                    this.te(true);
                }
                break;
            case 1:
                if (this.s5(b, this.ch.count - b, d)) {
                    var f = new Array(c);
                    for (var g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.tg(b, this.ch.count - b, d);
                    this.te(true);
                }
                break;
            case 0:
                if (this.s5(b, this.ch.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.tg(b, this.ch.count - b, d);
                    this.te(true);
                }
                break;
            case 4:
                if (this.s5(b, this.ch.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.ch.count);
                    var h = new Array(c);
                    for (var i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.tg(b, this.ch.count - b, d);
                    this.te(true);
                }
                break;
        }
    };
    FinancialIndicator.prototype.get_s2 = function () {
        return 0;
    };
    Object.defineProperty(FinancialIndicator.prototype, "s2", {
        get: function () {
            return this.get_s2();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialIndicator.prototype, "tr", {
        get: function () {
            return this.c(FinancialIndicator.th);
        },
        set: function (a) {
            this.h(FinancialIndicator.th, a);
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicator.prototype.tb = function () {
        return -1;
    };
    Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicator.prototype.lm = function (a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.s1.cd();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.s1.b5 = CategoryTrendLineManagerFactory.a(this.s1.b5, this.pq, this.mr, this, this.ck);
                }
                break;
        }
        _super.prototype.lm.call(this, a, b, c, d);
        if (this.s1.b7 && this.s1.b5.g$b(a, b, c, d)) {
            this.l0(false);
            var f = typeCast(FinancialIndicatorView.$, this.bw);
            if (f != null && f.b7) {
                f.b5.g$b(a, b, c, d);
            }
            this.k7();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.ch != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.ch.count);
                    var g = new Array(this.ch.count);
                    for (var h = 0; h < this.ch.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.tg(0, this.ch.count, null);
                    if (this.qc != null && !this.qc.cv()) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.md();
                break;
            case FinancialIndicator.$$p[0]:
                this.kh(true, this.bx);
                this.me();
                this.l0(false);
                this.k7();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.ch != null) {
                    if (this.indicatorColumn.count != this.ch.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.ch.count);
                        var i = new Array(this.ch.count);
                        for (var j = 0; j < this.ch.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.s5(0, this.ch.count - 1, b)) {
                        this.tf();
                    }
                }
                break;
            case "XAxis":
                if (this.pq != null && (typeCast(ISortingAxis_$type, this.pq) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.tf();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.tf();
                this.k7();
                break;
            case "TrendLineType":
                this.k7();
                break;
        }
    };
    FinancialIndicator.prototype.f8 = function (a, b, c) {
        if (this.indicatorColumn == null) {
            return _super.prototype.f8.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        f.c = this.ca.pv;
        return this.ga(this.indicatorColumn, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialIndicator.prototype.g6 = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.g6.call(this, a, b);
        }
        return this.g7(a, b, this.pq, runOn(this, this.rg), this.indicatorColumn);
    };
    FinancialIndicator.prototype.g4 = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.g4.call(this, a, b);
        }
        return this.g5(a, b, this.pq, runOn(this, this.rg), this.indicatorColumn);
    };
    FinancialIndicator.prototype.get_e2 = function () {
        return true;
    };
    FinancialIndicator.prototype.s5 = function (a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.s7(a, b).contains(c)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.tg = function (a, b, c) {
        this.s4(a, b);
    };
    FinancialIndicator.prototype.ap = function (a) {
        if (this.ch == null) {
            return null;
        }
        if (a != null && a == this.qc) {
            return this.s0;
        }
        return null;
    };
    FinancialIndicator.prototype.eh = function (a) {
        var b = this.ch != null ? this.ch.indexOf(a) : -1;
        var c = this.bx.bv;
        c = c.copy();
        var d = this.bx.bu;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.o9(this.bx);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.pq != null) {
                var g = new ScalerParams(0, e, e, this.pq.cc, f);
                var h = this.pq.d8(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.qc != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                var i = new ScalerParams(0, e, e, this.qc.cc, f);
                i.b = this.f2();
                var j = this.qc.d8(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.b5.ap(this.ca, c, true);
        }
        return b >= 0;
    };
    FinancialIndicator.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    };
    FinancialIndicator.prototype.sh = function (a, b) {
        var _this = this;
        _super.prototype.sh.call(this, a, b);
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pq;
        var g = this.qc;
        var h = new ScalerParams(0, c, d, f.cc, e);
        var i = new ScalerParams(0, c, d, g.cc, e);
        i.b = this.f2();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.pq);
        if (k != null && k.i$b.count != this.ch.count) {
            return;
        }
        j = this.rh(c, d, e);
        var l = this.tb();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        var m = typeCast(FinancialIndicatorView.$, b);
        if (m.b7) {
            m.b5.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, function (n) { return _this.pq.d8(n, h); }, function (n) { return _this.qc.d8(n, i); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.bx.b;
                $ret.d = b.bx.c;
                $ret.e = b.bx.d;
                $ret.a = j;
                $ret.b = _this.gh;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        var n = this.pq.eb(2, h) - this.pq.eb(1, h);
        for (var o = b.bx.c; o <= b.bx.d; ++o) {
            var p = void 0;
            if (k == null) {
                p = b.bx.getBucket(o);
            }
            else {
                var q = k.i$b._inner[o];
                var r = k.i$d(q);
                var s = this.indicatorColumn._inner[o];
                var t = s;
                var u = r;
                while (o < b.bx.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    var v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                var w = NaN;
                if (!isNaN_(r)) {
                    w = this.pq.d8(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.d8(p[0], h) + j;
                }
                p[1] = g.d8(p[1], i);
                if (b.bx.b > 1 || k != null) {
                    p[2] = g.d8(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    };
    FinancialIndicator.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = b;
        c.b8(a);
        if (c.b7) {
            c.b5.g$d();
        }
    };
    FinancialIndicator.prototype.p0 = function () {
        switch (this.s3) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    };
    FinancialIndicator.prototype.sj = function (a, b) {
        _super.prototype.sj.call(this, a, b);
        var c = typeCast(FinancialIndicatorView.$, b);
        var d = function (e) { return a.f._inner[e][0]; };
        var e = function (f) { return a.f._inner[f][1]; };
        if (c.b7) {
            c.b5.g$d();
            c.b5.g$g(a.p);
        }
        var f = b.bu;
        var g = this.getEffectiveViewport1(b);
        var h = 0;
        var i = this.of;
        var j = this.sw;
        if (b.b0(a)) {
            c.b8(false);
            if (a.f.count > 0) {
                switch (this.s3) {
                    case 0:
                        var k = CategorySeries.qx(a.f, a.f.count - 1, f, b.bv, false);
                        c.cc(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.qc != null) {
                            h = this.rl(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        var l = CategorySeries.qx(a.f, a.f.count - 1, f, b.bv, false);
                        c.ca(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.rl(b);
                        c.cb(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.b2(a);
        }
        var m = a.f;
        var n = this.ch.count;
        this.pz.a0(this, this.qy(), runOn(this, this.pi), this.rn(b), this.rp(b));
        var o = false;
        var p = this.pz.b;
        if (p != null) {
            o = true;
        }
        this.pz.ak = i;
        this.pz.ag = i;
        if (o) {
            var q = new ScalerParams(0, b.bv, b.bu, this.pq.cc, g);
            this.pz.f = false;
            this.sg(m, -1, n, this.pq, q, b.q);
        }
        this.pz.ad(c.cu, true, false, true, false);
        this.pz.ad(c.cw, true, false, true, false);
        this.pz.ad(c.cv, false, true, false, false);
        c.cv._opacity = 0.8 * this.pz.j * this.fi;
        this.pz.ad(c.ct, true, false, false, false);
        this.pz.ak = j;
        this.pz.ag = j;
        if (o) {
            var r = new ScalerParams(0, b.bv, b.bu, this.pq.cc, g);
            this.pz.f = true;
            this.sg(m, -1, n, this.pq, r, b.q);
        }
        this.pz.ad(c.cq, true, false, true, false);
        this.pz.ad(c.cs, true, false, true, false);
        this.pz.ad(c.cr, false, true, false, false);
        c.cr._opacity = 0.8 * this.pz.j * this.fi;
        this.pz.ad(c.cp, true, false, false, false);
        c.ce();
    };
    FinancialIndicator.prototype.md = function () {
        _super.prototype.md.call(this);
        if (this.g9 < 0) {
            return;
        }
        if (this.s1.b7) {
            this.s1.cf();
        }
    };
    FinancialIndicator.prototype.tf = function () {
        if (this.s1.b7) {
            this.s1.b5.g$i();
        }
        this.s4(0, this.indicatorColumn.count);
        if (this.qc != null && !this.qc.cv()) {
            this.l0(false);
        }
    };
    FinancialIndicator.prototype.kr = function (a) {
        _super.prototype.kr.call(this, a);
        this.a6.exportTrendlineData(this, a, this.s1.b5.g$j);
    };
    FinancialIndicator.prototype.a8 = function (a) {
        if (this.s3 == 1 || this.s3 == 2) {
            return 3;
        }
        else if (this.s3 == 0) {
            return 2;
        }
        return a;
    };
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.th = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:s3:ti', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:s9:tj', [1, 0], 'TrendLineType::tp', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::to', [1, 1.5], 'TrendLinePeriod::tn', [1, 7], 'TrendLineBrush::tk', [Brush.$, null], 'TrendLineZIndex:ta:tq', [1, 1001], 'TrendLineDashArray:ts:tl', [DoubleCollection.$], 'TrendLineDashCap:tt:tm', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
}(FinancialSeries));
export { FinancialIndicator };
/**
 * @hidden
 */
var FinancialIndicatorBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorBucketCalculator, _super);
    function FinancialIndicatorBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.f.b3.indicatorColumn.count - 1);
        var d = NaN;
        var e = NaN;
        for (var f = b; f <= c; ++f) {
            var g = this.f.b3.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    };
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
}(FinancialBucketCalculator));
export { FinancialIndicatorBucketCalculator };
/**
 * @hidden
 */
var FinancialIndicatorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorView, _super);
    function FinancialIndicatorView(a) {
        var _this = _super.call(this, a) || this;
        _this.b3 = null;
        _this.b6 = null;
        _this.cu = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cq = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cv = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cr = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cw = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cs = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.ct = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.cp = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.b4 = null;
        _this.cm = new Path();
        _this.co = new Path();
        _this.cn = new Path();
        _this.cl = new Path();
        _this.ci = new Path();
        _this.ck = new Path();
        _this.cj = new Path();
        _this.ch = new Path();
        _this.b3 = a;
        _this.b6 = ((function () {
            var $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(_this, _this.cg);
            $ret.destroy = runOn(_this, _this.b9);
            return $ret;
        })());
        return _this;
    }
    FinancialIndicatorView.prototype.by = function () {
        return new FinancialIndicatorBucketCalculator(this);
    };
    FinancialIndicatorView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.b3.sw = Defaults.ah;
            this.b3.s3 = this.b3.s2;
        }
    };
    FinancialIndicatorView.prototype.cg = function () {
        return new LineGeometry();
    };
    FinancialIndicatorView.prototype.b9 = function (a) {
    };
    Object.defineProperty(FinancialIndicatorView.prototype, "b5", {
        get: function () {
            if (this.b4 == null) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
            return this.b4;
        },
        set: function (a) {
            this.b4 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialIndicatorView.prototype, "b7", {
        get: function () {
            return this.b4 != null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicatorView.prototype.b8 = function (a) {
        Extensions.e(this.cu.ak);
        Extensions.e(this.cv.ak);
        Extensions.e(this.cw.ak);
        Extensions.e(this.cq.ak);
        Extensions.e(this.cr.ak);
        Extensions.e(this.cs.ak);
        Extensions.d(this.ct.ak);
        Extensions.d(this.cp.ak);
        if (a) {
            this.b6.count = 0;
        }
        this.aq();
    };
    FinancialIndicatorView.prototype.ce = function () {
    };
    FinancialIndicatorView.prototype.cc = function (a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bv, this.bu, this.cu, this.cq, this.bx.b, this.e.gh, e);
        this.aq();
    };
    FinancialIndicatorView.prototype.ca = function (a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bv, this.bu, this.cu, this.cv, this.cq, this.cr, e, this.bx.b, this.e.gh, f);
        this.aq();
    };
    FinancialIndicatorView.prototype.cb = function (a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.bu, e, this.b6, this.ct, this.cp);
        this.aq();
    };
    FinancialIndicatorView.prototype.cf = function () {
        this.b3.tr = null;
        if (this.b3.trendLineBrush != null) {
            this.b3.tr = this.b3.trendLineBrush;
        }
        else {
            this.b3.tr = this.b3.of;
        }
    };
    FinancialIndicatorView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        var a = this.bo();
        this.cm.ak = this.cu.ak;
        this.co.ak = this.cw.ak;
        this.cn.ak = this.cv.ak;
        this.cl.ak = this.ct.ak;
        this.ci.ak = this.cq.ak;
        this.ck.ak = this.cs.ak;
        this.cj.ak = this.cr.ak;
        this.ch.ak = this.cp.ak;
        this.cm._stroke = a;
        this.co._stroke = a;
        this.cm.ac = this.e.fl + 3;
        this.co.ac = this.e.fl + 3;
        this.cn._fill = a;
        this.cn._opacity = 1;
        this.cl._stroke = a;
        this.cl.ac = this.e.fl + 3;
        this.ci._stroke = a;
        this.ck._stroke = a;
        this.ci.ac = this.e.fl + 3;
        this.ck.ac = this.e.fl + 3;
        this.cj._fill = a;
        this.cj._opacity = 1;
        this.ch._stroke = a;
        this.ch.ac = this.e.fl + 3;
    };
    FinancialIndicatorView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (b) {
                if (this.b3.s3 == 2) {
                    a.s(this.cl);
                    a.s(this.ch);
                }
                else {
                    a.s(this.cn);
                    a.s(this.cm);
                    a.s(this.co);
                    a.s(this.cj);
                    a.s(this.ci);
                    a.s(this.ck);
                }
            }
            else {
                if (this.b3.s3 == 2) {
                    a.s(this.ct);
                    a.s(this.cp);
                }
                else {
                    a.s(this.cv);
                    a.s(this.cu);
                    a.s(this.cw);
                    a.s(this.cr);
                    a.s(this.cq);
                    a.s(this.cs);
                }
            }
        }
    };
    FinancialIndicatorView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (this.b3.trendLineType != 0 && !b) {
                var c = this.b5.g$j;
                c.ac = this.b3.trendLineThickness;
                c._stroke = this.b3.tr;
                c.ad = this.b3.tt;
                c.ai = this.b3.ts;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    FinancialIndicatorView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a6.exportPathData(a, this.ct, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a6.exportPathData(a, this.cp, "negativeColumnsShape", ["Negative"]);
        this.e.a6.exportPathData(a, this.cu, "positive0", ["Positive", "Main"]);
        this.e.a6.exportPathData(a, this.cw, "positive1", ["Positive"]);
        this.e.a6.exportPathData(a, this.cv, "positive01", ["PositiveFill"]);
        this.e.a6.exportPathData(a, this.cq, "negative0", ["Negative", "Main"]);
        this.e.a6.exportPathData(a, this.cs, "negative1", ["Negative"]);
        this.e.a6.exportPathData(a, this.cr, "negative01", ["NegativeFill"]);
    };
    FinancialIndicatorView.prototype.cd = function () {
        if (this.b7) {
            this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
        }
    };
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
}(FinancialSeriesView));
export { FinancialIndicatorView };
//# sourceMappingURL=FinancialIndicator_combined.js.map
