/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "igniteui-angular-core";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { typeCast, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Defaults } from "./Defaults";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineSeries, _super);
    function LineSeries() {
        var _this = _super.call(this) || this;
        _this.uf = null;
        _this.uf = new CategoryLineRasterizer();
        _this.ab = LineSeries.$;
        _this.tz = 0;
        return _this;
    }
    LineSeries.prototype.get_dv = function () {
        return true;
    };
    LineSeries.prototype.bu = function () {
        return new LineSeriesView(this);
    };
    LineSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.ug = a;
    };
    LineSeries.prototype.get_c8 = function () {
        return true;
    };
    LineSeries.prototype.preferredCategoryMode = function (a) {
        return this.tz;
    };
    LineSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = b;
        c.db();
    };
    LineSeries.prototype.sl = function (a, b) {
        _super.prototype.sl.call(this, a, b);
        var c = b.cr.d;
        var d = typeCast(LineSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.rb.a0(this, this.rv(), runOn(this, this.qw), this.r3(b), this.r4(b));
        var g = false;
        var h = this.rb.b;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bv, b.bu, this.tw.cc, f);
            this.sh(e, -1, this.valueColumn.count, this.tw, i, b.q);
        }
        var j = d.dh;
        var k = d.di;
        var l = d.dg;
        this.rb.ad(j, true, false, true, false);
        this.rb.ad(k, true, false, true, false);
        this.rb.ad(l, false, true, false, false);
        l._opacity = 0.75 * this.rb.j;
        if (b.cv(a)) {
            d.dc(e.count, e, true, this.unknownValuePlotting, this.st(e, e.count - 1, b.bu, b.bv), c, this.gh);
            b.cy(a);
        }
    };
    LineSeries.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.q8.m = this.unknownValuePlotting == 0;
                this.l0(false);
                this.k7();
                break;
        }
    };
    Object.defineProperty(LineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    LineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::ui', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return LineSeries;
}(HorizontalAnchoredCategorySeries));
export { LineSeries };
/**
 * @hidden
 */
var LineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineSeriesView, _super);
    function LineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.dk = new Path();
        _this.dj = new Path();
        _this.dl = new Path();
        _this.df = new Path();
        _this.de = new Path();
        _this.dd = new Path();
        _this.da = a;
        return _this;
    }
    LineSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.da.pr = Defaults.e;
        }
    };
    Object.defineProperty(LineSeriesView.prototype, "dh", {
        get: function () {
            return this.dk;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "di", {
        get: function () {
            return this.dl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "dg", {
        get: function () {
            return this.dj;
        },
        enumerable: false,
        configurable: true
    });
    LineSeriesView.prototype.db = function () {
        this.dj.ak = null;
        this.dk.ak = null;
        this.dl.ak = null;
        this.aq();
    };
    LineSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
        this.da.uf.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
        this.da.uf.m(this.dk, this.dj, this.dl, a, b, c, d, e, f, g);
        this.aq();
    };
    LineSeriesView.prototype.bb = function () {
        _super.prototype.bb.call(this);
    };
    LineSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        this.de.ak = this.dk.ak;
        this.df.ak = this.dl.ak;
        this.dd.ak = this.dj.ak;
        var a = this.bo();
        this.de._stroke = a;
        this.de.ac = this.e.fl + 3;
        this.df._stroke = a;
        this.df.ac = this.e.fl + 3;
        this.dd._fill = a;
        this.dd._opacity = 1;
    };
    LineSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
            else {
                a.s(this.dj);
                a.s(this.dk);
                a.s(this.dl);
            }
        }
    };
    LineSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower", "Main"]);
        this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper"]);
        this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
    };
    LineSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.or = a;
        this.e.gj = 3;
        this.e.gk = 1;
        this.e.gl = 4;
        this.e.e1 = false;
    };
    LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
    return LineSeriesView;
}(AnchoredCategorySeriesView));
export { LineSeriesView };
//# sourceMappingURL=LineSeries_combined.js.map
