/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType, TypeRegistrar } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { HorizontalLogarithmicScaler } from "./HorizontalLogarithmicScaler";
import { FastHorizontalLinearScaler } from "./FastHorizontalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
var NumericXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericXAxis, _super);
    function NumericXAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericXAxis.$;
        _this.j6 = _this.j4();
        return _this;
    }
    NumericXAxis.prototype.a3 = function () {
        return new NumericXAxisView(this);
    };
    NumericXAxis.prototype.ha = function (a) {
        _super.prototype.ha.call(this, a);
        this.mm = a;
    };
    NumericXAxis.prototype.au = function () {
        if (this.cz) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    NumericXAxis.prototype.j4 = function () {
        var _this = this;
        var a = _super.prototype.j4.call(this);
        a.b.c = function (b) {
            if ((_this.ay == null || _this.ay.visibility == 0) && _this.ai != null) {
                _this.av.bc = b;
                if (_this.ay != null && (_this.ay.location == 4 || _this.ay.location == 5)) {
                    _this.bh.jq();
                }
            }
        };
        a.k = function (b, c, d) { return _this.h1(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.h2(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.cd, d);
            return _this.d8(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.g8(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = b.z.bottom;
            if (_this.ai != null && _this.ai.bh != null) {
                var c = b.n;
                var d = b.r;
                var e = _this.hv(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    };
    NumericXAxis.prototype.d8 = function (a, b) {
        if (this.l5 != null) {
            return this.l5.p(a, b);
        }
        return this.l4.p(a, b);
    };
    NumericXAxis.prototype.eb = function (a, b) {
        if (this.l5 != null) {
            return this.l5.q(a, b);
        }
        return this.l4.q(a, b);
    };
    NumericXAxis.prototype.g5 = function (a, b, c, d) {
        if (this.l5 != null) {
            this.l5.v(a, b, c, d);
            return;
        }
        this.l4.v(a, b, c, d);
    };
    NumericXAxis.prototype.g4 = function (a, b, c, d, e) {
        if (this.l5 != null) {
            this.l5.u(a, b, c, d, e);
            return;
        }
        this.l4.u(a, b, c, d, e);
    };
    NumericXAxis.prototype.g6 = function (a, b, c, d) {
        if (this.l5 != null) {
            this.l5.j(a, b, c, d);
            return;
        }
        this.l4.j(a, b, c, d);
    };
    NumericXAxis.prototype.mn = function (a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.ma(a, this);
        var d = this.ma(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.pw = new Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
    };
    NumericXAxis.prototype.j7 = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.j7.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.cc, c);
        var h = NaN;
        var i = NaN;
        if (!this.cc && b.right == 1) {
            i = this.ku;
        }
        else if (this.cc && b.left == 0) {
            h = this.ku;
        }
        if (isNaN_(h)) {
            h = this.eb(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.eb(e.right, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.ky = j;
        this.kx = k;
        f.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    };
    NumericXAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = !b.isEmpty ? this.js : Rect.empty;
        var d = this.jn();
        var e = this.jm();
        var f = this.j6.c(a, c, b, d, e);
        if (f != null) {
            this.kt = f.f.m;
            this.kw = f.f.l;
        }
    };
    NumericXAxis.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        if (b.height != a.height) {
            this.cv();
        }
    };
    NumericXAxis.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(NumericXAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    NumericXAxis.prototype.j9 = function () {
        if (this.kk) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.l3) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    };
    NumericXAxis.prototype.j$c = function (a, b) {
        return this.eb.apply(this, arguments);
    };
    NumericXAxis.prototype.j$b = function (a, b) {
        return this.d8.apply(this, arguments);
    };
    NumericXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.g4.apply(this, arguments);
    };
    NumericXAxis.prototype.j$e = function (a, b, c, d) {
        this.g5.apply(this, arguments);
    };
    NumericXAxis.prototype.j$f = function (a, b, c, d) {
        this.g6.apply(this, arguments);
    };
    Object.defineProperty(NumericXAxis.prototype, "j$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericXAxis;
}(StraightNumericAxisBase));
export { NumericXAxis };
/**
 * @hidden
 */
var NumericXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericXAxisView, _super);
    function NumericXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bi = null;
        _this.bi = a;
        return _this;
    }
    NumericXAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.jb = AxisDefaults.h;
    };
    NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
    return NumericXAxisView;
}(StraightNumericAxisBaseView));
export { NumericXAxisView };
//# sourceMappingURL=NumericXAxis_combined.js.map
