/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, typeCast, runOn, markType, markDep } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterSplineSeriesView } from "./ScatterSplineSeriesView";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { PathGeometry } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSplineSeries, _super);
    function ScatterSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterSplineSeries.$;
        _this.rh = new ScatterFrame();
        _this.rj = new ScatterFrame();
        _this.rf = new ScatterFrame();
        return _this;
    }
    ScatterSplineSeries.prototype.get_ea = function () {
        return true;
    };
    ScatterSplineSeries.prototype.bu = function () {
        return new ScatterSplineSeriesView(this);
    };
    ScatterSplineSeries.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.l0(false);
                this.k7();
                break;
        }
    };
    ScatterSplineSeries.prototype.bo = function () {
        if (this.bp == 0) {
            return 2;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    ScatterSplineSeries.prototype.s3 = function (a, b) {
        var _this = this;
        _super.prototype.s3.call(this, a, b);
        a.m.clear();
        a.u.clear();
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.gh * this.gh;
        var g = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
        var h = new ScalerParams(0, c, d, this.rb.d, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, _this.rb.e, e);
            $ret.b = _this.f2();
            return $ret;
        })());
        var j = function (k) { return _this.rb.a.d8(_this.rr.item(k), h); };
        var k = function (l) { return _this.rb.b.d8(_this.rs.item(l), i); };
        var l = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (var m = 0; m < g;) {
            var n = m;
            ++m;
            while (m < g && this.t4(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.sc) {
                l.j(this.t8(j, k, n, m - 1));
            }
            else {
                var o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.ch.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.sc) {
            l.i = null;
        }
    };
    ScatterSplineSeries.prototype.t8 = function (a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        var e = 0;
        var f = 0;
        var g = (d - c + 1);
        for (var h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    };
    ScatterSplineSeries.prototype.t4 = function (a, b, c, d) {
        var e = a(d) - a(c);
        var f = b(d) - b(c);
        return e * e + f * f;
    };
    ScatterSplineSeries.prototype.get_rz = function () {
        return true;
    };
    ScatterSplineSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        c.c4(false);
    };
    ScatterSplineSeries.prototype.te = function (a, b) {
        this.kh(false, b);
        _super.prototype.te.call(this, a, b);
        this.s6(a);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        var d = c.dg;
        this.ro.ax(this, this.r4(), runOn(this, this.qz));
        var e = false;
        var f = this.ro.b;
        if (f != null) {
            e = true;
        }
        if (e) {
            this.sz(-1, this.rr.count, b.q);
        }
        this.ro.ad(d, true, false, true, false);
        c.dg.ak = new PathGeometry();
        c.dg.ak.c = Numeric.h(a.m.count, function (g) { return a.m._inner[g].x; }, function (g) { return a.m._inner[g].y; }, this.t5);
    };
    ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
    ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:t5:t7', [1, 0.5]]);
    return ScatterSplineSeries;
}(ScatterBase));
export { ScatterSplineSeries };
//# sourceMappingURL=ScatterSplineSeries.js.map
