/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, runOn, markType } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Defaults } from "./Defaults";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaSeries, _super);
    function SplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.uz = null;
        _this.uz = new CategoryLineRasterizer();
        _this.ab = SplineAreaSeries.$;
        return _this;
    }
    SplineAreaSeries.prototype.get_c7 = function () {
        return true;
    };
    SplineAreaSeries.prototype.get_ea = function () {
        return true;
    };
    SplineAreaSeries.prototype.bu = function () {
        return new SplineAreaSeriesView(this);
    };
    SplineAreaSeries.prototype.rd = function () {
        return 1;
    };
    SplineAreaSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.u0 = a;
    };
    SplineAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    SplineAreaSeries.prototype.b0 = function () {
        if (this.b1 == 0) {
            return 2;
        }
        return _super.prototype.b0.call(this);
    };
    SplineAreaSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = b;
        c.dc();
    };
    SplineAreaSeries.prototype.ep = function (a, b) {
        var c = this.o2(this.o5(a), true, false);
        if (this.t6(a, c, b)) {
            return true;
        }
        if (this.eo(a, b)) {
            return true;
        }
        if (this.pu(a, b)) {
            return true;
        }
        return false;
    };
    SplineAreaSeries.prototype.sl = function (a, b) {
        var _this = this;
        _super.prototype.sl.call(this, a, b);
        var c = this.rc.cr.d;
        var d = typeCast(SplineAreaSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.rb.a0(this, this.rv(), runOn(this, this.qw), this.r3(b), this.r4(b));
        var g = false;
        var h = this.rb.b;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bv, b.bu, this.tw.cc, f);
            this.sh(e, -1, this.valueColumn.count, this.tw, i, b.q);
        }
        var j = d.dn;
        var k = d.dp;
        var l = d.dq;
        var m = d.dr;
        this.rb.ad(j, true, false, true, true);
        this.rb.ad(k, true, false, true, true);
        this.rb.ad(l, false, true, false, false);
        this.rb.ad(m, false, true, false, false);
        l._opacity = this.rb.j * this.fi;
        m._opacity = 0.5 * this.rb.j * this.fi;
        if (b.cv(a)) {
            d.de(a.f.count, e, true, c, this.gh, function (n, o, p, q, r) { return _this.tg(n, a.f.count, b); }, 1, a.f.count == 1 ? null : this.su(e, e.count - 1, b.bu, b.bv, true));
            b.cy(a);
        }
        var n = this.fetchYAxis();
    };
    Object.defineProperty(SplineAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    SplineAreaSeries.$t = markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
    return SplineAreaSeries;
}(SplineSeriesBase));
export { SplineAreaSeries };
/**
 * @hidden
 */
var SplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaSeriesView, _super);
    function SplineAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.db = null;
        _this.dj = new Path();
        _this.dl = new Path();
        _this.dk = new Path();
        _this.dm = new Path();
        _this.df = new Path();
        _this.dh = new Path();
        _this.dg = new Path();
        _this.di = new Path();
        _this.db = a;
        return _this;
    }
    SplineAreaSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.db.pr = Defaults.e;
        }
    };
    Object.defineProperty(SplineAreaSeriesView.prototype, "dn", {
        get: function () {
            return this.dl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "dp", {
        get: function () {
            return this.dm;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "dq", {
        get: function () {
            return this.dj;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "dr", {
        get: function () {
            return this.dk;
        },
        enumerable: false,
        configurable: true
    });
    SplineAreaSeriesView.prototype.dc = function () {
        this.dj.ak = null;
        this.dk.ak = null;
        this.dl.ak = null;
        this.dm.ak = null;
        this.aq();
    };
    SplineAreaSeriesView.prototype.dd = function (a, b, c, d, e, f, g) {
        this.de(a, b, c, d, e, f, g, null);
    };
    SplineAreaSeriesView.prototype.de = function (a, b, c, d, e, f, g, h) {
        this.db.uz.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
        this.db.uz.j(this.dj, this.dl, this.dk, this.dm, a, b, c, d, e, f, g, h);
        this.aq();
    };
    SplineAreaSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        this.df.ak = this.dj.ak;
        this.dh.ak = this.dl.ak;
        this.dg.ak = this.dk.ak;
        this.di.ak = this.dm.ak;
        var a = this.bo();
        this.df._fill = a;
        this.df._opacity = 1;
        this.dg._fill = a;
        this.dg._opacity = 1;
        this.dh._stroke = a;
        this.dh.ac = this.e.fl + 3;
        this.di._stroke = a;
        this.di.ac = this.e.fl + 3;
    };
    SplineAreaSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (b) {
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
            a.s(this.di);
        }
        else {
            a.s(this.dj);
            a.s(this.dk);
            a.s(this.dl);
            a.s(this.dm);
        }
    };
    SplineAreaSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a6.exportPathData(a, this.dl, "lowerShape", ["Lower"]);
        this.e.a6.exportPathData(a, this.dm, "upperShape", ["Upper", "Main"]);
        this.e.a6.exportPathData(a, this.dk, "translucentShape", ["Translucent"]);
        this.e.a6.exportPathData(a, this.dj, "fillShape", ["Fill"]);
    };
    SplineAreaSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.or = a;
        this.e.gj = 5;
        this.e.gk = 1;
        this.e.gl = -3;
    };
    SplineAreaSeriesView.$t = markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);
    return SplineAreaSeriesView;
}(SplineSeriesBaseView));
export { SplineAreaSeriesView };
//# sourceMappingURL=SplineAreaSeries_combined.js.map
