/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, Array_$type, runOn, markType } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { intDivide, isNaN_ } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var StepLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepLineSeries, _super);
    function StepLineSeries() {
        var _this = _super.call(this) || this;
        _this.uf = null;
        _this.uf = new CategoryLineRasterizer();
        _this.ab = StepLineSeries.$;
        return _this;
    }
    StepLineSeries.prototype.get_dv = function () {
        return true;
    };
    StepLineSeries.prototype.get_eb = function () {
        return true;
    };
    StepLineSeries.prototype.get_dw = function () {
        return true;
    };
    StepLineSeries.prototype.bu = function () {
        return new StepLineSeriesView(this);
    };
    StepLineSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.ug = a;
    };
    StepLineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    StepLineSeries.prototype.preferredCategoryMode = function (a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    };
    StepLineSeries.prototype.get_c8 = function () {
        return true;
    };
    StepLineSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = b;
        c.db();
    };
    StepLineSeries.prototype.bo = function () {
        if (this.bp == 0) {
            return 2;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    StepLineSeries.prototype.f0 = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    };
    StepLineSeries.prototype.uh = function (a, b, c, d, e, f) {
        var g;
        if (b) {
            if (f) {
                g = (a & 1) == 0;
                if (g || (intDivide(a, 2)) + 1 < 0) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                if (c.f.count == (intDivide(a, 2)) + 1) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            g = (a & 1) == 0;
            return c.f._inner[(intDivide(a, 2))][0] + (g ? d : -d);
        }
        if (f) {
            g = (a & 1) == 0;
            if (g || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            if (c.f.count == (intDivide(a, 2)) + 1) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        g = (a & 1) == 0;
        return c.f._inner[(intDivide(a, 2))][0] + (g ? -d : d);
    };
    StepLineSeries.prototype.sl = function (a, b) {
        _super.prototype.sl.call(this, a, b);
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = typeCast(ISortingAxis_$type, this.tw) != null;
        var g = this.tw.cc;
        var h = 0;
        if (this.tw != null) {
            h = 0.5 * this.tw.getCategorySize(c, d, e);
        }
        var i = a.f;
        var j = 2 * i.count;
        var k = new List$1(Array_$type, 2, j);
        if (!this.tw.cc) {
            for (var l = 0; l < j; l++) {
                var m = new Array(4);
                m[0] = this.uh(l, false, a, h, g, f);
                m[1] = a.f._inner[(intDivide(l, 2))][1];
                m[2] = this.uh(l, true, a, h, g, f);
                m[3] = a.f._inner[(intDivide(l, 2))][2];
                k.add(m);
            }
        }
        else {
            for (var n = 0; n < j; n++) {
                var o = new Array(4);
                o[0] = this.uh(n, true, a, h, g, f);
                o[1] = a.f._inner[(intDivide(n, 2))][1];
                o[2] = this.uh(n, true, a, h, g, f);
                o[3] = a.f._inner[(intDivide(n, 2))][2];
                k.add(o);
            }
        }
        var p = typeCast(StepLineSeriesView.$, b);
        var q = p.cr.d;
        this.rb.a0(this, this.rv(), runOn(this, this.qw), this.r3(b), this.r4(b));
        var r = false;
        var s = this.rb.b;
        if (s != null) {
            r = true;
        }
        if (r) {
            var t = new ScalerParams(0, b.bv, b.bu, this.tw.cc, e);
            this.sh(i, -1, this.valueColumn.count, this.tw, t, b.q);
        }
        var u = p.dh;
        var v = p.di;
        var w = p.dg;
        this.rb.ad(u, true, false, true, false);
        this.rb.ad(v, true, false, true, false);
        this.rb.ad(w, false, true, false, false);
        w._opacity = 0.75 * this.rb.j;
        if (b.cv(a)) {
            p.dc(j, k, false, 1, this.st(k, j - 1, b.bu, b.bv), q, this.gh);
            b.cy(a);
        }
    };
    Object.defineProperty(StepLineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    StepLineSeries.$t = markType(StepLineSeries, 'StepLineSeries', HorizontalAnchoredCategorySeries.$);
    return StepLineSeries;
}(HorizontalAnchoredCategorySeries));
export { StepLineSeries };
/**
 * @hidden
 */
var StepLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepLineSeriesView, _super);
    function StepLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.dk = new Path();
        _this.dj = new Path();
        _this.dl = new Path();
        _this.df = new Path();
        _this.de = new Path();
        _this.dd = new Path();
        _this.da = a;
        return _this;
    }
    StepLineSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.da.pr = Defaults.c;
        }
    };
    Object.defineProperty(StepLineSeriesView.prototype, "dh", {
        get: function () {
            return this.dk;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "di", {
        get: function () {
            return this.dl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "dg", {
        get: function () {
            return this.dj;
        },
        enumerable: false,
        configurable: true
    });
    StepLineSeriesView.prototype.db = function () {
        this.dj.ak = null;
        this.dk.ak = null;
        this.dl.ak = null;
        this.aq();
    };
    StepLineSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
        this.da.uf.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
        this.da.uf.m(this.dk, this.dj, this.dl, a, b, c, d, e, f, g);
        this.aq();
    };
    StepLineSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        this.de.ak = this.dk.ak;
        this.df.ak = this.dl.ak;
        this.dd.ak = this.dj.ak;
        var a = this.bo();
        this.de._stroke = a;
        this.de.ac = this.e.fl + 3;
        this.df._stroke = a;
        this.df.ac = this.e.fl + 3;
        this.dd._fill = a;
        this.dd._opacity = 1;
    };
    StepLineSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
            else {
                a.s(this.dj);
                a.s(this.dk);
                a.s(this.dl);
            }
        }
    };
    StepLineSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower", "Main"]);
        this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper"]);
        this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
    };
    StepLineSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.or = a;
        this.e.gj = 3;
        this.e.gk = 1;
        this.e.gl = 4;
        this.e.e1 = false;
    };
    StepLineSeriesView.$t = markType(StepLineSeriesView, 'StepLineSeriesView', AnchoredCategorySeriesView.$);
    return StepLineSeriesView;
}(AnchoredCategorySeriesView));
export { StepLineSeriesView };
//# sourceMappingURL=StepLineSeries_combined.js.map
