/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FrameworkElement } from "igniteui-angular-core";
import { INotifyPropertyChanged_$type, PropertyChangedEventArgs, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
var SyncSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncSettings, _super);
    function SyncSettings() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        return _this;
    }
    SyncSettings.prototype.ai = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    SyncSettings.$t = markType(SyncSettings, 'SyncSettings', FrameworkElement.$, [INotifyPropertyChanged_$type]);
    SyncSettings.$$p = markDep(DependencyProperty, PropertyMetadata, SyncSettings, 'ai', ['SyncChannel', [2, null], 'SynchronizeHorizontally', [0, true], 'SynchronizeVertically', [0, true]]);
    return SyncSettings;
}(FrameworkElement));
export { SyncSettings };
//# sourceMappingURL=SyncSettings.js.map
