/**
 * Provides data for GetCustomContourValues event.
*/
var IgxCustomContourValueResolverEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgxCustomContourValueResolverEventArgs() {
    }
    Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxCustomContourValueResolverEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxCustomContourValueResolverEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "values", {
        get: function () {
            return this.i.values;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "contourValues", {
        get: function () {
            return this.i.contourValues;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.contourValues = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgxCustomContourValueResolverEventArgs;
}());
export { IgxCustomContourValueResolverEventArgs };
//# sourceMappingURL=igx-custom-contour-value-resolver-event-args.js.map
