import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { Series as Series_internal } from './Series';
import { IgxSeriesComponent as IgxSeriesComponent } from './igx-series-component';
var IgxSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxSeriesCollection, _super);
    function IgxSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxSeriesCollection.prototype._createInnerColl = function () {
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxSeriesComponent.$type, Series_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgxSeriesComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxSeriesCollection;
}(IgCollection));
export { IgxSeriesCollection };
//# sourceMappingURL=igx-series-collection.js.map
