import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { TimeAxisBreak as TimeAxisBreak_internal } from './TimeAxisBreak';
import { IgxTimeAxisBreakComponent as IgxTimeAxisBreakComponent } from './igx-time-axis-break-component';
var IgxTimeAxisBreakCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxTimeAxisBreakCollection, _super);
    function IgxTimeAxisBreakCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxTimeAxisBreakComponent.$type) {
            IgxTimeAxisBreakComponent.$type = markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxTimeAxisBreakCollection.prototype._createInnerColl = function () {
        if (!IgxTimeAxisBreakComponent.$type) {
            IgxTimeAxisBreakComponent.$type = markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxTimeAxisBreakComponent.$type, TimeAxisBreak_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxTimeAxisBreakComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxTimeAxisBreakCollection;
}(IgCollection));
export { IgxTimeAxisBreakCollection };
//# sourceMappingURL=igx-time-axis-break-collection.js.map
