import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Rect } from "igniteui-angular-core";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { SeriesViewer } from "./SeriesViewer";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryYAxis extends CategoryAxisBase {
    static $t: Type;
    a3(): AxisView;
    ha(a: AxisView): void;
    lo: CategoryYAxisView;
    protected get_cj(): boolean;
    d7(): number;
    ll(a: Point, b: boolean, c: number): Rect;
    protected ln(a: IList$1<number[]>): number[][];
    g4(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    constructor();
    static readonly l7: DependencyProperty;
    get lv(): number;
    set lv(a: number);
    lp(): boolean;
    private lq;
    get ls(): number;
    set ls(a: number);
    ej(): number;
    static readonly l8: DependencyProperty;
    get lw(): number;
    set lw(a: number);
    private lr;
    get lt(): number;
    set lt(a: number);
    private ly;
    get l0(): number;
    set l0(a: number);
    private lx;
    get lz(): number;
    set lz(a: number);
    d8(a: number, b: ScalerParams): number;
    private lu;
    eb(a: number, b: ScalerParams): number;
    ec(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    l6(a: number, b: number): void;
    au(): AxisLabelPanelBase;
    dv(): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    ki(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    l5(a: any): void;
    cx(): boolean;
    j9(a: SeriesViewer): boolean;
    protected hr(a: boolean): void;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
}
/**
 * @hidden
 */
export declare class CategoryYAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryYAxis;
    constructor(a: CategoryYAxis);
    ag(): void;
}
