import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    protected get_c5(): boolean;
    protected get_c3(): boolean;
    constructor();
    protected bu(): SeriesView;
    lh(a: SeriesView): void;
    protected qo: CrosshairLayerView;
    sv: Brush;
    sw: Brush;
    rd: string;
    qp: Series;
    qu: boolean;
    qs: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    qq(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    qr(): boolean;
    sz: Brush;
    sx: Brush;
    q7: number;
    sy: Brush;
    get s3(): Thickness;
    qy: number;
    q0: number;
    qz: number;
    qx: number;
    get s4(): Thickness;
    q3: number;
    q5: number;
    q4: number;
    q2: number;
    q1: number;
    s2: Brush;
    s0: Brush;
    q8: number;
    s1: Brush;
    q6: number;
    s6: Visibility;
    s5: Visibility;
    qt: boolean;
    protected p3(a: Series, b: boolean): void;
    protected p5(a: Frame, b: SeriesView): void;
    protected pq(a: Series): boolean;
    la(): void;
    private r2;
    private qw;
    private qv;
    protected r3(a: CrosshairLayerFrame, b: boolean): void;
    private r1;
    protected p8(a: Frame, b: SeriesView): void;
    protected eg(): boolean;
    protected lm(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b4: CrosshairLayer;
    b5: Pool$1<Path>;
    protected b6: List$1<Path>;
    as(): void;
    private cc;
    private b7;
    private b9;
    private b8;
    ca(a: Path, b: number, c: number, d: number): void;
    cb(a: Brush): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
