import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    static $t: Type;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ke(): void;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected get_d5(): boolean;
    protected bo(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    g4(a: Point, b: boolean): number;
    g6(a: Point, b: boolean): number;
    fu(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    f8(a: Point, b: boolean, c: boolean): number;
    f6(a: Point, b: boolean, c: boolean): number;
    f4(a: Point, b: boolean, c: boolean): number;
    oy(a: Point, b: boolean, c: boolean): Point;
    o0(a: Point, b: boolean, c: boolean): Point;
    o2(a: Point, b: boolean, c: boolean): Point;
    rx(): boolean;
    protected lm(a: any, b: string, c: any, d: any): void;
    tb(a: any): boolean;
    ta(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
