import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler } from "./IScaler";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "igniteui-angular-core";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { Rect } from "igniteui-angular-core";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
/**
 * @hidden
 */
export declare class NumericXAxis extends StraightNumericAxisBase implements IScaler {
    static $t: Type;
    a3(): AxisView;
    ha(a: AxisView): void;
    mm: NumericXAxisView;
    constructor();
    au(): AxisLabelPanelBase;
    j4(): NumericAxisRenderer;
    d8(a: number, b: ScalerParams): number;
    eb(a: number, b: ScalerParams): number;
    g5(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    g4(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    g6(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    mn(a: number, b: number): void;
    j7(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    protected hr(a: boolean): void;
    protected h3(a: Rect, b: Rect): void;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    j9(): NumericScaler;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
}
/**
 * @hidden
 */
export declare class NumericXAxisView extends StraightNumericAxisBaseView {
    static $t: Type;
    protected bi: NumericXAxis;
    constructor(a: NumericXAxis);
    ag(): void;
}
