import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { IEnumerable, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    ke(): void;
    qg: string;
    hk(a: any, b: string): any;
    qk: string;
    private pp;
    protected get pv(): IFastItemColumn$1<number>;
    protected set pv(a: IFastItemColumn$1<number>);
    private pq;
    protected get pw(): IFastItemColumn$1<number>;
    protected set pw(a: IFastItemColumn$1<number>);
    pi: NumericXAxis;
    pj: NumericYAxis;
    private py;
    l1(a: boolean): void;
    private qo;
    private qm;
    private pl;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private qp;
    protected pr(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected lm(a: any, b: string, c: any, d: any): void;
    p0(a: any): boolean;
    pz(a: any): boolean;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    private qn;
    private p1;
    ky(): void;
    protected kk(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ap(a: Axis): AxisRange;
    protected mn(a: Rect, b: Rect): void;
    protected mm(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    px: IFastItemsSource;
    p8: string;
    qa: string;
    qc: string;
    private pm;
    protected get ps(): IFastItemColumn$1<number>;
    protected set ps(a: IFastItemColumn$1<number>);
    private pn;
    protected get pt(): IFastItemColumn$1<number>;
    protected set pt(a: IFastItemColumn$1<number>);
    private po;
    protected get pu(): IFastItemColumn$1<number>;
    protected set pu(a: IFastItemColumn$1<number>);
    protected get_d7(): boolean;
    protected get_dw(): boolean;
    static $$p: string[];
}
