/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AccumulationDistributionIndicatorStrategy } from "./AccumulationDistributionIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AccumulationDistributionIndicator = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new AccumulationDistributionIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return AccumulationDistributionIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
    }
    AccumulationDistributionIndicator.$t = markType(AccumulationDistributionIndicator, 'AccumulationDistributionIndicator', StrategyBasedIndicator.$);
    return AccumulationDistributionIndicator;
})();
//# sourceMappingURL=AccumulationDistributionIndicator.js.map
