/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Boolean_$type, typeCast, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type, markDep } from "igniteui-angular-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "igniteui-angular-core";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { LineGeometry } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { ArcSegment } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export let AngleAxisLabelPanel = /*@__PURE__*/ (() => {
    class AngleAxisLabelPanel extends AxisLabelPanelBase {
        constructor() {
            super();
            this.c2 = false;
            this.c8 = null;
            this.c6 = 0;
            this.c3 = 0;
            this.c5 = 0;
            this.c4 = 0;
        }
        ad() {
            return new AngleAxisLabelPanelView(this);
        }
        cc(a) {
            super.cc(a);
            this.c1 = a;
        }
        aq(a, b) {
            if (!Extensions.b(b)) {
                return false;
            }
            if (this.ac == null || this.ac.js.isEmpty) {
                return super.aq(a, b);
            }
            return true;
        }
        a1() {
            let a = new List$1(Rect.$, 0);
            let b = new List$1(Boolean_$type, 0);
            if (this.a7.count != this.a6.count) {
                return a;
            }
            this.c1.ay(a, b);
            let c = false;
            this.an = this.am(a, b);
            if (!this.ac.b3()) {
                c = true;
                this.bd = this.c6 / 2;
                this.bd = this.bd + this.c7();
            }
            else {
                c = true;
                this.c1.ac();
            }
            if (c) {
                for (let d = 0; d < a.count; d++) {
                    let e = this.a7._inner[d];
                    let f = this.a6._inner[d];
                    let g = a._inner[d];
                    let h = this.c8(f.c);
                    let i = h.x - this.bg(e) / 2;
                    let j = h.y - this.bf(e) / 2;
                    g.x = i;
                    g.y = j;
                    a._inner[d] = g;
                }
            }
            return a;
        }
        c7() {
            let a;
            let b;
            b = this.ac;
            a = null;
            if (b != null) {
                a = typeCast(XamDataChart.$, b.bh);
            }
            if (a == null || b == null) {
                return 0;
            }
            let c = new List$1(Axis.$, 0);
            for (let d = 0; d < a.axes.count; d++) {
                let e = a.axes._inner[d];
                if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.av) !== null && e.av.a7.count > 0 && (!e.b3()) && !e.b1() && (e.ai == null || this.ac.ai == null || e.ai.ma == b.ai.ma)) {
                    c.add(e);
                }
            }
            let f = c.indexOf(b);
            if (f == -1) {
                return 0;
            }
            let g = 0;
            let h = 5;
            if (f == 0) {
                g += h;
            }
            else {
                g += c._inner[f - 1].av.bd;
                g += c._inner[f].av.bd * 2 + h;
            }
            return g;
        }
        ah() {
            return 4;
        }
        au(a) {
            return a == 4 || a == 5;
        }
    }
    AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
    return AngleAxisLabelPanel;
})();
/**
 * @hidden
 */
export let CategoryAngleAxis = /*@__PURE__*/ (() => {
    class CategoryAngleAxis extends CategoryAxisBase {
        constructor() {
            super();
            this.lt = null;
            this.lq = null;
            this.lu = false;
            this.ly = NaN;
            this.lr = null;
            this.lz = 0;
            this.lw = 0;
            this.lx = 0;
            this.ma = 1;
            this.ab = CategoryAngleAxis.$;
            this.lq = this.lp();
            this.lt = new PolarAxisRenderingManager();
        }
        a3() {
            return new CategoryAngleAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.lo = a;
        }
        get_b4() {
            return true;
        }
        au() {
            let a = new AngleAxisLabelPanel();
            a.c8 = (b) => {
                let c = this.bh != null ? this.bh.pg : Rect.empty;
                let d = !c.isEmpty ? this.js : Rect.empty;
                return this.mn(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.bd);
            };
            return a;
        }
        l8(a) {
            return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
        }
        lp() {
            let a = ((() => {
                let $ret = new AxisLabelManager();
                $ret.a = this;
                $ret.f = this.c6;
                $ret.e = this.c5;
                $ret.b = this.av;
                return $ret;
            })());
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            let b = new CategoryAxisRenderer(a);
            b.u = () => {
                let c = this.a4.ay();
                let d = this.a4.a1();
                let e = this.a4.az();
                let f = this.a4.a0();
                this.h0();
                this.g0(c);
                this.g0(d);
                this.g0(e);
                this.g0(f);
            };
            b.o = (c, d) => !d.isEmpty && !c.isEmpty && this.ls != null;
            b.d = (c, d, e, f) => this.ln(c, d, e, f);
            b.v = () => {
                if (!this.lu) {
                    this.lu = true;
                    this.ls.cv();
                    this.lu = false;
                }
            };
            b.g = (c) => {
                let d = typeGetValue(c);
                if (d > this.j6.count - 1) {
                    d -= this.j6.count;
                }
                let e = this.j6.item(d);
                return this.fi(e);
            };
            b.b.c = (c) => {
                if ((this.ay == null || this.ay.visibility == 0) && this.ls != null && this.ly != c) {
                    let d = typeCast(XamDataChart.$, this.bh);
                    if (d == null) {
                        return;
                    }
                    this.ly = c;
                    this.av.bc = c;
                    d.jq();
                    for (let e of fromEnum(d.axes)) {
                        if (e != this && typeCast(AngleAxisLabelPanel.$, e.av) !== null) {
                            e.a4.ad();
                        }
                    }
                }
            };
            b.k = (c, d, e) => {
                let f = typeCast(RadialAxisRenderingParameters.$, c);
                this.lt.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
            };
            b.l = (c, d, e, f) => {
                let g = typeCast(RadialAxisRenderingParameters.$, c);
                this.lt.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
            };
            b.m = (c, d) => this.getScaledAngle(d);
            b.q = (c, d) => {
                if (this.l8(d - this.lz) < 0) {
                    return false;
                }
                if (this.l8(d - this.lz - (2 * Math.PI)) > 0) {
                    return false;
                }
                return true;
            };
            b.j = (c) => {
                let d = typeCast(RadialAxisRenderingParameters.$, c);
                if (d.e == d.k._inner[0]) {
                    this.lt.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
                }
            };
            b.e = (c) => {
                c.n = this.l2();
                c.r = c.n;
            };
            b.p = (c, d, e) => {
                let f = typeCast(RadialAxisRenderingParameters.$, c);
                if (e) {
                    return false;
                }
                let g = this.mn(d, f.center, c.aa, c.z, 0);
                if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                    return true;
                }
                return false;
            };
            b.a = (c, d, e, f) => {
                let g = c.y;
                let h = new ScalerParams(0, c.aa, c.z, this.cc, g);
                let i = d;
                if (this.categoryMode != 0) {
                    let j = (e * f) + 1;
                    j = Math.min(j, this.kq);
                    let k = this.d8(j, h);
                    i = (d + k) / 2;
                }
                return i;
            };
            b.f = runOn(this, this.getGroupCenter);
            b.i = runOn(this, this.l5);
            return b;
        }
        mn(a, b, c, d, e) {
            let f = this.l2();
            let g = ViewportUtils.b(e, c, d);
            if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
                g *= -1;
            }
            let h = b.x + (f + g) * Math.cos(a);
            let i = b.y + (f + g) * Math.sin(a);
            h = ViewportUtils.c(h, c, d);
            i = ViewportUtils.f(i, c, d);
            return { $type: Point_$type, x: h, y: i };
        }
        l2() {
            if (this.ls == null) {
                return 0;
            }
            if (!this.b1()) {
                return this.ls.mf();
            }
            else {
                return this.ls.mg((this.fe));
            }
        }
        ln(a, b, c, d) {
            if (this.j6 == null) {
                return null;
            }
            let e = new RadialAxisRenderingParameters();
            let f = this.j6.count - 1;
            let g = this.a4.ay();
            let h = this.a4.a1();
            let i = this.a4.az();
            let j = this.a4.a0();
            e.t = g;
            e.w = h;
            e.u = i;
            e.v = j;
            e.l = f;
            e.m = 0;
            e.h = false;
            e.z = a;
            e.y = c;
            e.x = d;
            e.aa = b;
            e.g = this.lv();
            e.p = this.l6;
            e.o = this.el();
            e.q = this.l7;
            e.s = this.fj;
            let k = this.lt.f(b);
            let l = this.lt.g(b);
            let m = 0.5 * this.ls.ma;
            let n = 0.5 * this.ls.l9;
            let o = k;
            let p = l;
            let q = this.ls.mf();
            if (isNaN_(q) || isInfinity(q)) {
                return null;
            }
            if (p >= m) {
                p = q;
            }
            if (o < n) {
                o = n;
            }
            let r = a.width;
            this.lt.k(b, e, 0, this.j6.count, this.cc, runOn(this, this.getUnscaledAngle), r);
            let s = { $type: Point_$type, x: 0.5, y: 0.5 };
            e.center = s;
            e.maxLength = p;
            e.minLength = o;
            e.effectiveMaximum = q;
            e.ae = this.j6.count;
            e.ab = this.categoryMode;
            e.ad = true;
            e.ac = this.cc;
            e.af = this.ks;
            e.f = new CategoryTickmarkValues();
            e.j = this.cs;
            return e;
        }
        getMinMaxAngle(a, b, c) {
            let d = this.lt.l(a, b, c);
            b = d.p1;
            c = d.p2;
            return {
                p1: b,
                p2: c
            };
        }
        ac() {
            super.ac();
            this.hq(false);
        }
        get ls() {
            if (this.lr != null) {
                return this.lr;
            }
            let a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (let b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.lr;
        }
        set ls(a) {
            this.lr = a;
        }
        aj() {
            return this.ls;
        }
        getCategorySize(a, b, c) {
            return 2 * Math.PI / this.kq;
        }
        ki(a, b, c) {
            let d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            let e = 0;
            if (!isNaN_(this.km)) {
                e = Math.min(this.km, 1);
            }
            let f = 1 - 0.5 * d;
            return this.getCategorySize(a, b, c) * f / (this.ks - (this.ks - 1) * e);
        }
        getGroupCenter(a, b, c, d) {
            let e = 0.5;
            if (this.ks > 1) {
                let f = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
                let g = 0;
                if (!isNaN_(this.km)) {
                    g = Math.min(this.km, 1);
                }
                let h = 1 - 0.5 * f;
                let i = h / (this.ks - (this.ks - 1) * g);
                let j = (h - i) / (this.ks - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        }
        l5(a) {
            let b = 0.5;
            if (this.ks > 1) {
                let c = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
                let d = 0;
                if (!isNaN_(this.km)) {
                    d = Math.min(this.km, 1);
                }
                let e = 1 - 0.5 * c;
                let f = e / (this.ks - (this.ks - 1) * d);
                let g = (e - f) / (this.ks - 1);
                b = 0.25 * c + 0.5 * f + a * g;
            }
            return b;
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = !b.isEmpty ? this.js : Rect.empty;
            let d = this.jn();
            let e = this.jm();
            let f = this.lq.c(a, c, b, d, e);
            if (f != null) {
                this.l0 = f.f.m;
                this.l1 = f.f.l;
            }
        }
        l4(a, b) {
            let c;
            let d;
            let e = this.lt.l(b, c, d);
            c = e.p1;
            d = e.p2;
            if (c == 0) {
                if (this.cc) {
                    return this.kq;
                }
                else {
                    return 0;
                }
            }
            let f = this.getUnscaledAngle(c);
            if (f < 0 || f > this.kq) {
                f = this.getUnscaledAngle(c + Math.PI * 2);
            }
            return f;
        }
        l3(a, b) {
            let c;
            let d;
            let e = this.lt.l(b, c, d);
            c = e.p1;
            d = e.p2;
            if (d > Math.PI * 2) {
                d = d - Math.PI * 2;
            }
            if (d == Math.PI * 2) {
                if (this.cc) {
                    return 0;
                }
                else {
                    return this.kq;
                }
            }
            let f = this.getUnscaledAngle(d);
            if (f < 0 || f > this.kq) {
                f = this.getUnscaledAngle(d + Math.PI * 2);
            }
            return f;
        }
        getScaledAngle(a) {
            let b = this.kq;
            let c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
            if (this.cd) {
                c = 1 - c;
            }
            return (c * 2 * Math.PI) + this.lz;
        }
        getUnscaledAngle(a) {
            if (a < this.lz) {
                a += 2 * Math.PI;
            }
            let b = (a - this.lz) / (2 * Math.PI);
            if (this.cc) {
                b = 1 - b;
            }
            return b * (this.kq);
        }
        d8(a, b) {
            return this.getScaledAngle(a);
        }
        eb(a, b) {
            return this.getUnscaledAngle(a);
        }
        he(a, b, c, d) {
            super.he(a, b, c, d);
            let e = typeCast(XamDataChart.$, this.bh);
            switch (b) {
                case "CrossingAxis":
                    let f = typeCast(NumericRadiusAxis.$, d);
                    this.mj(f);
                    if (f != null) {
                        f.mp(this);
                    }
                    this.ck = true;
                    this.hq(false);
                    break;
                case CategoryAngleAxis.$$p[0]:
                    this.lz = this.l9;
                    while (this.lz < 0) {
                        this.lz += 360;
                    }
                    while (this.lz >= 360) {
                        this.lz -= 360;
                    }
                    this.lz = (this.lz * Math.PI) / 180;
                    this.ck = true;
                    this.hq(false);
                    for (let g of fromEnum(this.c7)) {
                        g.l0(false);
                        g.k7();
                    }
                    break;
                case "Label":
                    if (e != null) {
                        for (let h of fromEnum(e.axes)) {
                            h.ck = true;
                            h.hp();
                        }
                    }
                    break;
                case "CrossingValue":
                    if (e != null) {
                        for (let i of fromEnum(e.axes)) {
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.ck = true;
                                i.hp();
                            }
                        }
                    }
                    break;
                case "LabelSettings":
                    this.lq = this.lp();
                    this.mh();
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        }
        mh() {
            this.ly = NaN;
        }
        mj(a) {
            this.ls = a;
        }
        get l6() {
            return this.c(CategoryAngleAxis.mk);
        }
        set l6(a) {
            this.h(CategoryAngleAxis.mk, a);
        }
        get l0() {
            return this.lw;
        }
        set l0(a) {
            if (this.l0 != a) {
                let b = this.lw;
                this.lw = a;
                this.hk("ActualInterval", b, this.l0);
            }
        }
        ej() {
            return this.l0;
        }
        get l7() {
            return this.c(CategoryAngleAxis.ml);
        }
        set l7(a) {
            this.h(CategoryAngleAxis.ml, a);
        }
        get l1() {
            return this.lx;
        }
        set l1(a) {
            if (this.l1 != a) {
                let b = this.lx;
                this.lx = a;
                this.hk("ActualMinorInterval", b, this.l1);
            }
        }
        lv() {
            return !isNaN_(this.l6);
        }
        get_a1() {
            return 2;
        }
        get a1() {
            return this.get_a1();
        }
        cx() {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null) {
                return false;
            }
            let a = this.j6.count;
            if (a != this.mb) {
                let b = new AxisRangeChangedEventArgs(0, 1, 1, this.mb, a);
                this.mb = a;
                this.hl(b);
                return true;
            }
            return false;
        }
        get mb() {
            return this.ma;
        }
        set mb(a) {
            this.ma = a;
        }
        jk(a, b, c, d = null, e = null) {
            let f = typeCast(RadialAxisRenderingParameters.$, this.lq.d(c, b, d, e));
            if (f == null) {
                return null;
            }
            let g = Math.cos(a);
            let h = Math.sin(a);
            let i = f.center.x + g * f.minLength;
            let j = f.center.y + h * f.minLength;
            let k = f.center.x + g * f.maxLength;
            let l = f.center.y + h * f.maxLength;
            i = ViewportUtils.c(i, b, c);
            j = ViewportUtils.f(j, b, c);
            k = ViewportUtils.c(k, b, c);
            l = ViewportUtils.f(l, b, c);
            let m = new LineGeometry();
            m.d = { $type: Point_$type, x: i, y: j };
            m.c = { $type: Point_$type, x: k, y: l };
            return m;
        }
        get isVertical() {
            return this.cj;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
    }
    CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
    CategoryAngleAxis.mk = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
        a.hk("Interval", b.oldValue, b.newValue);
        a.hq(false);
    }));
    CategoryAngleAxis.ml = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
        (typeCast(CategoryAngleAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryAngleAxis.$, a)).hq(false);
    }));
    CategoryAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'hk', ['StartAngleOffset:l9:mm', [1, 0]]);
    return CategoryAngleAxis;
})();
/**
 * @hidden
 */
export let NumericAngleAxis = /*@__PURE__*/ (() => {
    class NumericAngleAxis extends NumericAxisBase {
        constructor() {
            super();
            this.l6 = null;
            this.l7 = false;
            this.l8 = NaN;
            this.l9 = 0;
            this.l4 = null;
            this.ab = NumericAngleAxis.$;
            this.l6 = new PolarAxisRenderingManager();
            this.j6 = this.j4();
        }
        a3() {
            return new NumericAngleAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.l3 = a;
        }
        get_b4() {
            return true;
        }
        au() {
            let a = new AngleAxisLabelPanel();
            a.c8 = (b) => {
                let c = this.bh != null ? this.bh.pg : Rect.empty;
                let d = !c.isEmpty ? this.js : Rect.empty;
                return this.mj(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.bd);
            };
            return a;
        }
        ma() {
            if (this.l5 == null) {
                return 0;
            }
            if (!this.b1()) {
                return this.l5.mf();
            }
            else {
                return this.l5.mg((this.fe));
            }
        }
        mc(a) {
            return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
        }
        j4() {
            let a = super.j4();
            a.b.c = (b) => {
                if ((this.ay == null || this.ay.visibility == 0) && this.l5 != null && this.l8 != b) {
                    let c = typeCast(XamDataChart.$, this.bh);
                    if (c == null) {
                        return;
                    }
                    this.l8 = b;
                    this.av.bc = b;
                    c.jq();
                    for (let d of fromEnum(c.axes)) {
                        if (d != this && typeCast(AngleAxisLabelPanel.$, d.av) !== null) {
                            d.a4.ad();
                        }
                    }
                }
            };
            a.e = (b) => {
                b.n = this.ma();
                b.r = b.n;
            };
            a.j = (b) => {
                let c = typeCast(PolarAxisRenderingParameters.$, b);
                if (c.e == c.k._inner[0]) {
                    this.l6.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
                }
            };
            a.k = (b, c, d) => {
                let e = typeCast(PolarAxisRenderingParameters.$, b);
                this.l6.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
            };
            a.l = (b, c, d, e) => {
                let f = typeCast(PolarAxisRenderingParameters.$, b);
                this.l6.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
            };
            a.d = (b, c, d, e) => {
                let f = typeCast(PolarAxisRenderingParameters.$, this.j7(b, c, d, e));
                return f;
            };
            a.v = () => {
                if (!this.l7) {
                    this.l7 = true;
                    this.l5.cv();
                    this.l7 = false;
                }
            };
            a.m = (b, c) => this.getScaledAngle(c);
            a.o = (b, c) => !c.isEmpty && !b.isEmpty && this.l5 != null;
            a.q = (b, c) => {
                if (this.mc(c - this.l9) < 0) {
                    return false;
                }
                if (this.mc(c - this.l9 - (2 * Math.PI)) > 0) {
                    return false;
                }
                return true;
            };
            a.p = (b, c, d) => {
                let e = typeCast(PolarAxisRenderingParameters.$, b);
                let f = this.mj(this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
                let g = this.mj(c, e.center, b.aa, b.z, 0);
                if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                    return false;
                }
                if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                    return true;
                }
                return false;
            };
            a.r = (b, c, d, e) => {
                if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                    return b.m;
                }
                else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                    return b.l;
                }
                return c;
            };
            return a;
        }
        mj(a, b, c, d, e) {
            let f = this.ma();
            let g = ViewportUtils.b(e, c, d);
            if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
                g *= -1;
            }
            let h = b.x + (f + g) * Math.cos(a);
            let i = b.y + (f + g) * Math.sin(a);
            h = ViewportUtils.c(h, c, d);
            i = ViewportUtils.f(i, c, d);
            return { $type: Point_$type, x: h, y: i };
        }
        d8(a, b) {
            return this.getScaledAngle(a);
        }
        getScaledAngle1(a, b, c) {
            let d = 0;
            if (b) {
                d = (Math.log(a) - this.k1) / (this.k0 - this.k1);
            }
            else {
                d = (a - this.kv) / (this.ku - this.kv);
            }
            if (c) {
                d = 1 - d;
            }
            return (d * 2 * Math.PI) + this.l9;
        }
        getScaledAngle(a) {
            return this.getScaledAngle1(a, this.kl, this.cd);
        }
        eb(a, b) {
            return this.getUnscaledAngle(a);
        }
        getUnscaledAngle(a) {
            let b = (a - this.l9) / (2 * Math.PI);
            if (this.cc) {
                b = 1 - b;
            }
            if (this.kl) {
                return Math.exp(b * (this.k0 - this.k1) + this.k1);
            }
            else {
                return this.kv + b * (this.ku - this.kv);
            }
        }
        he(a, b, c, d) {
            super.he(a, b, c, d);
            let e = typeCast(XamDataChart.$, this.bh);
            switch (b) {
                case "CrossingAxis":
                    let f = typeCast(NumericRadiusAxis.$, d);
                    this.mh(f);
                    if (f != null) {
                        f.mp(this);
                    }
                    this.hq(false);
                    break;
                case NumericAngleAxis.$$p[0]:
                    this.l9 = this.md;
                    while (this.l9 < 0) {
                        this.l9 += 360;
                    }
                    while (this.l9 >= 360) {
                        this.l9 -= 360;
                    }
                    this.l9 = (this.md * Math.PI) / 180;
                    this.hq(false);
                    for (let g of fromEnum(this.c4())) {
                        g.l0(false);
                        g.k7();
                    }
                    break;
                case "Label":
                    if (e != null) {
                        for (let h of fromEnum(e.axes)) {
                            h.hp();
                        }
                    }
                    break;
                case "CrossingValue":
                    if (e != null) {
                        for (let i of fromEnum(e.axes)) {
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.hp();
                            }
                        }
                    }
                    break;
                case "LabelSettings":
                    this.j6 = this.j4();
                    this.mf();
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        }
        mf() {
            this.l8 = NaN;
        }
        j8() {
            return new PolarAxisRenderingParameters();
        }
        j7(a, b, c, d) {
            let e = typeCast(PolarAxisRenderingParameters.$, super.j7(a, b, c, d));
            let f = this.l6.f(b);
            let g = this.l6.g(b);
            let h = 0.5 * this.l5.ma;
            let i = 0.5 * this.l5.l9;
            let j = f;
            let k = g;
            let l = this.l5.mf();
            if (isNaN_(l) || isInfinity(l)) {
                return null;
            }
            if (k >= h) {
                k = l;
            }
            if (j < i) {
                j = i;
            }
            let m = a.width;
            this.l6.k(b, e, this.kv, this.ku, this.cc, runOn(this, this.getUnscaledAngle), m);
            let n = { $type: Point_$type, x: 0.5, y: 0.5 };
            e.center = n;
            e.maxLength = k;
            e.minLength = j;
            e.effectiveMaximum = l;
            return e;
        }
        getMinMaxAngle(a, b, c) {
            let d = this.l6.l(a, b, c);
            b = d.p1;
            c = d.p2;
            return {
                p1: b,
                p2: c
            };
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = !b.isEmpty ? this.js : Rect.empty;
            let d = this.jn();
            let e = this.jm();
            let f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        }
        get l5() {
            if (this.l4 != null) {
                return this.l4;
            }
            let a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (let b = 0; b < a.axes.count; b++) {
                    if (a.axes._inner[b].cg) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.l4;
        }
        set l5(a) {
            this.l4 = a;
        }
        aj() {
            return this.l5;
        }
        mh(a) {
            this.l5 = a;
        }
        h3(a, b) {
            super.h3(a, b);
            if (b.height != a.height || b.width != a.width) {
                this.cv();
            }
        }
        get_a1() {
            return 2;
        }
        get a1() {
            return this.get_a1();
        }
        jk(a, b, c, d = null, e = null) {
            if (this.l5 == null) {
                return null;
            }
            let f = typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
            if (f == null) {
                return null;
            }
            let g = Math.cos(a);
            let h = Math.sin(a);
            let i = f.center.x + g * f.minLength;
            let j = f.center.y + h * f.minLength;
            let k = f.center.x + g * f.maxLength;
            let l = f.center.y + h * f.maxLength;
            i = ViewportUtils.c(i, b, c);
            j = ViewportUtils.f(j, b, c);
            k = ViewportUtils.c(k, b, c);
            l = ViewportUtils.f(l, b, c);
            let m = new LineGeometry();
            m.d = { $type: Point_$type, x: i, y: j };
            m.c = { $type: Point_$type, x: k, y: l };
            return m;
        }
    }
    NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
    NumericAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'hk', ['StartAngleOffset:md:mi', [1, 0]]);
    return NumericAngleAxis;
})();
/**
 * @hidden
 */
export let NumericRadiusAxis = /*@__PURE__*/ (() => {
    class NumericRadiusAxis extends NumericAxisBase {
        constructor() {
            super();
            this.l6 = null;
            this.l7 = false;
            this.l8 = NaN;
            this.ma = 0;
            this.l9 = 0;
            this.mc = 0;
            this.l3 = null;
            this.ab = NumericRadiusAxis.$;
            this.ma = this.mk;
            this.l9 = this.mj;
            this.l6 = new PolarAxisRenderingManager();
            this.j6 = this.j4();
        }
        a3() {
            return new NumericRadiusAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.l5 = a;
        }
        get_cg() {
            return true;
        }
        d7() {
            let a = this.ma;
            let b = this.l9;
            let c = Math.min(this.me(), this.md()) * (a - b) / 2;
            c = Math.max(c, 14);
            return c;
        }
        me() {
            return this.js.width;
        }
        md() {
            return this.js.height;
        }
        au() {
            return new RadialAxisLabelPanel();
        }
        mb(a) {
            if (a == null) {
                return 0;
            }
            return a;
        }
        j4() {
            let a = super.j4();
            a.b.c = (b) => {
                if ((this.ay == null || this.ay.visibility == 0) && this.l4 != null) {
                    if ((this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) && this.l8 != b) {
                        this.l8 = b;
                        this.av.bc = b;
                        this.bh.jq();
                    }
                }
            };
            a.k = (b, c, d) => {
                let e = typeCast(PolarAxisRenderingParameters.$, b);
                this.l6.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
            };
            a.l = (b, c, d, e) => {
                if (d == e) {
                    return;
                }
                let f = typeCast(PolarAxisRenderingParameters.$, b);
                this.l6.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
            };
            a.m = (b, c) => this.mg(c);
            a.q = (b, c) => {
                let d = typeCast(PolarAxisRenderingParameters.$, b);
                return c <= d.effectiveMaximum;
            };
            a.n = (b, c) => {
                let d = typeCast(PolarAxisRenderingParameters.$, b);
                return c <= d.effectiveMaximum;
            };
            a.j = (b) => {
                let c = typeCast(PolarAxisRenderingParameters.$, b);
                this.l6.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
            };
            a.e = (b) => {
                b.n = this.ay == null || (this.ay.c == 4 || this.ay.c == 0) ? b.z.top : b.z.bottom;
                b.r = b.n;
                let c = typeCast(PolarAxisRenderingParameters.$, b);
                c.crossingAngleRadians = (this.mb(this.fe) * Math.PI) / 180;
                if (this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) {
                    c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                    c.r = c.n;
                    let d = typeCast(RadialAxisLabelPanel.$, this.av);
                    if (d != null) {
                        let e = 0;
                        if (this.ay != null && this.ay.c == 4) {
                            e = 1;
                        }
                        d.dq = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                        d.dm = c.crossingAngleRadians;
                    }
                }
            };
            a.p = (b, c, d) => {
                let e = typeCast(PolarAxisRenderingParameters.$, b);
                if (this.l4 == null) {
                    return false;
                }
                if (c > e.effectiveMaximum) {
                    return false;
                }
                let f = false;
                f = this.ay == null || (this.ay.c == 4 || this.ay.c == 5);
                let g = 0;
                if (f) {
                    g = this.mc;
                }
                let h = e.center.x + c * Math.cos(g);
                let i = e.center.y + c * Math.sin(g);
                h = ViewportUtils.c(h, e.aa, e.z);
                i = ViewportUtils.f(i, e.aa, e.z);
                if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                    return true;
                }
                return false;
            };
            a.h = (b, c) => {
                let d = typeCast(PolarAxisRenderingParameters.$, b);
                return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
            };
            a.r = (b, c, d, e) => {
                if (c < b.m) {
                    return b.m;
                }
                else if (c > b.l) {
                    return b.l;
                }
                return c;
            };
            return a;
        }
        d8(a, b) {
            return this.mg(a);
        }
        mh(a, b, c, d, e) {
            let f = 0;
            if (b) {
                if (a <= 0) {
                    f = (Math.log(this.kv) - this.k1) / (this.k0 - this.k1);
                }
                else {
                    f = (Math.log(a) - this.k1) / (this.k0 - this.k1);
                }
            }
            else {
                f = (a - this.kv) / (this.ku - this.kv);
            }
            if (c) {
                f = 1 - f;
            }
            f = e + (f * (d - e));
            f /= 2;
            return f;
        }
        mg(a) {
            return this.mh(a, this.kl, this.cd, this.ma, this.l9);
        }
        mi(a) {
            let b = a * 2;
            b = (b - this.l9) / (this.ma - this.l9);
            if (this.cc) {
                b = 1 - b;
            }
            if (this.kl) {
                return Math.exp(b * (this.k0 - this.k1) + this.k1);
            }
            else {
                return this.kv + b * (this.ku - this.kv);
            }
        }
        eb(a, b) {
            return this.mi(a);
        }
        he(a, b, c, d) {
            switch (b) {
                case "CrossingValue":
                    this.mc = this.mb(this.fe) * Math.PI / 180;
                    break;
            }
            super.he(a, b, c, d);
            switch (b) {
                case NumericRadiusAxis.$$p[1]:
                    this.ma = this.mk;
                    if (this.ma < 0) {
                        this.ma = 0.1;
                    }
                    if (this.ma > 1) {
                        this.ma = 1;
                    }
                    if (this.l9 >= this.ma) {
                        this.l9 = this.ma - 0.01;
                        if (this.l9 < 0) {
                            this.l9 = 0;
                            this.ma = 0.01;
                        }
                    }
                    this.ck = true;
                    this.hq(false);
                    if (this.l4 != null) {
                        this.l4.hp();
                    }
                    for (let e of fromEnum(this.c4())) {
                        e.l0(false);
                    }
                    break;
                case NumericRadiusAxis.$$p[0]:
                    this.l9 = this.mj;
                    if (this.l9 < 0) {
                        this.l9 = 0.1;
                    }
                    if (this.l9 > 1) {
                        this.l9 = 1;
                    }
                    if (this.l9 >= this.ma) {
                        this.l9 = this.ma - 0.01;
                        if (this.l9 < 0) {
                            this.l9 = 0;
                            this.ma = 0.01;
                        }
                    }
                    this.ck = true;
                    this.hq(false);
                    if (this.l4 != null) {
                        this.l4.hp();
                    }
                    for (let f of fromEnum(this.c4())) {
                        f.et = true;
                        f.l0(false);
                    }
                    if (this.bh != null) {
                        this.bh.jz();
                    }
                    break;
                case "CrossingAxis":
                    let g = typeCast(NumericAngleAxis.$, d);
                    let h = typeCast(CategoryAngleAxis.$, d);
                    if (g == null && h == null) {
                        this.mp(null);
                    }
                    if (g != null) {
                        this.mp(g);
                        g.mh(this);
                    }
                    if (h != null) {
                        this.mp(h);
                        h.mj(this);
                    }
                    this.ck = true;
                    this.hq(false);
                    break;
                case "IsInverted":
                    if (this.l4 != null) {
                        this.l4.ck = true;
                        this.l4.hq(false);
                    }
                    break;
            }
        }
        mp(a) {
            this.l4 = a;
        }
        get l4() {
            if (this.l3 != null) {
                return this.l3;
            }
            let a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (let b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.l3;
        }
        set l4(a) {
            this.l3 = a;
        }
        aj() {
            return this.l4;
        }
        j8() {
            return new PolarAxisRenderingParameters();
        }
        j7(a, b, c, d) {
            let e = typeCast(PolarAxisRenderingParameters.$, super.j7(a, b, c, d));
            let f = this.l6.f(b);
            let g = this.l6.g(b);
            let h = 0.5 * this.ma;
            let i = 0.5 * this.l9;
            let j, k;
            if (Rect.l_op_Equality(b, SeriesViewer.ps)) {
                k = this.ku;
                j = this.kv;
            }
            else {
                k = Math.min(g, h);
                j = this.mi(f);
                k = this.mi(k);
                let l = this.mq(a, b, j, k);
                j = l.p2;
                k = l.p3;
            }
            let m = { $type: Point_$type, x: 0.5, y: 0.5 };
            let n = f;
            let o = g;
            let p = Math.min(a.width, a.height) * (this.ma - this.l9) / 2;
            e.center = m;
            let q = Math.max(o, n);
            let r = Math.min(n, o);
            e.maxLength = q;
            e.minLength = r;
            let s = Math.min(j, k);
            let t = Math.max(j, k);
            if (s < this.kv) {
                s = this.kv;
            }
            if (t > this.ku) {
                t = this.ku;
            }
            this.ky = s;
            this.kx = t;
            e.k.add(((() => {
                let $ret = new RangeInfo();
                $ret.d = s;
                $ret.c = t;
                $ret.b = p;
                return $ret;
            })()));
            let u = typeCast(IAngleScaler_$type, this.l4);
            if (u != null) {
                let v;
                let w;
                let x = u.getMinMaxAngle(b, v, w);
                v = x.p1;
                w = x.p2;
                e.minAngle = Math.min(v, w);
                e.maxAngle = Math.max(v, w);
            }
            let y = this.mf();
            if (o >= h) {
                o = y;
            }
            if (n < i) {
                n = i;
            }
            e.minLength = n;
            e.maxLength = o;
            e.effectiveMaximum = y;
            e.f = this.kb;
            let z = typeCast(LinearTickmarkValues.$, e.f);
            if (z != null) {
                z.y = this.ml(m, e.minLength, e.maxLength, b, a);
            }
            return e;
        }
        mq(a, b, c, d) {
            let e = { $type: Point_$type, x: 0.5, y: 0.5 };
            let f = 0;
            if (this.cc) {
                f = this.mg(this.kv);
            }
            else {
                f = this.mg(this.ku);
            }
            let g = 0;
            if (this.fe != null) {
                g = this.mc;
            }
            let h = e.x + f * Math.cos(g);
            let i = e.y + f * Math.sin(g);
            e.x = ViewportUtils.c(e.x, b, a);
            e.y = ViewportUtils.f(e.y, b, a);
            h = ViewportUtils.c(h, b, a);
            i = ViewportUtils.f(i, b, a);
            if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
                if (this.cc) {
                    d = this.kv;
                }
                else {
                    d = this.ku;
                }
            }
            if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
                if (this.cc) {
                    c = this.ku;
                }
                else {
                    c = this.kv;
                }
            }
            return {
                p2: c,
                p3: d
            };
        }
        ml(a, b, c, d, e) {
            let f = ViewportUtils.d(c - b, d, e);
            let g = f / Math.min(e.width, e.height);
            if (g > 0.7) {
                return 10;
            }
            return 5;
        }
        mf() {
            let a = 0;
            if (!this.cc) {
                a = this.mg(this.ku);
            }
            else {
                a = this.mg(this.kv);
            }
            return a;
        }
        lt(a) {
            if (this.l4 != null) {
                this.l4.hp();
            }
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = !b.isEmpty ? this.js : Rect.empty;
            let d = this.jn();
            let e = this.jm();
            let f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        }
        h3(a, b) {
            super.h3(a, b);
            if (b.height != a.height || b.width != a.width) {
                this.cv();
            }
        }
        mo(a, b, c, d, e) {
            let f = typeCast(IPolarRadialRenderingParameters_$type, this.j7(b, c, d, e));
            if (f == null) {
                return;
            }
            this.l6.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
        }
        get_a1() {
            return 3;
        }
        get a1() {
            return this.get_a1();
        }
        jk(a, b, c, d = null, e = null) {
            let f = typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
            let g = a;
            let h = new PathGeometry();
            let i = ViewportUtils.d(g, b, c);
            let j = ViewportUtils.g(g, b, c);
            if (i <= 0 || j <= 0) {
                return null;
            }
            let k = ViewportUtils.c(f.center.x, b, c);
            let l = ViewportUtils.f(f.center.y, b, c);
            if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
                let m = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
                let n = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
                let o = new PathFigure();
                o._startPoint = m;
                o._isClosed = false;
                o._segments.add(((() => {
                    let $ret = new ArcSegment();
                    $ret.b = false;
                    $ret.e = n;
                    $ret.f = new Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                h.c.add(o);
            }
            else {
                let p = new PathFigure();
                p._startPoint = { $type: Point_$type, x: k, y: l - j };
                p._isClosed = true;
                p._segments.add(((() => {
                    let $ret = new ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: Point_$type, x: k, y: l + j };
                    $ret.f = new Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                p._segments.add(((() => {
                    let $ret = new ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: Point_$type, x: k, y: l - j };
                    $ret.f = new Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                h.c.add(p);
            }
            return h;
        }
    }
    NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
    NumericRadiusAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'hk', ['InnerRadiusExtentScale:mj:mr', [1, 0], 'RadiusExtentScale:mk:ms', [1, 0.75]]);
    return NumericRadiusAxis;
})();
/**
 * @hidden
 */
export let AngleAxisLabelPanelView = /*@__PURE__*/ (() => {
    class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
        constructor(a) {
            super(a);
            this.ax = null;
            this.ax = a;
        }
        am() {
            super.am();
            this.ax.c2 = true;
        }
        ay(a, b) {
            this.ax.c6 = -1.7976931348623157E+308;
            this.ax.c3 = -1.7976931348623157E+308;
            this.ax.c5 = -1.7976931348623157E+308;
            this.ax.c4 = -1.7976931348623157E+308;
            for (let c = 0; c < this.a.a7.count; c++) {
                let d = this.a.a7._inner[c];
                let e = this.a.a6._inner[c];
                let f = e.a;
                let g = this.ax.c8(e.c);
                let h = this.m(d);
                let i = this.l(d);
                let j = h + this.p() + this.q();
                let k = i + this.r() + this.o();
                let l = g.x - j / 2;
                let m = g.y - k / 2;
                this.ax.c5 = Math.max(h, this.ax.c5);
                this.ax.c4 = Math.max(i, this.ax.c4);
                this.ax.c6 = Math.max(j, this.ax.c6);
                this.ax.c3 = Math.max(k, this.ax.c3);
                let n = new Rect(0, l, m, j, k);
                a.add(n);
                b.add(f);
            }
        }
        o() {
            return 0;
        }
        p() {
            return 0;
        }
        q() {
            return 0;
        }
        r() {
            return 0;
        }
    }
    AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
    return AngleAxisLabelPanelView;
})();
/**
 * @hidden
 */
export let CategoryAngleAxisView = /*@__PURE__*/ (() => {
    class CategoryAngleAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        }
    }
    CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
    return CategoryAngleAxisView;
})();
/**
 * @hidden
 */
export let NumericAngleAxisView = /*@__PURE__*/ (() => {
    class NumericAngleAxisView extends NumericAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        }
    }
    NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
    return NumericAngleAxisView;
})();
/**
 * @hidden
 */
export let NumericRadiusAxisView = /*@__PURE__*/ (() => {
    class NumericRadiusAxisView extends NumericAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        }
    }
    NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
    return NumericRadiusAxisView;
})();
//# sourceMappingURL=AngleAxisLabelPanel_combined.js.map
