/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AverageTrueRangeIndicatorStrategy } from "./AverageTrueRangeIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AverageTrueRangeIndicator = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new AverageTrueRangeIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return AverageTrueRangeIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(AverageTrueRangeIndicator.uh));
        }
        set ug(a) {
            this.h(AverageTrueRangeIndicator.uh, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
    }
    AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
    AverageTrueRangeIndicator.uh = StrategyBasedIndicator.ud(14, AverageTrueRangeIndicator.$);
    return AverageTrueRangeIndicator;
})();
//# sourceMappingURL=AverageTrueRangeIndicator.js.map
