/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { BollingerBandWidthIndicatorStrategy } from "./BollingerBandWidthIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let BollingerBandWidthIndicator = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new BollingerBandWidthIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return BollingerBandWidthIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get uh() {
            return typeGetValue(this.c(BollingerBandWidthIndicator.uk));
        }
        set uh(a) {
            this.h(BollingerBandWidthIndicator.uk, a);
        }
        t1() {
            return this.uh;
        }
        get ug() {
            return this.c(BollingerBandWidthIndicator.uj);
        }
        set ug(a) {
            this.h(BollingerBandWidthIndicator.uj, a);
        }
        tz() {
            return this.ug;
        }
    }
    BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
    BollingerBandWidthIndicator.uk = StrategyBasedIndicator.ud(20, BollingerBandWidthIndicator.$);
    BollingerBandWidthIndicator.uj = StrategyBasedIndicator.uc(2, BollingerBandWidthIndicator.$);
    return BollingerBandWidthIndicator;
})();
//# sourceMappingURL=BollingerBandWidthIndicator.js.map
