/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinalValueLayer = /*@__PURE__*/ (() => {
    class FinalValueLayer extends AnnotationLayer {
        constructor() {
            super();
            this.axisAnnotationFormatLabel = null;
            this.qs = null;
            this.qr = null;
            let a = new FinalValueLayerFrame();
            let b = new FinalValueLayerFrame();
            let c = new FinalValueLayerFrame();
            let d = this.ha / 1000;
            this.pk = a;
            this.pj = b;
            this.pl = c;
            this.ab = FinalValueLayer.$;
        }
        get_c4() {
            return true;
        }
        bu() {
            return new FinalValueLayerView(this);
        }
        lh(a) {
            super.lh(a);
            this.qn = a;
        }
        get ru() {
            return new Thickness(1, this.qu, this.qw, this.qv, this.qt);
        }
        qq() {
            return this.axisAnnotationFormatLabel != null;
        }
        p3(a, b) {
            if (this.qp == null || this.qp == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        }
        p5(a, b) {
            super.p5(a, b);
            let c = a;
            c.f.clear();
            c.q.clear();
            c.p.clear();
            c.aa.clear();
            c.o.clear();
            c.z.clear();
            c.g.clear();
            c.h.clear();
            c.j.clear();
            c.l.clear();
            c.k.clear();
            c.i.clear();
            c.m.clear();
            c.n.clear();
            c.r.clear();
            c.s.clear();
            c.u.clear();
            c.w.clear();
            c.v.clear();
            c.t.clear();
            c.x.clear();
            c.y.clear();
            if (this.pq(this.qp)) {
                this.rc(this.qp, c);
            }
            else {
                for (let d of fromEnum(this.ca.series)) {
                    if (this.pq(d)) {
                        this.rc(d, c);
                    }
                    if (d.isStacked) {
                        d.ku((e) => {
                            if (this.pq(e)) {
                                this.rc(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        pq(a) {
            if (!super.pq(a)) {
                return false;
            }
            if (this.q9 != null) {
                if (a.dn) {
                    let b = a.i9();
                    if (!Base.equalsStatic(this.q9, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.q9, a.name)) {
                        return false;
                    }
                }
            }
            return true;
        }
        la() {
            super.la();
            if (!this.as.c && !this.cr()) {
                return;
            }
            if (this.cr()) {
                this.rd(this.pl, false);
            }
            else {
                this.rd(this.pj, false);
            }
        }
        rt(a) {
            let b = NaN;
            let c = NaN;
            let d = this.qo;
            if (d == 0) {
                d = 1;
            }
            let e = false;
            if (d == 2) {
                e = true;
            }
            if (a.isVertical) {
                let f = a.ar();
                if (f != null) {
                    if (d == 1 || d == 2) {
                        if (f.cc) {
                            c = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.bottom }).y;
                        }
                        else {
                            c = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.top }).y;
                        }
                    }
                    else {
                        if (f.cc) {
                            c = 1;
                        }
                        else {
                            c = 0;
                        }
                    }
                }
                return a.o2({ $type: Point_$type, x: 0, y: c }, e, true);
            }
            else {
                let g = a.ar();
                if (g != null) {
                    if (d == 1 || d == 2) {
                        if (g.cc) {
                            b = a.o5({ $type: Point_$type, x: this.pf.left, y: this.pf.top }).x;
                        }
                        else {
                            b = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.top }).x;
                        }
                    }
                    else {
                        if (g.cc) {
                            b = 0;
                        }
                        else {
                            b = 1;
                        }
                    }
                }
                if (a.di) {
                    return a.o2({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
                else {
                    return a.o2({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
            }
        }
        rc(a, b) {
            let c = this.rt(a);
            let d = this.o5(c);
            let e = this.of;
            if (e == null) {
                e = this.oj;
            }
            if (e == null) {
                e = a.of;
                if (e != null) {
                    e = this.qn.b5(e);
                }
            }
            AxisAnnotationFrameManager.c(b, c, a, this.ca, this.getEffectiveViewport(), e, this.rq, this.rs, this.rr, this.ru, this.qx, this.rq, this.rs, this.rr, this.ru, this.qx, a.isVertical, !a.isVertical);
        }
        rd(a, b) {
            let c = false;
            if (this.qr == null) {
                c = true;
                this.qs = new List$1(Axis.$, 0);
                this.qr = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.qr, this.qs, b, this.qy, this.qy, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
        }
        p8(a, b) {
            super.p8(a, b);
            if (this.cr()) {
                this.rd(this.pl, true);
            }
            else {
                this.rd(this.pj, false);
            }
        }
        eg() {
            return true;
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case FinalValueLayer.$$p[10]:
                case FinalValueLayer.$$p[11]:
                    this.l0(true);
                    break;
                case FinalValueLayer.$$p[0]:
                case FinalValueLayer.$$p[2]:
                case FinalValueLayer.$$p[4]:
                case FinalValueLayer.$$p[6]:
                case FinalValueLayer.$$p[5]:
                case FinalValueLayer.$$p[3]:
                case FinalValueLayer.$$p[7]:
                case FinalValueLayer.$$p[8]:
                case FinalValueLayer.$$p[9]:
                    this.l0(true);
                    break;
                case "SeriesViewer":
                    let e = this.qs;
                    let f = this.qr;
                    if (f != null) {
                        for (let g of fromEnum(f)) {
                            let h = g.value;
                            h.c((i) => g.key.am.remove(i));
                            h.clear();
                        }
                        e.clear();
                        f.clear();
                    }
                    break;
            }
        }
    }
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackground:rq:re', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:qy:rf', [1, -1], 'AxisAnnotationOutline:rr:rg', [Brush.$, null], 'AxisAnnotationPaddingBottom:qt:rh', [1, NaN], 'AxisAnnotationPaddingLeft:qu:ri', [1, NaN], 'AxisAnnotationPaddingRight:qv:rj', [1, NaN], 'AxisAnnotationPaddingTop:qw:rk', [1, NaN], 'AxisAnnotationStrokeThickness:qx:rl', [1, NaN], 'AxisAnnotationTextColor:rs:rm', [Brush.$, null], 'FinalValueSelectionMode:qo:rn', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:q9:ro', [2, null], 'TargetSeries:qp:rp', [Series.$, null]]);
    return FinalValueLayer;
})();
/**
 * @hidden
 */
export let FinalValueLayerView = /*@__PURE__*/ (() => {
    class FinalValueLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b4 = a;
        }
        as() {
            super.as();
        }
        b5(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.1);
        }
        al(a) {
            super.al(a);
        }
    }
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
})();
//# sourceMappingURL=FinalValueLayer_combined.js.map
