/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
/**
 * @hidden
 */
export let FinancialPriceSeriesProxy = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesProxy extends Base {
        getCloseMemberPath(a) {
            return a.ru;
        }
        getHighMemberPath(a) {
            return a.rx;
        }
        getLowMemberPath(a) {
            return a.r2;
        }
        getOpenMemberPath(a) {
            return a.r6;
        }
        getVolumeMemberPath(a) {
            return a.sa;
        }
        matchesType(a) {
            if (!a.di) {
                return false;
            }
            if (a.dj || a.dk) {
                return false;
            }
            return true;
        }
        setCategoryMode(a, b) {
            a.py = b;
        }
        setCloseMemberPath(a, b) {
            a.ru = b;
        }
        setDisplayType(a, b) {
            a.s2 = b;
        }
        setHighMemberPath(a, b) {
            a.rx = b;
        }
        setLowMemberPath(a, b) {
            a.r2 = b;
        }
        setOpenMemberPath(a, b) {
            a.r6 = b;
        }
        setVolumeMemberPath(a, b) {
            a.sa = b;
        }
        setXAxis(a, b) {
            a.pq = b;
        }
        setYAxis(a, b) {
            a.qc = b;
        }
    }
    FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
    return FinancialPriceSeriesProxy;
})();
//# sourceMappingURL=FinancialPriceSeriesProxy.js.map
