/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FullStochasticOscillatorIndicator = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
        constructor() {
            super();
            this.trendLineBrush = ((() => {
                let $ret = new Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            this.trendLineType = 10;
            this.trendLinePeriod = 3;
        }
        get_tv() {
            return new FullStochasticOscillatorIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return FullStochasticOscillatorIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.ul));
        }
        set ug(a) {
            this.h(FullStochasticOscillatorIndicator.ul, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
        get smoothingPeriod() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.um));
        }
        set smoothingPeriod(a) {
            this.h(FullStochasticOscillatorIndicator.um, a);
        }
        t3() {
            return this.smoothingPeriod;
        }
        get ui() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.un));
        }
        set ui(a) {
            this.h(FullStochasticOscillatorIndicator.un, a);
        }
        t0() {
            return this.ui;
        }
        tb() {
            return this.ui;
        }
    }
    FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    FullStochasticOscillatorIndicator.ul = StrategyBasedIndicator.ud(14, FullStochasticOscillatorIndicator.$);
    FullStochasticOscillatorIndicator.um = StrategyBasedIndicator.ue(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
    FullStochasticOscillatorIndicator.un = StrategyBasedIndicator.ue(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
    return FullStochasticOscillatorIndicator;
})();
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map
