/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType, TypeRegistrar } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { HorizontalLogarithmicScaler } from "./HorizontalLogarithmicScaler";
import { FastHorizontalLinearScaler } from "./FastHorizontalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let NumericXAxis = /*@__PURE__*/ (() => {
    class NumericXAxis extends StraightNumericAxisBase {
        constructor() {
            super();
            this.ab = NumericXAxis.$;
            this.j6 = this.j4();
        }
        a3() {
            return new NumericXAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.mm = a;
        }
        au() {
            if (this.cz) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        j4() {
            let a = super.j4();
            a.b.c = (b) => {
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    this.av.bc = b;
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.jq();
                    }
                }
            };
            a.k = (b, c, d) => this.h1(c, d, b.z, b.b, false);
            a.l = (b, c, d, e) => this.h2(c, d, e, b.z);
            a.m = (b, c) => {
                let d = b.y;
                let e = new ScalerParams(0, b.aa, b.z, this.cd, d);
                return this.d8(c, e);
            };
            a.q = (b, c) => true;
            a.j = (b) => this.g8(b.t, b.n, b.z, b.a, true);
            a.e = (b) => {
                b.n = b.z.bottom;
                if (this.ai != null && this.ai.bh != null) {
                    let c = b.n;
                    let d = b.r;
                    let e = this.hv(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                    c = e.p0;
                    d = e.p1;
                    b.n = c;
                    b.r = d;
                }
            };
            a.p = (b, c, d) => {
                let e = Math.round(c);
                return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
            };
            return a;
        }
        d8(a, b) {
            if (this.l5 != null) {
                return this.l5.p(a, b);
            }
            return this.l4.p(a, b);
        }
        eb(a, b) {
            if (this.l5 != null) {
                return this.l5.q(a, b);
            }
            return this.l4.q(a, b);
        }
        g5(a, b, c, d) {
            if (this.l5 != null) {
                this.l5.v(a, b, c, d);
                return;
            }
            this.l4.v(a, b, c, d);
        }
        g4(a, b, c, d, e) {
            if (this.l5 != null) {
                this.l5.u(a, b, c, d, e);
                return;
            }
            this.l4.u(a, b, c, d, e);
        }
        g6(a, b, c, d) {
            if (this.l5 != null) {
                this.l5.j(a, b, c, d);
                return;
            }
            this.l4.j(a, b, c, d);
        }
        mn(a, b) {
            if (this.bh == null || a == NaN || b == NaN) {
                return;
            }
            let c = this.ma(a, this);
            let d = this.ma(b, this);
            if (c == NaN || d == NaN) {
                return;
            }
            this.bh.pw = new Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        }
        j7(a, b, c, d) {
            let e = d;
            let f = super.j7(a, b, c, d);
            let g = new ScalerParams(0, b, a, this.cc, c);
            let h = NaN;
            let i = NaN;
            if (!this.cc && b.right == 1) {
                i = this.ku;
            }
            else if (this.cc && b.left == 0) {
                h = this.ku;
            }
            if (isNaN_(h)) {
                h = this.eb(e.left, g);
            }
            if (isNaN_(i)) {
                i = this.eb(e.right, g);
            }
            let j = Math.min(h, i);
            let k = Math.max(h, i);
            this.ky = j;
            this.kx = k;
            f.k.add(((() => {
                let $ret = new RangeInfo();
                $ret.d = j;
                $ret.c = k;
                $ret.b = e.width;
                return $ret;
            })()));
            return f;
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = !b.isEmpty ? this.js : Rect.empty;
            let d = this.jn();
            let e = this.jm();
            let f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        }
        h3(a, b) {
            super.h3(a, b);
            if (b.height != a.height) {
                this.cv();
            }
        }
        get_a1() {
            return 0;
        }
        get a1() {
            return this.get_a1();
        }
        j9() {
            if (this.kk) {
                return new HorizontalLogarithmicScaler();
            }
            switch (this.l3) {
                case 0: return new FastHorizontalLinearScaler();
                case 1: return new HorizontalLogarithmicScaler();
            }
            return null;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
    }
    NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericXAxis;
})();
/**
 * @hidden
 */
export let NumericXAxisView = /*@__PURE__*/ (() => {
    class NumericXAxisView extends StraightNumericAxisBaseView {
        constructor(a) {
            super(a);
            this.bi = null;
            this.bi = a;
        }
        ag() {
            super.ag();
            this.a.jb = AxisDefaults.h;
        }
    }
    NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
    return NumericXAxisView;
})();
//# sourceMappingURL=NumericXAxis_combined.js.map
