/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarBase } from "./PolarBase";
import { markType } from "igniteui-angular-core";
import { PolarBaseView } from "./PolarBaseView";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PolarScatterSeries = /*@__PURE__*/ (() => {
    class PolarScatterSeries extends PolarBase {
        constructor() {
            super();
            this.ab = PolarScatterSeries.$;
        }
        get_c0() {
            return true;
        }
        bu() {
            return new PolarScatterSeriesView(this);
        }
        lh(a) {
            super.lh(a);
            this.t4 = a;
        }
        gi() {
            return 0.7;
        }
        pl() {
            if (this.pk == 0) {
                return 2;
            }
            return super.pl();
        }
    }
    PolarScatterSeries.$t = markType(PolarScatterSeries, 'PolarScatterSeries', PolarBase.$);
    return PolarScatterSeries;
})();
/**
 * @hidden
 */
export let PolarScatterSeriesView = /*@__PURE__*/ (() => {
    class PolarScatterSeriesView extends PolarBaseView {
        constructor(a) {
            super(a);
            this.c3 = null;
            this.c3 = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.c3.pr = Defaults.e;
            }
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 2;
            this.e.gl = 2;
            this.e.e1 = false;
        }
    }
    PolarScatterSeriesView.$t = markType(PolarScatterSeriesView, 'PolarScatterSeriesView', PolarBaseView.$);
    return PolarScatterSeriesView;
})();
//# sourceMappingURL=PolarScatterSeries_combined.js.map
