/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { StandardDeviationIndicatorStrategy } from "./StandardDeviationIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let StandardDeviationIndicator = /*@__PURE__*/ (() => {
    class StandardDeviationIndicator extends StrategyBasedIndicator {
        get_tv() {
            return new StandardDeviationIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return StandardDeviationIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(StandardDeviationIndicator.uh));
        }
        set ug(a) {
            this.h(StandardDeviationIndicator.uh, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
    }
    StandardDeviationIndicator.$t = markType(StandardDeviationIndicator, 'StandardDeviationIndicator', StrategyBasedIndicator.$);
    StandardDeviationIndicator.uh = StrategyBasedIndicator.ud(20, StandardDeviationIndicator.$);
    return StandardDeviationIndicator;
})();
//# sourceMappingURL=StandardDeviationIndicator.js.map
