/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Boolean_$type, typeCast, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type, markDep } from "igniteui-angular-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "igniteui-angular-core";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { LineGeometry } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { ArcSegment } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
var AngleAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AngleAxisLabelPanel, _super);
    function AngleAxisLabelPanel() {
        var _this = _super.call(this) || this;
        _this.c2 = false;
        _this.c8 = null;
        _this.c6 = 0;
        _this.c3 = 0;
        _this.c5 = 0;
        _this.c4 = 0;
        return _this;
    }
    AngleAxisLabelPanel.prototype.ad = function () {
        return new AngleAxisLabelPanelView(this);
    };
    AngleAxisLabelPanel.prototype.cc = function (a) {
        _super.prototype.cc.call(this, a);
        this.c1 = a;
    };
    AngleAxisLabelPanel.prototype.aq = function (a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.js.isEmpty) {
            return _super.prototype.aq.call(this, a, b);
        }
        return true;
    };
    AngleAxisLabelPanel.prototype.a1 = function () {
        var a = new List$1(Rect.$, 0);
        var b = new List$1(Boolean_$type, 0);
        if (this.a7.count != this.a6.count) {
            return a;
        }
        this.c1.ay(a, b);
        var c = false;
        this.an = this.am(a, b);
        if (!this.ac.b3()) {
            c = true;
            this.bd = this.c6 / 2;
            this.bd = this.bd + this.c7();
        }
        else {
            c = true;
            this.c1.ac();
        }
        if (c) {
            for (var d = 0; d < a.count; d++) {
                var e = this.a7._inner[d];
                var f = this.a6._inner[d];
                var g = a._inner[d];
                var h = this.c8(f.c);
                var i = h.x - this.bg(e) / 2;
                var j = h.y - this.bf(e) / 2;
                g.x = i;
                g.y = j;
                a._inner[d] = g;
            }
        }
        return a;
    };
    AngleAxisLabelPanel.prototype.c7 = function () {
        var a;
        var b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.bh);
        }
        if (a == null || b == null) {
            return 0;
        }
        var c = new List$1(Axis.$, 0);
        for (var d = 0; d < a.axes.count; d++) {
            var e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.av) !== null && e.av.a7.count > 0 && (!e.b3()) && !e.b1() && (e.ai == null || this.ac.ai == null || e.ai.ma == b.ai.ma)) {
                c.add(e);
            }
        }
        var f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        var g = 0;
        var h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].av.bd;
            g += c._inner[f].av.bd * 2 + h;
        }
        return g;
    };
    AngleAxisLabelPanel.prototype.ah = function () {
        return 4;
    };
    AngleAxisLabelPanel.prototype.au = function (a) {
        return a == 4 || a == 5;
    };
    AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
    return AngleAxisLabelPanel;
}(AxisLabelPanelBase));
export { AngleAxisLabelPanel };
/**
 * @hidden
 */
var CategoryAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAngleAxis, _super);
    function CategoryAngleAxis() {
        var _this = _super.call(this) || this;
        _this.lt = null;
        _this.lq = null;
        _this.lu = false;
        _this.ly = NaN;
        _this.lr = null;
        _this.lz = 0;
        _this.lw = 0;
        _this.lx = 0;
        _this.ma = 1;
        _this.ab = CategoryAngleAxis.$;
        _this.lq = _this.lp();
        _this.lt = new PolarAxisRenderingManager();
        return _this;
    }
    CategoryAngleAxis.prototype.a3 = function () {
        return new CategoryAngleAxisView(this);
    };
    CategoryAngleAxis.prototype.ha = function (a) {
        _super.prototype.ha.call(this, a);
        this.lo = a;
    };
    CategoryAngleAxis.prototype.get_b4 = function () {
        return true;
    };
    CategoryAngleAxis.prototype.au = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.c8 = function (b) {
            var c = _this.bh != null ? _this.bh.pg : Rect.empty;
            var d = !c.isEmpty ? _this.js : Rect.empty;
            return _this.mn(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.av.bd);
        };
        return a;
    };
    CategoryAngleAxis.prototype.l8 = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    CategoryAngleAxis.prototype.lp = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new AxisLabelManager();
            $ret.a = _this;
            $ret.f = _this.c6;
            $ret.e = _this.c5;
            $ret.b = _this.av;
            return $ret;
        })());
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        var b = new CategoryAxisRenderer(a);
        b.u = function () {
            var c = _this.a4.ay();
            var d = _this.a4.a1();
            var e = _this.a4.az();
            var f = _this.a4.a0();
            _this.h0();
            _this.g0(c);
            _this.g0(d);
            _this.g0(e);
            _this.g0(f);
        };
        b.o = function (c, d) { return !d.isEmpty && !c.isEmpty && _this.ls != null; };
        b.d = function (c, d, e, f) { return _this.ln(c, d, e, f); };
        b.v = function () {
            if (!_this.lu) {
                _this.lu = true;
                _this.ls.cv();
                _this.lu = false;
            }
        };
        b.g = function (c) {
            var d = typeGetValue(c);
            if (d > _this.j6.count - 1) {
                d -= _this.j6.count;
            }
            var e = _this.j6.item(d);
            return _this.fi(e);
        };
        b.b.c = function (c) {
            var e_1, _a;
            if ((_this.ay == null || _this.ay.visibility == 0) && _this.ls != null && _this.ly != c) {
                var d = typeCast(XamDataChart.$, _this.bh);
                if (d == null) {
                    return;
                }
                _this.ly = c;
                _this.av.bc = c;
                d.jq();
                try {
                    for (var _b = __values(fromEnum(d.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        if (e != _this && typeCast(AngleAxisLabelPanel.$, e.av) !== null) {
                            e.a4.ad();
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        b.k = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            _this.lt.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = function (c, d, e, f) {
            var g = typeCast(RadialAxisRenderingParameters.$, c);
            _this.lt.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = function (c, d) { return _this.getScaledAngle(d); };
        b.q = function (c, d) {
            if (_this.l8(d - _this.lz) < 0) {
                return false;
            }
            if (_this.l8(d - _this.lz - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = function (c) {
            var d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                _this.lt.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = function (c) {
            c.n = _this.l2();
            c.r = c.n;
        };
        b.p = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            var g = _this.mn(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = function (c, d, e, f) {
            var g = c.y;
            var h = new ScalerParams(0, c.aa, c.z, _this.cc, g);
            var i = d;
            if (_this.categoryMode != 0) {
                var j = (e * f) + 1;
                j = Math.min(j, _this.kq);
                var k = _this.d8(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.l5);
        return b;
    };
    CategoryAngleAxis.prototype.mn = function (a, b, c, d, e) {
        var f = this.l2();
        var g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    CategoryAngleAxis.prototype.l2 = function () {
        if (this.ls == null) {
            return 0;
        }
        if (!this.b1()) {
            return this.ls.mf();
        }
        else {
            return this.ls.mg((this.fe));
        }
    };
    CategoryAngleAxis.prototype.ln = function (a, b, c, d) {
        if (this.j6 == null) {
            return null;
        }
        var e = new RadialAxisRenderingParameters();
        var f = this.j6.count - 1;
        var g = this.a4.ay();
        var h = this.a4.a1();
        var i = this.a4.az();
        var j = this.a4.a0();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.lv();
        e.p = this.l6;
        e.o = this.el();
        e.q = this.l7;
        e.s = this.fj;
        var k = this.lt.f(b);
        var l = this.lt.g(b);
        var m = 0.5 * this.ls.ma;
        var n = 0.5 * this.ls.l9;
        var o = k;
        var p = l;
        var q = this.ls.mf();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        var r = a.width;
        this.lt.k(b, e, 0, this.j6.count, this.cc, runOn(this, this.getUnscaledAngle), r);
        var s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.j6.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.cc;
        e.af = this.ks;
        e.f = new CategoryTickmarkValues();
        e.j = this.cs;
        return e;
    };
    CategoryAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.lt.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    CategoryAngleAxis.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.hq(false);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "ls", {
        get: function () {
            if (this.lr != null) {
                return this.lr;
            }
            var a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.lr;
        },
        set: function (a) {
            this.lr = a;
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.aj = function () {
        return this.ls;
    };
    CategoryAngleAxis.prototype.getCategorySize = function (a, b, c) {
        return 2 * Math.PI / this.kq;
    };
    CategoryAngleAxis.prototype.ki = function (a, b, c) {
        var d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.km)) {
            e = Math.min(this.km, 1);
        }
        var f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.ks - (this.ks - 1) * e);
    };
    CategoryAngleAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.ks > 1) {
            var f = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.km)) {
                g = Math.min(this.km, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.ks - (this.ks - 1) * g);
            var j = (h - i) / (this.ks - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryAngleAxis.prototype.l5 = function (a) {
        var b = 0.5;
        if (this.ks > 1) {
            var c = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            var d = 0;
            if (!isNaN_(this.km)) {
                d = Math.min(this.km, 1);
            }
            var e = 1 - 0.5 * c;
            var f = e / (this.ks - (this.ks - 1) * d);
            var g = (e - f) / (this.ks - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    };
    CategoryAngleAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = !b.isEmpty ? this.js : Rect.empty;
        var d = this.jn();
        var e = this.jm();
        var f = this.lq.c(a, c, b, d, e);
        if (f != null) {
            this.l0 = f.f.m;
            this.l1 = f.f.l;
        }
    };
    CategoryAngleAxis.prototype.l4 = function (a, b) {
        var c;
        var d;
        var e = this.lt.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.cc) {
                return this.kq;
            }
            else {
                return 0;
            }
        }
        var f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.kq) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.l3 = function (a, b) {
        var c;
        var d;
        var e = this.lt.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.cc) {
                return 0;
            }
            else {
                return this.kq;
            }
        }
        var f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.kq) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.getScaledAngle = function (a) {
        var b = this.kq;
        var c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.cd) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.lz;
    };
    CategoryAngleAxis.prototype.getUnscaledAngle = function (a) {
        if (a < this.lz) {
            a += 2 * Math.PI;
        }
        var b = (a - this.lz) / (2 * Math.PI);
        if (this.cc) {
            b = 1 - b;
        }
        return b * (this.kq);
    };
    CategoryAngleAxis.prototype.d8 = function (a, b) {
        return this.getScaledAngle(a);
    };
    CategoryAngleAxis.prototype.eb = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    CategoryAngleAxis.prototype.he = function (a, b, c, d) {
        var e_2, _a, e_3, _b, e_4, _c;
        _super.prototype.he.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.mj(f);
                if (f != null) {
                    f.mp(this);
                }
                this.ck = true;
                this.hq(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.lz = this.l9;
                while (this.lz < 0) {
                    this.lz += 360;
                }
                while (this.lz >= 360) {
                    this.lz -= 360;
                }
                this.lz = (this.lz * Math.PI) / 180;
                this.ck = true;
                this.hq(false);
                try {
                    for (var _d = __values(fromEnum(this.c7)), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var g = _e.value;
                        g.l0(false);
                        g.k7();
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _f = __values(fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var h = _g.value;
                            h.ck = true;
                            h.hp();
                        }
                    }
                    catch (e_3_1) {
                        e_3 = { error: e_3_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_3)
                                throw e_3.error;
                        }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _h = __values(fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var i = _j.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.ck = true;
                                i.hp();
                            }
                        }
                    }
                    catch (e_4_1) {
                        e_4 = { error: e_4_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_4)
                                throw e_4.error;
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.lq = this.lp();
                this.mh();
                this.ck = true;
                this.hq(false);
                break;
        }
    };
    CategoryAngleAxis.prototype.mh = function () {
        this.ly = NaN;
    };
    CategoryAngleAxis.prototype.mj = function (a) {
        this.ls = a;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "l6", {
        get: function () {
            return this.c(CategoryAngleAxis.mk);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.mk, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "l0", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            if (this.l0 != a) {
                var b = this.lw;
                this.lw = a;
                this.hk("ActualInterval", b, this.l0);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.ej = function () {
        return this.l0;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "l7", {
        get: function () {
            return this.c(CategoryAngleAxis.ml);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.ml, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "l1", {
        get: function () {
            return this.lx;
        },
        set: function (a) {
            if (this.l1 != a) {
                var b = this.lx;
                this.lx = a;
                this.hk("ActualMinorInterval", b, this.l1);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.lv = function () {
        return !isNaN_(this.l6);
    };
    CategoryAngleAxis.prototype.get_a1 = function () {
        return 2;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.cx = function () {
        if (this.ck && this.cy) {
            this.bb = this.ba();
        }
        if (this.j6 == null) {
            return false;
        }
        var a = this.j6.count;
        if (a != this.mb) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.mb, a);
            this.mb = a;
            this.hl(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "mb", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            this.ma = a;
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.jk = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        var f = typeCast(RadialAxisRenderingParameters.$, this.lq.d(c, b, d, e));
        if (f == null) {
            return null;
        }
        var g = Math.cos(a);
        var h = Math.sin(a);
        var i = f.center.x + g * f.minLength;
        var j = f.center.y + h * f.minLength;
        var k = f.center.x + g * f.maxLength;
        var l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        var m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "isVertical", {
        get: function () {
            return this.cj;
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.prototype.j$c = function (a, b) {
        return this.eb.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$b = function (a, b) {
        return this.d8.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$d = function (a, b, c, d, e) {
        this.g4.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$e = function (a, b, c, d) {
        this.g5.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$f = function (a, b, c, d) {
        this.g6.apply(this, arguments);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "j$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
    CategoryAngleAxis.mk = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.hk("Interval", b.oldValue, b.newValue);
        a.hq(false);
    }));
    CategoryAngleAxis.ml = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryAngleAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryAngleAxis.$, a)).hq(false);
    }));
    CategoryAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'hk', ['StartAngleOffset:l9:mm', [1, 0]]);
    return CategoryAngleAxis;
}(CategoryAxisBase));
export { CategoryAngleAxis };
/**
 * @hidden
 */
var NumericAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAngleAxis, _super);
    function NumericAngleAxis() {
        var _this = _super.call(this) || this;
        _this.l6 = null;
        _this.l7 = false;
        _this.l8 = NaN;
        _this.l9 = 0;
        _this.l4 = null;
        _this.ab = NumericAngleAxis.$;
        _this.l6 = new PolarAxisRenderingManager();
        _this.j6 = _this.j4();
        return _this;
    }
    NumericAngleAxis.prototype.a3 = function () {
        return new NumericAngleAxisView(this);
    };
    NumericAngleAxis.prototype.ha = function (a) {
        _super.prototype.ha.call(this, a);
        this.l3 = a;
    };
    NumericAngleAxis.prototype.get_b4 = function () {
        return true;
    };
    NumericAngleAxis.prototype.au = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.c8 = function (b) {
            var c = _this.bh != null ? _this.bh.pg : Rect.empty;
            var d = !c.isEmpty ? _this.js : Rect.empty;
            return _this.mj(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.av.bd);
        };
        return a;
    };
    NumericAngleAxis.prototype.ma = function () {
        if (this.l5 == null) {
            return 0;
        }
        if (!this.b1()) {
            return this.l5.mf();
        }
        else {
            return this.l5.mg((this.fe));
        }
    };
    NumericAngleAxis.prototype.mc = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    NumericAngleAxis.prototype.j4 = function () {
        var _this = this;
        var a = _super.prototype.j4.call(this);
        a.b.c = function (b) {
            var e_5, _a;
            if ((_this.ay == null || _this.ay.visibility == 0) && _this.l5 != null && _this.l8 != b) {
                var c = typeCast(XamDataChart.$, _this.bh);
                if (c == null) {
                    return;
                }
                _this.l8 = b;
                _this.av.bc = b;
                c.jq();
                try {
                    for (var _b = __values(fromEnum(c.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        if (d != _this && typeCast(AngleAxisLabelPanel.$, d.av) !== null) {
                            d.a4.ad();
                        }
                    }
                }
                catch (e_5_1) {
                    e_5 = { error: e_5_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_5)
                            throw e_5.error;
                    }
                }
            }
        };
        a.e = function (b) {
            b.n = _this.ma();
            b.r = b.n;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                _this.l6.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.l6.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.l6.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, _this.j7(b, c, d, e));
            return f;
        };
        a.v = function () {
            if (!_this.l7) {
                _this.l7 = true;
                _this.l5.cv();
                _this.l7 = false;
            }
        };
        a.m = function (b, c) { return _this.getScaledAngle(c); };
        a.o = function (b, c) { return !c.isEmpty && !b.isEmpty && _this.l5 != null; };
        a.q = function (b, c) {
            if (_this.mc(c - _this.l9) < 0) {
                return false;
            }
            if (_this.mc(c - _this.l9 - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            var f = _this.mj(_this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            var g = _this.mj(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = function (b, c, d, e) {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericAngleAxis.prototype.mj = function (a, b, c, d, e) {
        var f = this.ma();
        var g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    NumericAngleAxis.prototype.d8 = function (a, b) {
        return this.getScaledAngle(a);
    };
    NumericAngleAxis.prototype.getScaledAngle1 = function (a, b, c) {
        var d = 0;
        if (b) {
            d = (Math.log(a) - this.k1) / (this.k0 - this.k1);
        }
        else {
            d = (a - this.kv) / (this.ku - this.kv);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.l9;
    };
    NumericAngleAxis.prototype.getScaledAngle = function (a) {
        return this.getScaledAngle1(a, this.kl, this.cd);
    };
    NumericAngleAxis.prototype.eb = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    NumericAngleAxis.prototype.getUnscaledAngle = function (a) {
        var b = (a - this.l9) / (2 * Math.PI);
        if (this.cc) {
            b = 1 - b;
        }
        if (this.kl) {
            return Math.exp(b * (this.k0 - this.k1) + this.k1);
        }
        else {
            return this.kv + b * (this.ku - this.kv);
        }
    };
    NumericAngleAxis.prototype.he = function (a, b, c, d) {
        var e_6, _a, e_7, _b, e_8, _c;
        _super.prototype.he.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.mh(f);
                if (f != null) {
                    f.mp(this);
                }
                this.hq(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.l9 = this.md;
                while (this.l9 < 0) {
                    this.l9 += 360;
                }
                while (this.l9 >= 360) {
                    this.l9 -= 360;
                }
                this.l9 = (this.md * Math.PI) / 180;
                this.hq(false);
                try {
                    for (var _d = __values(fromEnum(this.c4())), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var g = _e.value;
                        g.l0(false);
                        g.k7();
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _f = __values(fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var h = _g.value;
                            h.hp();
                        }
                    }
                    catch (e_7_1) {
                        e_7 = { error: e_7_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_7)
                                throw e_7.error;
                        }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _h = __values(fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var i = _j.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.hp();
                            }
                        }
                    }
                    catch (e_8_1) {
                        e_8 = { error: e_8_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_8)
                                throw e_8.error;
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.j6 = this.j4();
                this.mf();
                this.ck = true;
                this.hq(false);
                break;
        }
    };
    NumericAngleAxis.prototype.mf = function () {
        this.l8 = NaN;
    };
    NumericAngleAxis.prototype.j8 = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericAngleAxis.prototype.j7 = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.j7.call(this, a, b, c, d));
        var f = this.l6.f(b);
        var g = this.l6.g(b);
        var h = 0.5 * this.l5.ma;
        var i = 0.5 * this.l5.l9;
        var j = f;
        var k = g;
        var l = this.l5.mf();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        var m = a.width;
        this.l6.k(b, e, this.kv, this.ku, this.cc, runOn(this, this.getUnscaledAngle), m);
        var n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    };
    NumericAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.l6.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    NumericAngleAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = !b.isEmpty ? this.js : Rect.empty;
        var d = this.jn();
        var e = this.jm();
        var f = this.j6.c(a, c, b, d, e);
        if (f != null) {
            this.kt = f.f.m;
            this.kw = f.f.l;
        }
    };
    Object.defineProperty(NumericAngleAxis.prototype, "l5", {
        get: function () {
            if (this.l4 != null) {
                return this.l4;
            }
            var a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (a.axes._inner[b].cg) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.l4;
        },
        set: function (a) {
            this.l4 = a;
        },
        enumerable: false,
        configurable: true
    });
    NumericAngleAxis.prototype.aj = function () {
        return this.l5;
    };
    NumericAngleAxis.prototype.mh = function (a) {
        this.l5 = a;
    };
    NumericAngleAxis.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cv();
        }
    };
    NumericAngleAxis.prototype.get_a1 = function () {
        return 2;
    };
    Object.defineProperty(NumericAngleAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    NumericAngleAxis.prototype.jk = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        if (this.l5 == null) {
            return null;
        }
        var f = typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
        if (f == null) {
            return null;
        }
        var g = Math.cos(a);
        var h = Math.sin(a);
        var i = f.center.x + g * f.minLength;
        var j = f.center.y + h * f.minLength;
        var k = f.center.x + g * f.maxLength;
        var l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        var m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    };
    NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
    NumericAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'hk', ['StartAngleOffset:md:mi', [1, 0]]);
    return NumericAngleAxis;
}(NumericAxisBase));
export { NumericAngleAxis };
/**
 * @hidden
 */
var NumericRadiusAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericRadiusAxis, _super);
    function NumericRadiusAxis() {
        var _this = _super.call(this) || this;
        _this.l6 = null;
        _this.l7 = false;
        _this.l8 = NaN;
        _this.ma = 0;
        _this.l9 = 0;
        _this.mc = 0;
        _this.l3 = null;
        _this.ab = NumericRadiusAxis.$;
        _this.ma = _this.mk;
        _this.l9 = _this.mj;
        _this.l6 = new PolarAxisRenderingManager();
        _this.j6 = _this.j4();
        return _this;
    }
    NumericRadiusAxis.prototype.a3 = function () {
        return new NumericRadiusAxisView(this);
    };
    NumericRadiusAxis.prototype.ha = function (a) {
        _super.prototype.ha.call(this, a);
        this.l5 = a;
    };
    NumericRadiusAxis.prototype.get_cg = function () {
        return true;
    };
    NumericRadiusAxis.prototype.d7 = function () {
        var a = this.ma;
        var b = this.l9;
        var c = Math.min(this.me(), this.md()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    };
    NumericRadiusAxis.prototype.me = function () {
        return this.js.width;
    };
    NumericRadiusAxis.prototype.md = function () {
        return this.js.height;
    };
    NumericRadiusAxis.prototype.au = function () {
        return new RadialAxisLabelPanel();
    };
    NumericRadiusAxis.prototype.mb = function (a) {
        if (a == null) {
            return 0;
        }
        return a;
    };
    NumericRadiusAxis.prototype.j4 = function () {
        var _this = this;
        var a = _super.prototype.j4.call(this);
        a.b.c = function (b) {
            if ((_this.ay == null || _this.ay.visibility == 0) && _this.l4 != null) {
                if ((_this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5)) && _this.l8 != b) {
                    _this.l8 = b;
                    _this.av.bc = b;
                    _this.bh.jq();
                }
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.l6.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = function (b, c, d, e) {
            if (d == e) {
                return;
            }
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.l6.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = function (b, c) { return _this.mg(c); };
        a.q = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            _this.l6.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = function (b) {
            b.n = _this.ay == null || (_this.ay.c == 4 || _this.ay.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (_this.mb(_this.fe) * Math.PI) / 180;
            if (_this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                var d = typeCast(RadialAxisLabelPanel.$, _this.av);
                if (d != null) {
                    var e = 0;
                    if (_this.ay != null && _this.ay.c == 4) {
                        e = 1;
                    }
                    d.dq = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.dm = c.crossingAngleRadians;
                }
            }
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            if (_this.l4 == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            var f = false;
            f = _this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5);
            var g = 0;
            if (f) {
                g = _this.mc;
            }
            var h = e.center.x + c * Math.cos(g);
            var i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = function (b, c, d, e) {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericRadiusAxis.prototype.d8 = function (a, b) {
        return this.mg(a);
    };
    NumericRadiusAxis.prototype.mh = function (a, b, c, d, e) {
        var f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.kv) - this.k1) / (this.k0 - this.k1);
            }
            else {
                f = (Math.log(a) - this.k1) / (this.k0 - this.k1);
            }
        }
        else {
            f = (a - this.kv) / (this.ku - this.kv);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    };
    NumericRadiusAxis.prototype.mg = function (a) {
        return this.mh(a, this.kl, this.cd, this.ma, this.l9);
    };
    NumericRadiusAxis.prototype.mi = function (a) {
        var b = a * 2;
        b = (b - this.l9) / (this.ma - this.l9);
        if (this.cc) {
            b = 1 - b;
        }
        if (this.kl) {
            return Math.exp(b * (this.k0 - this.k1) + this.k1);
        }
        else {
            return this.kv + b * (this.ku - this.kv);
        }
    };
    NumericRadiusAxis.prototype.eb = function (a, b) {
        return this.mi(a);
    };
    NumericRadiusAxis.prototype.he = function (a, b, c, d) {
        var e_9, _a, e_10, _b;
        switch (b) {
            case "CrossingValue":
                this.mc = this.mb(this.fe) * Math.PI / 180;
                break;
        }
        _super.prototype.he.call(this, a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.ma = this.mk;
                if (this.ma < 0) {
                    this.ma = 0.1;
                }
                if (this.ma > 1) {
                    this.ma = 1;
                }
                if (this.l9 >= this.ma) {
                    this.l9 = this.ma - 0.01;
                    if (this.l9 < 0) {
                        this.l9 = 0;
                        this.ma = 0.01;
                    }
                }
                this.ck = true;
                this.hq(false);
                if (this.l4 != null) {
                    this.l4.hp();
                }
                try {
                    for (var _c = __values(fromEnum(this.c4())), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        e.l0(false);
                    }
                }
                catch (e_9_1) {
                    e_9 = { error: e_9_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_9)
                            throw e_9.error;
                    }
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.l9 = this.mj;
                if (this.l9 < 0) {
                    this.l9 = 0.1;
                }
                if (this.l9 > 1) {
                    this.l9 = 1;
                }
                if (this.l9 >= this.ma) {
                    this.l9 = this.ma - 0.01;
                    if (this.l9 < 0) {
                        this.l9 = 0;
                        this.ma = 0.01;
                    }
                }
                this.ck = true;
                this.hq(false);
                if (this.l4 != null) {
                    this.l4.hp();
                }
                try {
                    for (var _e = __values(fromEnum(this.c4())), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var f = _f.value;
                        f.et = true;
                        f.l0(false);
                    }
                }
                catch (e_10_1) {
                    e_10 = { error: e_10_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_10)
                            throw e_10.error;
                    }
                }
                if (this.bh != null) {
                    this.bh.jz();
                }
                break;
            case "CrossingAxis":
                var g = typeCast(NumericAngleAxis.$, d);
                var h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.mp(null);
                }
                if (g != null) {
                    this.mp(g);
                    g.mh(this);
                }
                if (h != null) {
                    this.mp(h);
                    h.mj(this);
                }
                this.ck = true;
                this.hq(false);
                break;
            case "IsInverted":
                if (this.l4 != null) {
                    this.l4.ck = true;
                    this.l4.hq(false);
                }
                break;
        }
    };
    NumericRadiusAxis.prototype.mp = function (a) {
        this.l4 = a;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "l4", {
        get: function () {
            if (this.l3 != null) {
                return this.l3;
            }
            var a = typeCast(XamDataChart.$, this.bh);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.l3;
        },
        set: function (a) {
            this.l3 = a;
        },
        enumerable: false,
        configurable: true
    });
    NumericRadiusAxis.prototype.aj = function () {
        return this.l4;
    };
    NumericRadiusAxis.prototype.j8 = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericRadiusAxis.prototype.j7 = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.j7.call(this, a, b, c, d));
        var f = this.l6.f(b);
        var g = this.l6.g(b);
        var h = 0.5 * this.ma;
        var i = 0.5 * this.l9;
        var j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.ps)) {
            k = this.ku;
            j = this.kv;
        }
        else {
            k = Math.min(g, h);
            j = this.mi(f);
            k = this.mi(k);
            var l = this.mq(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        var m = { $type: Point_$type, x: 0.5, y: 0.5 };
        var n = f;
        var o = g;
        var p = Math.min(a.width, a.height) * (this.ma - this.l9) / 2;
        e.center = m;
        var q = Math.max(o, n);
        var r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        var s = Math.min(j, k);
        var t = Math.max(j, k);
        if (s < this.kv) {
            s = this.kv;
        }
        if (t > this.ku) {
            t = this.ku;
        }
        this.ky = s;
        this.kx = t;
        e.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        var u = typeCast(IAngleScaler_$type, this.l4);
        if (u != null) {
            var v = void 0;
            var w = void 0;
            var x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        var y = this.mf();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.kb;
        var z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.ml(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    };
    NumericRadiusAxis.prototype.mq = function (a, b, c, d) {
        var e = { $type: Point_$type, x: 0.5, y: 0.5 };
        var f = 0;
        if (this.cc) {
            f = this.mg(this.kv);
        }
        else {
            f = this.mg(this.ku);
        }
        var g = 0;
        if (this.fe != null) {
            g = this.mc;
        }
        var h = e.x + f * Math.cos(g);
        var i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.cc) {
                d = this.kv;
            }
            else {
                d = this.ku;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.cc) {
                c = this.ku;
            }
            else {
                c = this.kv;
            }
        }
        return {
            p2: c,
            p3: d
        };
    };
    NumericRadiusAxis.prototype.ml = function (a, b, c, d, e) {
        var f = ViewportUtils.d(c - b, d, e);
        var g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    };
    NumericRadiusAxis.prototype.mf = function () {
        var a = 0;
        if (!this.cc) {
            a = this.mg(this.ku);
        }
        else {
            a = this.mg(this.kv);
        }
        return a;
    };
    NumericRadiusAxis.prototype.lt = function (a) {
        if (this.l4 != null) {
            this.l4.hp();
        }
    };
    NumericRadiusAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = !b.isEmpty ? this.js : Rect.empty;
        var d = this.jn();
        var e = this.jm();
        var f = this.j6.c(a, c, b, d, e);
        if (f != null) {
            this.kt = f.f.m;
            this.kw = f.f.l;
        }
    };
    NumericRadiusAxis.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cv();
        }
    };
    NumericRadiusAxis.prototype.mo = function (a, b, c, d, e) {
        var f = typeCast(IPolarRadialRenderingParameters_$type, this.j7(b, c, d, e));
        if (f == null) {
            return;
        }
        this.l6.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    };
    NumericRadiusAxis.prototype.get_a1 = function () {
        return 3;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    NumericRadiusAxis.prototype.jk = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        var f = typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
        var g = a;
        var h = new PathGeometry();
        var i = ViewportUtils.d(g, b, c);
        var j = ViewportUtils.g(g, b, c);
        if (i <= 0 || j <= 0) {
            return null;
        }
        var k = ViewportUtils.c(f.center.x, b, c);
        var l = ViewportUtils.f(f.center.y, b, c);
        if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
            var m = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
            var n_1 = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
            var o = new PathFigure();
            o._startPoint = m;
            o._isClosed = false;
            o._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = n_1;
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(o);
        }
        else {
            var p = new PathFigure();
            p._startPoint = { $type: Point_$type, x: k, y: l - j };
            p._isClosed = true;
            p._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l + j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            p._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l - j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(p);
        }
        return h;
    };
    NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
    NumericRadiusAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'hk', ['InnerRadiusExtentScale:mj:mr', [1, 0], 'RadiusExtentScale:mk:ms', [1, 0.75]]);
    return NumericRadiusAxis;
}(NumericAxisBase));
export { NumericRadiusAxis };
/**
 * @hidden
 */
var AngleAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AngleAxisLabelPanelView, _super);
    function AngleAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.ax = null;
        _this.ax = a;
        return _this;
    }
    AngleAxisLabelPanelView.prototype.am = function () {
        _super.prototype.am.call(this);
        this.ax.c2 = true;
    };
    AngleAxisLabelPanelView.prototype.ay = function (a, b) {
        this.ax.c6 = -1.7976931348623157E+308;
        this.ax.c3 = -1.7976931348623157E+308;
        this.ax.c5 = -1.7976931348623157E+308;
        this.ax.c4 = -1.7976931348623157E+308;
        for (var c = 0; c < this.a.a7.count; c++) {
            var d = this.a.a7._inner[c];
            var e = this.a.a6._inner[c];
            var f = e.a;
            var g = this.ax.c8(e.c);
            var h = this.m(d);
            var i = this.l(d);
            var j = h + this.p() + this.q();
            var k = i + this.r() + this.o();
            var l = g.x - j / 2;
            var m = g.y - k / 2;
            this.ax.c5 = Math.max(h, this.ax.c5);
            this.ax.c4 = Math.max(i, this.ax.c4);
            this.ax.c6 = Math.max(j, this.ax.c6);
            this.ax.c3 = Math.max(k, this.ax.c3);
            var n = new Rect(0, l, m, j, k);
            a.add(n);
            b.add(f);
        }
    };
    AngleAxisLabelPanelView.prototype.o = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.p = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.q = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.r = function () {
        return 0;
    };
    AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
    return AngleAxisLabelPanelView;
}(AxisLabelPanelBaseView));
export { AngleAxisLabelPanelView };
/**
 * @hidden
 */
var CategoryAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAngleAxisView, _super);
    function CategoryAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryAngleAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.jb = AxisDefaults.h;
        this.a.je = AxisDefaults.g;
    };
    CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
    return CategoryAngleAxisView;
}(CategoryAxisBaseView));
export { CategoryAngleAxisView };
/**
 * @hidden
 */
var NumericAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAngleAxisView, _super);
    function NumericAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    NumericAngleAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.jb = AxisDefaults.h;
        this.a.je = AxisDefaults.g;
    };
    NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
    return NumericAngleAxisView;
}(NumericAxisBaseView));
export { NumericAngleAxisView };
/**
 * @hidden
 */
var NumericRadiusAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericRadiusAxisView, _super);
    function NumericRadiusAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    NumericRadiusAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.jb = AxisDefaults.h;
        this.a.je = AxisDefaults.g;
    };
    NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
    return NumericRadiusAxisView;
}(NumericAxisBaseView));
export { NumericRadiusAxisView };
//# sourceMappingURL=AngleAxisLabelPanel_combined.js.map
