/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.vk = null;
        _this.vj = null;
        _this.uj = null;
        _this.ub = null;
        _this.ua = null;
        _this.t9 = null;
        _this.ab = BubbleSeries.$;
        _this.rh = new ScatterFrame();
        _this.rj = new ScatterFrame();
        _this.rf = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.get_c0 = function () {
        return true;
    };
    BubbleSeries.prototype.bu = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.t7 = a;
    };
    BubbleSeries.prototype.gi = function () {
        return 0.7;
    };
    BubbleSeries.prototype.pl = function () {
        if (this.pk == 0) {
            return 2;
        }
        return _super.prototype.pl.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a0 == a;
    };
    BubbleSeries.prototype.cz = function () {
        return true;
    };
    BubbleSeries.prototype.kt = function (a) {
        _super.prototype.kt.call(this, a);
        if (this.ue != null && this.uj != null && this.uj.count > 0) {
            for (var b = 0; b < this.uj.count; b++) {
                a(this.uj._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "ud", {
        get: function () {
            return this.uf;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.vi = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.t6);
        var c = typeCast(ValueBrushScale.$, this.t6);
        var d = this.t6;
        if (b != null && this.ch != null) {
            return b.getBrush1(a, this.ch.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.uc);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.uf != null && this.uf.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.t5(this.t8).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.t5(this.t8).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.uf.count; b++) {
            if (this.t6 == null || !this.t6.isReady) {
                return false;
            }
            var c = NaN;
            if (this.uc != null) {
                c = (this.uc.item(b) - this.uc.minimum) / (this.uc.maximum - this.uc.minimum);
            }
            var d = (this.uf.item(b) - this.uf.minimum) / (this.uf.maximum - this.uf.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.qr;
            var f = this.vi(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.hk = function (a, b) {
        var c = this.ja(b);
        if (c == BubbleSeries.$$p[3]) {
            return this.hl(a, b, this.uu);
        }
        if (c == BubbleSeries.$$p[7]) {
            return this.hl(a, b, this.u0);
        }
        if (c == ScatterBase.$$p[8]) {
            return this.hl(a, b, this.so);
        }
        if (c == ScatterBase.$$p[10]) {
            return this.hl(a, b, this.ss);
        }
        if (c == BubbleSeries.$$p[0]) {
            return this.hl(a, b, this.up);
        }
        return _super.prototype.hk.call(this, a, b);
    };
    Object.defineProperty(BubbleSeries.prototype, "uf", {
        get: function () {
            return this.ub;
        },
        set: function (a) {
            if (this.ub != a) {
                var b = this.uf;
                this.ub = a;
                this.raisePropertyChanged("RadiusColumn", b, this.uf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "ue", {
        get: function () {
            return this.ua;
        },
        set: function (a) {
            if (this.ua != a) {
                var b = this.ue;
                this.ua = a;
                this.raisePropertyChanged("LabelColumn", b, this.ue);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "uc", {
        get: function () {
            return this.t9;
        },
        set: function (a) {
            if (this.t9 != a) {
                var b = this.uc;
                this.t9 = a;
                this.raisePropertyChanged("FillColumn", b, this.uc);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.sv = function (a, b, c, d, e) {
        if (c <= this.sc) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.sc;
        var g = this.ch;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.rb.d, j);
        var l = new ScalerParams(0, d, e, this.rb.e, j);
        var m = false;
        var n = 0;
        if (this.ca != null) {
            if (this.ca.ei()) {
                var o = this.ca.i1(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.rr.item(p);
            i = this_1.rs.item(p);
            var q = { $type: Point_$type, x: this_1.rb.a.d8(h, k), y: this_1.rb.b.d8(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.s3 = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.cv;
        d.m = this.uf;
        _super.prototype.s3.call(this, a, b);
        var e = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
        if (e < 1) {
            return;
        }
        c.dh();
        c.di();
    };
    BubbleSeries.prototype.u5 = function () {
        if (this.ca == null) {
            return;
        }
        if (this.a0 == null) {
            return;
        }
        if (this.a0.isItemwise) {
            var a = this.a0;
            this.a0.clearLegendItemsForSeries(this);
            this.u4();
            a.renderItemwiseContent(this);
        }
        if (this.a0.isScale) {
            var b = this.a0;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.uk = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.ul = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.uk(g, h, c, d, f);
    };
    BubbleSeries.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        if (this.uf == null || this.ch == null || this.uf.count == 0 || this.ch.count != this.uf.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.r0 = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.so == a || this.ss == a || this.u0 == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.u4 = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a0);
        if (a == null || this.ch == null) {
            return;
        }
        this.uj = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.t6);
        var c = typeCast(ValueBrushScale.$, this.t6);
        var d = this.t6;
        var e = this.t4();
        var f = e.b;
        var g = e.a;
        var h = this.ch;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.uc != null) {
                var k = this_2.uc.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.ue != null && this_2.ue.item(i) != null ? this_2.ue.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                return $ret;
            })());
            var n = this_2.mt;
            if (n == null) {
                n = this_2.bx.bl(this_2.b2);
            }
            l.ah = n;
            this_2.uj.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.kk = function (a, b, c, d) {
        _super.prototype.kk.call(this, a, b, c, d);
        if (this.t8 != null) {
            this.t8.aa();
        }
        if (this.t6 != null) {
            this.t6.x();
        }
        this.u5();
    };
    BubbleSeries.prototype.k0 = function () {
        _super.prototype.k0.call(this);
        this.u5();
    };
    BubbleSeries.prototype.k6 = function () {
        _super.prototype.k6.call(this);
        this.u5();
    };
    BubbleSeries.prototype.lm = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (this.t8 != null) {
                    this.t8.aa();
                }
                if (this.t6 != null) {
                    this.t6.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.uf);
                    c.deregisterColumn(this.uc);
                    c.deregisterColumn(this.ue);
                    this.uf = null;
                    this.uc = null;
                    this.ue = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.uf = this.ce(this.u0);
                    if (!stringIsNullOrEmpty(this.up)) {
                        this.uc = this.ce(this.up);
                    }
                    this.ue = this.cg(this.uu);
                }
                this.l0(false);
                this.u5();
                break;
            case BubbleSeries.$$p[7]:
                if (this.t8 != null) {
                    this.t8.aa();
                }
                if (this.ch != null) {
                    this.ch.deregisterColumn(this.uf);
                    this.uf = this.ce(this.u0);
                    this.u5();
                }
                break;
            case "RadiusColumn":
                if (this.t8 != null) {
                    this.t8.aa();
                }
                this.rc.cx.g$i();
                this.l0(false);
                this.k8();
                break;
            case BubbleSeries.$$p[8]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.l0(false);
                this.k7();
                break;
            case BubbleSeries.$$p[9]:
                this.l0(false);
                this.k7();
                break;
            case "DiscreteLegendItemTemplate":
                this.u5();
                break;
            case BubbleSeries.$$p[1]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.l0(false);
                this.u5();
                this.k7();
                break;
            case BubbleSeries.$$p[2]:
            case BubbleSeries.$$p[6]:
            case BubbleSeries.$$p[5]:
            case BubbleSeries.$$p[4]:
                this.l0(false);
                this.u5();
                this.k7();
                break;
            case "FillColumn":
                this.l0(false);
                this.k7();
                break;
            case BubbleSeries.$$p[0]:
                if (this.t6 != null) {
                    this.t6.x();
                }
                if (this.ch != null) {
                    this.ch.deregisterColumn(this.uc);
                    this.uc = this.ce(this.up);
                    this.u5();
                }
                break;
            case BubbleSeries.$$p[3]:
                if (this.ch != null) {
                    this.ch.deregisterColumn(this.ue);
                    this.ue = this.cg(this.uu);
                    this.u5();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.ca != null) {
                        try {
                            for (var _b = __values(fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.u5();
                break;
            case "SeriesViewer":
                this.u5();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.uf != null) {
            a.b = this.uf.minimum;
            a.a = this.uf.maximum;
        }
        if (this.t8 != null) {
            this.t8.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.uc != null) {
            a.b = this.uc.minimum;
            a.a = this.uc.maximum;
        }
        if (this.t6 != null) {
            this.t6.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.t5 = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.uf != null) {
            b.b = this.uf.minimum;
            b.a = this.uf.maximum;
        }
        if (a != null) {
            a.x();
            if (this.ui) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.t4 = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.uc != null) {
            a.b = this.uc.minimum;
            a.a = this.uc.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.t6);
        if (b != null) {
            b.s();
            if (this.ug && this.t6.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.u7 = function (a, b, c, d) {
        var e = c.width;
        if (!this.bx.bu.isEmpty) {
            e = this.bx.bu.width;
        }
        else if (this.ca != null && !this.ca.pv.isEmpty) {
            e = this.ca.pv.width;
        }
        var f = DeviceUtils.c(e);
        var g = this.t8 || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (g != null) {
            var h = g.minimumValue;
            var i = g.maximumValue;
            var j = g.logarithmBase;
            var k = this.t5(g);
            var l = k.b;
            var m = k.a;
            if (g.isLogarithmic) {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.ul(l, m, h, i, j, b._inner[n]);
                }
            }
            else {
                for (var o = 0; o < b.count; o++) {
                    b._inner[o] = BubbleSeries.uk(l, m, h, i, b._inner[o]);
                }
            }
        }
        var p = 1;
        p = DeviceUtils.d();
        var q = this.t8 == null;
        if (d) {
            var r = c.width / e;
            for (var s = 0; s < b.count; s++) {
                if (q) {
                    b._inner[s] = b._inner[s] / p;
                }
                b._inner[s] = b._inner[s] * r;
            }
        }
        for (var t = 0; t < a.count; t++) {
            var u = a._inner[t];
            if (q && !d) {
                u.width = Math.max(0, b._inner[t] / p);
                u.height = Math.max(0, b._inner[t] / p);
            }
            else {
                u.width = Math.max(0, b._inner[t]);
                u.height = Math.max(0, b._inner[t]);
            }
        }
    };
    BubbleSeries.prototype.u6 = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.bw);
        this.t7.b3 = false;
        if (b != null) {
            b.b3 = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.t6);
        var d = typeCast(ValueBrushScale.$, this.t6);
        var e = this.t6;
        var f = this.t4();
        var g = f.b;
        var h = f.a;
        var i = this.t6 == null || !this.t6.isReady || (d != null && this.up == null);
        if (i) {
            this.t7.dg();
            if (b != null) {
                b.dg();
            }
            return;
        }
        this.t7.b3 = true;
        if (b != null) {
            b.b3 = true;
        }
        var j = a.count;
        var k = this.ch;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.uc != null) {
                    var q = this.uc.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.qt == null) {
                        o = this.qr;
                    }
                    else {
                        o = this.qt;
                    }
                }
                var r = null;
                if (this.qu == null) {
                    r = this.qs;
                }
                else {
                    r = this.qu;
                }
                if (this.uh && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.un)) {
                    r = BrushUtil.l(r, this.un);
                }
                if (o != null && !isNaN_(this.um)) {
                    o = BrushUtil.l(o, this.um);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.qr;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:up:u8', [2], 'FillScale:t6:u9', [BrushScale.$], 'FillScaleUseGlobalValues:ug:va', [0, false], 'LabelMemberPath:uu:vb', [2], 'MarkerBrushBrightness:um:vc', [1, NaN], 'MarkerOutlineBrightness:un:vd', [1, NaN], 'MarkerOutlineUsesFillScale:uh:ve', [0, false], 'RadiusMemberPath:u0:vf', [2, null], 'RadiusScale:t8:vg', [SizeScale.$], 'RadiusScaleUseGlobalValues:ui:vh', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.uk(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.df = null;
        _this.df = a;
        _this.cx = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.b1.pr = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.cu = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.cy.item(a); }, function (a) { return _this.cw.rb.c.item(a); }, runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz));
    };
    BubbleSeriesView.prototype.dh = function () {
        var a = this.cv;
        this.df.u7(a.n, a.o, this.bu, this == this.e.bw);
        this.aq();
    };
    BubbleSeriesView.prototype.di = function () {
        var a = this.cv;
        this.df.u6(a.n);
    };
    BubbleSeriesView.prototype.dg = function () {
        var e_2, _a;
        var a = this.cv;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a4.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.df.hp + "</span><br/><span>" + "(${item." + this.df.so + "}, ${item." + this.df.ss + "})</span>";
        if (!stringIsNullOrEmpty(this.df.u0)) {
            a += "<span>, Radius: ${item." + this.df.u0 + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
//# sourceMappingURL=BubbleSeries_combined.js.map
