/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayer, _super);
    function FinalValueLayer() {
        var _this = _super.call(this) || this;
        _this.axisAnnotationFormatLabel = null;
        _this.qs = null;
        _this.qr = null;
        var a = new FinalValueLayerFrame();
        var b = new FinalValueLayerFrame();
        var c = new FinalValueLayerFrame();
        var d = _this.ha / 1000;
        _this.pk = a;
        _this.pj = b;
        _this.pl = c;
        _this.ab = FinalValueLayer.$;
        return _this;
    }
    FinalValueLayer.prototype.get_c4 = function () {
        return true;
    };
    FinalValueLayer.prototype.bu = function () {
        return new FinalValueLayerView(this);
    };
    FinalValueLayer.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.qn = a;
    };
    Object.defineProperty(FinalValueLayer.prototype, "ru", {
        get: function () {
            return new Thickness(1, this.qu, this.qw, this.qv, this.qt);
        },
        enumerable: false,
        configurable: true
    });
    FinalValueLayer.prototype.qq = function () {
        return this.axisAnnotationFormatLabel != null;
    };
    FinalValueLayer.prototype.p3 = function (a, b) {
        if (this.qp == null || this.qp == a) {
            if (!this.as.c) {
                this.l0(b);
            }
        }
    };
    FinalValueLayer.prototype.p5 = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.p5.call(this, a, b);
        var c = a;
        c.f.clear();
        c.q.clear();
        c.p.clear();
        c.aa.clear();
        c.o.clear();
        c.z.clear();
        c.g.clear();
        c.h.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.m.clear();
        c.n.clear();
        c.r.clear();
        c.s.clear();
        c.u.clear();
        c.w.clear();
        c.v.clear();
        c.t.clear();
        c.x.clear();
        c.y.clear();
        if (this.pq(this.qp)) {
            this.rc(this.qp, c);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (this.pq(d)) {
                        this.rc(d, c);
                    }
                    if (d.isStacked) {
                        d.ku(function (e) {
                            if (_this.pq(e)) {
                                _this.rc(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    FinalValueLayer.prototype.pq = function (a) {
        if (!_super.prototype.pq.call(this, a)) {
            return false;
        }
        if (this.q9 != null) {
            if (a.dn) {
                var b = a.i9();
                if (!Base.equalsStatic(this.q9, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.q9, a.name)) {
                    return false;
                }
            }
        }
        return true;
    };
    FinalValueLayer.prototype.la = function () {
        _super.prototype.la.call(this);
        if (!this.as.c && !this.cr()) {
            return;
        }
        if (this.cr()) {
            this.rd(this.pl, false);
        }
        else {
            this.rd(this.pj, false);
        }
    };
    FinalValueLayer.prototype.rt = function (a) {
        var b = NaN;
        var c = NaN;
        var d = this.qo;
        if (d == 0) {
            d = 1;
        }
        var e = false;
        if (d == 2) {
            e = true;
        }
        if (a.isVertical) {
            var f = a.ar();
            if (f != null) {
                if (d == 1 || d == 2) {
                    if (f.cc) {
                        c = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.bottom }).y;
                    }
                    else {
                        c = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.top }).y;
                    }
                }
                else {
                    if (f.cc) {
                        c = 1;
                    }
                    else {
                        c = 0;
                    }
                }
            }
            return a.o2({ $type: Point_$type, x: 0, y: c }, e, true);
        }
        else {
            var g = a.ar();
            if (g != null) {
                if (d == 1 || d == 2) {
                    if (g.cc) {
                        b = a.o5({ $type: Point_$type, x: this.pf.left, y: this.pf.top }).x;
                    }
                    else {
                        b = a.o5({ $type: Point_$type, x: this.pf.right, y: this.pf.top }).x;
                    }
                }
                else {
                    if (g.cc) {
                        b = 0;
                    }
                    else {
                        b = 1;
                    }
                }
            }
            if (a.di) {
                return a.o2({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
            else {
                return a.o2({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
        }
    };
    FinalValueLayer.prototype.rc = function (a, b) {
        var c = this.rt(a);
        var d = this.o5(c);
        var e = this.of;
        if (e == null) {
            e = this.oj;
        }
        if (e == null) {
            e = a.of;
            if (e != null) {
                e = this.qn.b5(e);
            }
        }
        AxisAnnotationFrameManager.c(b, c, a, this.ca, this.getEffectiveViewport(), e, this.rq, this.rs, this.rr, this.ru, this.qx, this.rq, this.rs, this.rr, this.ru, this.qx, a.isVertical, !a.isVertical);
    };
    FinalValueLayer.prototype.rd = function (a, b) {
        var c = false;
        if (this.qr == null) {
            c = true;
            this.qs = new List$1(Axis.$, 0);
            this.qr = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.qr, this.qs, b, this.qy, this.qy, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
    };
    FinalValueLayer.prototype.p8 = function (a, b) {
        _super.prototype.p8.call(this, a, b);
        if (this.cr()) {
            this.rd(this.pl, true);
        }
        else {
            this.rd(this.pj, false);
        }
    };
    FinalValueLayer.prototype.eg = function () {
        return true;
    };
    FinalValueLayer.prototype.lm = function (a, b, c, d) {
        var e_2, _a;
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case FinalValueLayer.$$p[10]:
            case FinalValueLayer.$$p[11]:
                this.l0(true);
                break;
            case FinalValueLayer.$$p[0]:
            case FinalValueLayer.$$p[2]:
            case FinalValueLayer.$$p[4]:
            case FinalValueLayer.$$p[6]:
            case FinalValueLayer.$$p[5]:
            case FinalValueLayer.$$p[3]:
            case FinalValueLayer.$$p[7]:
            case FinalValueLayer.$$p[8]:
            case FinalValueLayer.$$p[9]:
                this.l0(true);
                break;
            case "SeriesViewer":
                var e = this.qs;
                var f = this.qr;
                if (f != null) {
                    var _loop_1 = function (g) {
                        var h = g.value;
                        h.c(function (i) { return g.key.am.remove(i); });
                        h.clear();
                    };
                    try {
                        for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var g = _c.value;
                            _loop_1(g);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    e.clear();
                    f.clear();
                }
                break;
        }
    };
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackground:rq:re', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:qy:rf', [1, -1], 'AxisAnnotationOutline:rr:rg', [Brush.$, null], 'AxisAnnotationPaddingBottom:qt:rh', [1, NaN], 'AxisAnnotationPaddingLeft:qu:ri', [1, NaN], 'AxisAnnotationPaddingRight:qv:rj', [1, NaN], 'AxisAnnotationPaddingTop:qw:rk', [1, NaN], 'AxisAnnotationStrokeThickness:qx:rl', [1, NaN], 'AxisAnnotationTextColor:rs:rm', [Brush.$, null], 'FinalValueSelectionMode:qo:rn', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:q9:ro', [2, null], 'TargetSeries:qp:rp', [Series.$, null]]);
    return FinalValueLayer;
}(AnnotationLayer));
export { FinalValueLayer };
/**
 * @hidden
 */
var FinalValueLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayerView, _super);
    function FinalValueLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b4 = a;
        return _this;
    }
    FinalValueLayerView.prototype.as = function () {
        _super.prototype.as.call(this);
    };
    FinalValueLayerView.prototype.b5 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    FinalValueLayerView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
    };
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
}(AnnotationLayerView));
export { FinalValueLayerView };
//# sourceMappingURL=FinalValueLayer_combined.js.map
