/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __generator, __values } from "tslib";
import { EventArgs, Base, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core";
import { IFastItemColumn$1_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-angular-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-angular-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { dateToStringFormat } from "igniteui-angular-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinancialEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
export { FinancialEventArgs };
/**
 * @hidden
 */
var FinancialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bz.gh;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bv;
        var c = this.a.bu;
        var d = this.a.bu;
        if (this.a.bz != null) {
            d = this.a.bz.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bz.pq == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.bz.pq != null) ? this.a.bz.pq.cc : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.bz.o7(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.bz.pq);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.bz.pq.eb(g.left, f));
            var j = Math.ceil(this.a.bz.pq.eb(g.right, f));
            if (this.a.bz.pq.cc) {
                j = Math.ceil(this.a.bz.pq.eb(g.left, f));
                i = Math.floor(this.a.bz.pq.eb(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
export { FinancialBucketCalculator };
/**
 * @hidden
 */
var FinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this.qf = null;
        _this.qg = null;
        _this.qe = null;
        _this.qi = null;
        _this.qr = false;
        _this.assigningCategoryStyle = null;
        _this.pz = null;
        _this.q1 = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.q2 = new Dictionary$2(String_$type, String_$type, 0);
        _this.qq = false;
        _this.qa = null;
        _this.pu = null;
        _this.pw = null;
        _this.ps = null;
        _this.p2 = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.qp = false;
        _this.re = null;
        _this.rc = null;
        _this.rd = null;
        _this.rb = null;
        _this.rf = null;
        _this.pv = null;
        _this.pr = null;
        _this.px = 0;
        _this.qb = null;
        _this.qd = null;
        _this.pz = new CategorySeriesRenderManager();
        _this.qr = false;
        _this.p2 = new CategoryTransitionSourceFramePreparer();
        _this.pv = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.py = 0;
        return _this;
    }
    FinancialSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.p7 = a;
    };
    FinancialSeries.prototype.get_di = function () {
        return true;
    };
    FinancialSeries.prototype.ag = function () {
        return [this.pq, this.qc];
    };
    FinancialSeries.prototype.hk = function (a, b) {
        var c = this.ja(b);
        if (c == FinancialSeries.$$p[6]) {
            return this.hl(a, b, this.r6);
        }
        if (c == FinancialSeries.$$p[1]) {
            return this.hl(a, b, this.rx);
        }
        if (c == FinancialSeries.$$p[4]) {
            return this.hl(a, b, this.r2);
        }
        if (c == FinancialSeries.$$p[0]) {
            return this.hl(a, b, this.ru);
        }
        if (c == FinancialSeries.$$p[8]) {
            return this.hl(a, b, this.sa);
        }
        return _super.prototype.hk.call(this, a, b);
    };
    FinancialSeries.prototype.rq = function () {
        return 2;
    };
    FinancialSeries.prototype.ro = function () {
        return 4;
    };
    FinancialSeries.prototype.ah = function (a) {
        var b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.rq();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ai = function (a) {
        var b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.op = function () {
        return this.sw;
    };
    FinancialSeries.prototype.oq = function () {
        return this.sw;
    };
    FinancialSeries.prototype.ke = function () {
        _super.prototype.ke.call(this);
        this.pq = null;
        this.qc = null;
    };
    Object.defineProperty(FinancialSeries.prototype, "qm", {
        get: function () {
            return this.qh;
        },
        set: function (a) {
            if (this.qh != a) {
                var b = this.qh;
                this.qh = a;
                this.raisePropertyChanged("OpenColumn", b, this.qh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "qk", {
        get: function () {
            return this.qf;
        },
        set: function (a) {
            if (this.qf != a) {
                var b = this.qf;
                this.qf = a;
                this.raisePropertyChanged("HighColumn", b, this.qf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "ql", {
        get: function () {
            return this.qg;
        },
        set: function (a) {
            if (this.qg != a) {
                var b = this.qg;
                this.qg = a;
                this.raisePropertyChanged("LowColumn", b, this.qg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "qj", {
        get: function () {
            return this.qe;
        },
        set: function (a) {
            if (this.qe != a) {
                var b = this.qe;
                this.qe = a;
                this.raisePropertyChanged("CloseColumn", b, this.qe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "qo", {
        get: function () {
            return this.qi;
        },
        set: function (a) {
            if (this.qi != a) {
                var b = this.qi;
                this.qi = a;
                this.raisePropertyChanged("VolumeColumn", b, this.qi);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.qy = function () {
        return (this.assigningCategoryStyle != null && this.qr) || this.bj != 1;
    };
    FinancialSeries.prototype.si = function (a) {
        if (this.assigningCategoryStyle != null && this.qr) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.sg = function (a, b, c, d, e, f) {
        var g = this.bj != 1;
        this.pz.a1(this.pz.b, d.ch, a, b, c, d, e, f, false);
        this.pz.ab(this.fj);
        var h = this.pz.aw;
        var i = null;
        var j = this.ch;
        if (g && this.ca != null) {
            i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.si(h);
        this.pz.z(this, i, f, g, b < 0);
    };
    FinancialSeries.prototype.rg = function (a) {
        return this.fy(a, this.pq);
    };
    FinancialSeries.prototype.g6 = function (a, b) {
        return this.g7(a, b, this.pq, runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
    };
    FinancialSeries.prototype.g4 = function (a, b) {
        return this.g5(a, b, this.pq, runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
    };
    FinancialSeries.prototype.fu = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.pq.kq;
        return this.fv(a, b, this.pq, d, e, f, runOn(this, this.rg));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.pq.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
    };
    FinancialSeries.prototype.o2 = function (a, b, c) {
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, null, null, null);
    };
    FinancialSeries.prototype.f8 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo), a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.f4 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(this.qk, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.f6 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(this.ql, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.ri = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(this.qj, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.rj = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(this.qm, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.rk = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.rh(this.bx.bv, this.bx.bu, d);
        var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
        return this.ga(this.qo, a, this.pq, f, e, runOn(this, this.rg), b, c);
    };
    FinancialSeries.prototype.oy = function (a, b, c) {
        var _this = this;
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.f4), function (d, e) { return _this.g7(d, e, _this.pq, runOn(_this, _this.rg), _this.qk); }, function (d, e) { return _this.g5(d, e, _this.pq, runOn(_this, _this.rg), _this.qk); });
    };
    FinancialSeries.prototype.o0 = function (a, b, c) {
        var _this = this;
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.f6), function (d, e) { return _this.g7(d, e, _this.pq, runOn(_this, _this.rg), _this.ql); }, function (d, e) { return _this.g5(d, e, _this.pq, runOn(_this, _this.rg), _this.ql); });
    };
    FinancialSeries.prototype.sy = function (a, b, c) {
        var _this = this;
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.rj), function (d, e) { return _this.g7(d, e, _this.pq, runOn(_this, _this.rg), _this.qm); }, function (d, e) { return _this.g5(d, e, _this.pq, runOn(_this, _this.rg), _this.qm); });
    };
    FinancialSeries.prototype.sx = function (a, b, c) {
        var _this = this;
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.ri), function (d, e) { return _this.g7(d, e, _this.pq, runOn(_this, _this.rg), _this.qj); }, function (d, e) { return _this.g5(d, e, _this.pq, runOn(_this, _this.rg), _this.qj); });
    };
    FinancialSeries.prototype.sz = function (a, b, c) {
        var _this = this;
        return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.rk), function (d, e) { return _this.g7(d, e, _this.pq, runOn(_this, _this.rg), _this.qo); }, function (d, e) { return _this.g5(d, e, _this.pq, runOn(_this, _this.rg), _this.qo); });
    };
    FinancialSeries.prototype.ky = function () {
        _super.prototype.ky.call(this);
        if (this.pq != null) {
            this.pq.hq(false);
        }
        if (this.qc != null) {
            this.qc.hq(false);
        }
    };
    FinancialSeries.prototype.mn = function (a, b) {
        this.p7.bx.e(this.gh);
        this.l0(false);
    };
    FinancialSeries.prototype.mm = function (a, b) {
        if (this.eu && this.gn < 0.05) {
            this.ev = true;
        }
        this.p7.bx.e(this.gh);
        this.l0(false);
    };
    FinancialSeries.prototype.qn = function (a, b, c) {
        var d = this.ce(b);
        this.q1.addItem(d, b);
        this.q2.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.sf = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.q1.item(b);
        this.q2.removeItem(c);
        this.q1.removeItem(b);
    };
    FinancialSeries.prototype.lm = function (a, b, c, d) {
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.b5 != null && this.ca != null) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.pq != null) {
                        this.pq.bx(this);
                    }
                    if (this.qc != null) {
                        this.qc.bx(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.pq != null) {
                        this.pq.cn(this);
                    }
                    if (this.qc != null) {
                        this.qc.cn(this);
                    }
                }
                this.p7.bx.e(this.gh);
                this.l0(false);
                break;
            case "FastItemsSource":
                this.qq = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.sf(typeCast(IFastItemsSource_$type, c), this.qm);
                    this.sf(typeCast(IFastItemsSource_$type, c), this.qk);
                    this.sf(typeCast(IFastItemsSource_$type, c), this.ql);
                    this.sf(typeCast(IFastItemsSource_$type, c), this.qj);
                    this.sf(typeCast(IFastItemsSource_$type, c), this.qo);
                    this.qm = null;
                    this.qk = null;
                    this.ql = null;
                    this.qj = null;
                    this.qo = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (stringIsNullOrEmpty(this.r6) == false) {
                        this.qm = this.qn(typeCast(IFastItemsSource_$type, d), this.r6, "OpenColumn");
                    }
                    if (stringIsNullOrEmpty(this.rx) == false) {
                        this.qk = this.qn(typeCast(IFastItemsSource_$type, d), this.rx, "HighColumn");
                    }
                    if (stringIsNullOrEmpty(this.r2) == false) {
                        this.ql = this.qn(typeCast(IFastItemsSource_$type, d), this.r2, "LowColumn");
                    }
                    if (stringIsNullOrEmpty(this.ru) == false) {
                        this.qj = this.qn(typeCast(IFastItemsSource_$type, d), this.ru, "CloseColumn");
                    }
                    if (stringIsNullOrEmpty(this.sa) == false) {
                        this.qo = this.qn(typeCast(IFastItemsSource_$type, d), this.sa, "VolumeColumn");
                    }
                }
                this.qq = false;
                if (this.qc != null && !this.qc.cv()) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.ch != null) {
                    this.sf(this.ch, this.qm);
                    this.qm = this.qn(this.ch, this.r6, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.qc != null && !this.qc.cv() && !this.qq) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.ch != null) {
                    this.sf(this.ch, this.qk);
                    this.qk = this.qn(this.ch, this.rx, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.qc != null && !this.qc.cv() && !this.qq) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.ch != null) {
                    this.sf(this.ch, this.ql);
                    this.ql = this.qn(this.ch, this.r2, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.qc != null && !this.qc.cv() && !this.qq) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.ch != null) {
                    this.sf(this.ch, this.qj);
                    this.qj = this.qn(this.ch, this.ru, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.qc != null && !this.qc.cv() && !this.qq) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                this.sk();
                break;
            case FinancialSeries.$$p[8]:
                if (this.ch != null) {
                    this.sf(this.ch, this.qo);
                    this.qo = this.qn(this.ch, this.sa, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.qc != null && !this.qc.cv() && !this.qq) {
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.cn(this);
                }
                this.p7.bx.e(this.gh);
                this.l0(false);
                this.k7();
                this.qb = typeCast(ITimeRangeSelectorAxis_$type, this.pq);
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.cn(this);
                }
                this.p7.bx.e(this.gh);
                if (this.qc != null) {
                    this.qc.cv();
                }
                {
                    this.l0(false);
                }
                this.k7();
                break;
            case "TransitionProgress":
                this.pw.c(this.gn, this.pu, this.ps);
                if (this.ct(this.bx)) {
                    return;
                }
                if (this.gn == 1) {
                    this.ps.v();
                    this.sj(this.ps, this.p7);
                    if (this.eu) {
                        this.eu = false;
                        this.ki();
                        this.cb.r = truncate(this.gb());
                        this.cb.b = this.cc;
                    }
                }
                else {
                    this.sj(this.pw, this.p7);
                }
                if (this.ca != null) {
                    this.ca.ln(this);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.l0(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.qr = this.qu();
                this.l0(false);
                break;
            case "CategoryMode":
                if (this.pq != null) {
                    this.pq.le(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.qt = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.qs = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b9) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.pj = function (a, b, c) {
        if (b < a || a < 0 || a > this.ch.count || b < 0 || b > this.ch.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.ch;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.ch.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.rn = function (a) {
        return a.bx.b;
    };
    FinancialSeries.prototype.rp = function (a) {
        return a.bx.c;
    };
    FinancialSeries.prototype.pi = function (a, b) {
        return this.pj(a, b, this.qc);
    };
    FinancialSeries.prototype.get_dr = function () {
        return true;
    };
    FinancialSeries.prototype.kf = function () {
        _super.prototype.kf.call(this);
        this.qa = null;
    };
    FinancialSeries.prototype.av = function (a, b, c) {
        if (this.cy && this.d9(this.bj) && !c) {
            var d = this.p9(a, b, this.qa);
            this.qa = d;
            return d;
        }
        else {
            var e = this.p8(a, b, this.qa);
            this.qa = e;
            return e;
        }
    };
    FinancialSeries.prototype.rr = function (a) {
        var b = this.pt();
        var c = this.bx.bu;
        var d = this.bx.bv;
        var e = this.pq;
        var f = 0;
        if (e.cj) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.p9 = function (a, b, c) {
        var d = this.ch.count;
        var e = this.p7.bx.c;
        var f = this.p7.bx.d;
        var g = this.p7.bx.b;
        var h = this.pq;
        var i = -1;
        var j = -1;
        if (h.ch) {
            var k = this.pt();
            var l = this.rr(b);
            i = l;
            j = l;
        }
        else {
            var m = this.g0(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.h == i && c.g == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.b = this;
        n.h = i;
        n.g = j;
        return n;
    };
    FinancialSeries.prototype.p8 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ch.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.qu = function () {
        return this.qw;
    };
    FinancialSeries.prototype.fw = function (a) {
        var b = this.bx.bv;
        var c = this.bx.bu;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.pq != null) {
            var e = this.getEffectiveViewport1(this.bx);
            var f = new ScalerParams(0, b, c, this.pq.cc, e);
            var g = this.o7(this.bx);
            var h = this.pq.eb(g.left, f);
            var i = this.pq.eb(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.pq.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.g0 = function (a) {
        return truncate(Math.round(this.fw(a)));
    };
    FinancialSeries.prototype.get_d3 = function () {
        return typeCast(ISortingAxis_$type, this.pq) !== null;
    };
    FinancialSeries.prototype.ar = function () {
        return this.pq;
    };
    FinancialSeries.prototype.g2 = function (a) {
        var b = this.bx.bv;
        var c = this.bx.bu;
        var d = this.getEffectiveViewport1(this.bx);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.pq.cc, d);
        var g = typeCast(ISortingAxis_$type, this.pq);
        var h = this.o7(this.bx);
        var i = h.left;
        var j = h.right;
        var k = this.ox(a).x;
        var l = this.pq.eb(k, f);
        var m = this.pq.eb(i, f);
        var n = this.pq.eb(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.hh = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.pq) !== null) {
            b = this.g2(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.g0(a);
        }
        return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
    };
    FinancialSeries.prototype.pt = function () {
        var a = this.ps;
        if (this.cr()) {
            if (this.cb.g) {
                this.cb.t();
            }
            a = this.pw;
        }
        return a;
    };
    FinancialSeries.prototype.rh = function (a, b, c) {
        if (this.pq == null) {
            return 0;
        }
        return this.pq.kj(a, b, c, this.g9);
    };
    FinancialSeries.prototype.ek = function () {
        return this.qx;
    };
    FinancialSeries.prototype.p0 = function () {
        return 11;
    };
    FinancialSeries.prototype.b6 = function () {
        return 3;
    };
    FinancialSeries.prototype.sj = function (a, b) {
        this.o6 = a.aa;
        b.au();
    };
    FinancialSeries.prototype.sh = function (a, b) {
        a.u();
    };
    FinancialSeries.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        var e = c;
        if (this.ch == null || this.ch.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.pq == null || this.qc == null || e.bx.b < 1 || this.pq.bh == null || this.qc.bh == null || this.qc.kv == this.qc.ku || this.pq.itemsSource == null || this.pq.kq < 1) {
            e.bx.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.bx.bv;
        a = this.bx.bu;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.rl = function (a) {
        var b = 0;
        var c = a.bv;
        var d = a.bu;
        var e = this.getEffectiveViewport1(this.bx);
        if (!c.isEmpty && !d.isEmpty && this.qc != null) {
            var f = new ScalerParams(0, c, d, this.qc.cc, e);
            f.b = this.f2();
            b = this.qc.d8(this.qc.k5, f);
        }
        return b;
    };
    FinancialSeries.prototype.ki = function () {
        _super.prototype.ki.call(this);
        this.pu.v();
        this.ps.v();
        this.pw.v();
    };
    FinancialSeries.prototype.l1 = function (a) {
        var _this = this;
        _super.prototype.l1.call(this, a);
        this.p7.bx.e(this.gh);
        if (this.ct(this.bx)) {
            return;
        }
        if (this.em) {
            if (this.cr()) {
                this.sj(this.pw, this.p7);
            }
            else {
                this.sj(this.ps, this.p7);
            }
            return;
        }
        if (this.ei(a)) {
            var b = this.pu;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                this.pu = this.pw;
                this.pw = b;
            }
            else {
                this.pu = this.ps;
                this.ps = b;
            }
            this.sh(this.ps, this.p7);
            if (this.ew) {
                this.cb.w();
                this.cb.r = truncate(this.gc());
                this.cb.b = this.cd != null ? this.cd : this.cc;
                this.p2.p(this.pu, this.ps, this.isVertical, this.pq, this.qc, this.p1, this.p0(), this.b7, this.b6(), function () { return _this.rl(_this.p7); }, this.p7.bu);
            }
            this.kd();
            this.l8();
            if (this.ew) {
                this.ev = false;
                this.eu = true;
            }
        }
        else {
            this.sh(this.ps, this.p7);
            this.sj(this.ps, this.p7);
        }
    };
    FinancialSeries.prototype.qz = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b) {
                    case "HighColumn":
                        if (this.qk == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.ql == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.qm == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.qj == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.qo == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "q0", {
        get: function () {
            return this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.qv = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.se = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "q8", {
        get: function () {
            return this.q5();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._q5 = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h;
        var e_2, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.qv())
                        return [3 /*break*/, 8];
                    b = this.p3(0, this.ch.count);
                    this.se(new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this));
                    if (!(b.typicalColumn != null))
                        return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a)
                        return [3 /*break*/, 17];
                    if (!(this.q0 && this.pq.i$b != null))
                        return [3 /*break*/, 13];
                    d = this.ch.count;
                    e = this.pq.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d))
                        return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.qk.item(e.item(f)) + this.ql.item(e.item(f)) + this.qj.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.ch.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g))
                        return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.qk.item(h) + this.ql.item(h) + this.qj.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.q5 = function () {
        var _this = this;
        return toEnum(function () { return _this._q5(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "q7", {
        get: function () {
            return this.q4();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._q4 = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.q0 && this.pq.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.qk.count;
                    b = this.pq.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.rm(this.qk.item(b.item(0)) - this.ql.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.rm(this.qk.item(b.item(c)) - this.ql.item(b.item(c))), Math.max(this.rm(Math.abs(this.qk.item(b.item(c)) - this.qj.item(b.item(c - 1)))), this.rm(Math.abs(this.ql.item(b.item(c)) - this.qj.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.qk.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.rm(this.qk.item(0) - this.ql.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.rm(this.qk.item(e) - this.ql.item(e)), Math.max(this.rm(Math.abs(this.qk.item(e) - this.qj.item(e - 1))), this.rm(Math.abs(this.ql.item(e) - this.qj.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.q4 = function () {
        var _this = this;
        return toEnum(function () { return _this._q4(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "q6", {
        get: function () {
            return this.q3();
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype._q3 = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.q0 && this.pq.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.ql.count;
                    b = this.pq.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.rm(this.ql.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.rm(this.ql.item(b.item(c))), this.rm(this.qj.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.ql.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.rm(this.ql.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.rm(this.ql.item(e)), this.rm(this.qj.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.q3 = function () {
        var _this = this;
        return toEnum(function () { return _this._q3(); });
    };
    FinancialSeries.prototype.ra = function (a) {
        if (a == null) {
            return null;
        }
        if (this.q0 && this.pq.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.pq.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.q9 = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.ch != null && !this.qp) {
            this.qp = true;
            var b = this.p3(0, this.ch.count);
            this.qp = false;
            var c = new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.qm == null) {
            return null;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            if (this.re != null) {
                return this.re.asArray();
            }
            var a = new List$1(Number_$type, 2, this.qm.count);
            var b = this.pq.i$b;
            var c = this.qm.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.re = a;
            return this.re.asArray();
        }
        else {
            return this.qm.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.qk == null) {
            return null;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            if (this.rc != null) {
                return this.rc.asArray();
            }
            var a = new List$1(Number_$type, 2, this.qk.count);
            var b = this.pq.i$b;
            var c = this.qk.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.rc = a;
            return this.rc.asArray();
        }
        else {
            return this.qk.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.ql == null) {
            return null;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            if (this.rd != null) {
                return this.rd.asArray();
            }
            var a = new List$1(Number_$type, 2, this.ql.count);
            var b = this.pq.i$b;
            var c = this.ql.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.rd = a;
            return this.rd.asArray();
        }
        else {
            return this.ql.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.qj == null) {
            return null;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            if (this.rb != null) {
                return this.rb.asArray();
            }
            var a = new List$1(Number_$type, 2, this.qj.count);
            var b = this.pq.i$b;
            var c = this.qj.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.rb = a;
            return this.rb.asArray();
        }
        else {
            return this.qj.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.qo == null) {
            return null;
        }
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            if (this.rf != null) {
                return this.rf.asArray();
            }
            var a = new List$1(Number_$type, 2, this.qo.count);
            var b = this.pq.i$b;
            var c = this.qo.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.rf = a;
            return this.rf.asArray();
        }
        else {
            return this.qo.asArray();
        }
    };
    FinancialSeries.prototype.kk = function (a, b, c, d) {
        _super.prototype.kk.call(this, a, b, c, d);
        if (this.pq == null || !(typeCast(ISortingAxis_$type, this.pq) !== null)) {
            return;
        }
        var e = this.pq.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.re != null) {
                        this.re.insert(f, this.qm.item(g));
                    }
                    if (this.rc != null) {
                        this.rc.insert(f, this.qk.item(g));
                    }
                    if (this.rd != null) {
                        this.rd.insert(f, this.ql.item(g));
                    }
                    if (this.rb != null) {
                        this.rb.insert(f, this.qj.item(g));
                    }
                    if (this.rf != null) {
                        this.rf.insert(f, this.qo.item(g));
                    }
                }
                break;
            case 0:
                if (this.re != null) {
                    this.re.v(b, c);
                }
                if (this.rc != null) {
                    this.rc.v(b, c);
                }
                if (this.rd != null) {
                    this.rd.v(b, c);
                }
                if (this.rb != null) {
                    this.rb.v(b, c);
                }
                if (this.rf != null) {
                    this.rf.v(b, c);
                }
                break;
            case 4:
                if (this.re != null) {
                    this.re = new List$1(Number_$type, 0);
                }
                if (this.rc != null) {
                    this.rc = new List$1(Number_$type, 0);
                }
                if (this.rd != null) {
                    this.rd = new List$1(Number_$type, 0);
                }
                if (this.rb != null) {
                    this.rb = new List$1(Number_$type, 0);
                }
                if (this.rf != null) {
                    this.rf = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.re != null) {
                        this.re._inner[h] = this.qm.item(i);
                    }
                    if (this.rc != null) {
                        this.rc._inner[h] = this.qk.item(i);
                    }
                    if (this.rd != null) {
                        this.rd._inner[h] = this.ql.item(i);
                    }
                    if (this.rb != null) {
                        this.rb._inner[h] = this.qj.item(i);
                    }
                    if (this.rf != null) {
                        this.rf._inner[h] = this.qo.item(i);
                    }
                }
                break;
        }
        this.sk();
        this.mj();
    };
    FinancialSeries.prototype.p3 = function (a, b) {
        var _this = this;
        var c = this.ra(this.qm);
        var d = this.ra(this.qj);
        var e = this.ra(this.qk);
        var f = this.ra(this.ql);
        var g = this.ra(this.qo);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.q8), _this.q9());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.q7), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.q6), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.ch != null ? _this.ch.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.rm = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.p4 = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.e8;
            $ret.j = Series.e7;
            $ret.i = runOn(_this, _this.rm);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.pq;
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.l2 = function (a, b) {
        _super.prototype.l2.call(this, a, b);
        if (!this.et) {
            this.bx.a2(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.bw);
        this.bx.a2(b);
        c.bx.e(this.gh);
        if (this.ct(this.bw)) {
            return;
        }
        if (!this.en) {
            this.sh(this.pv, c);
        }
        this.en = false;
        this.sj(this.pv, c);
        this.et = false;
    };
    FinancialSeries.prototype.lz = function (a, b, c, d, e) {
        _super.prototype.lz.call(this, a, b, c, d, e);
        var f = this.a4.a$h.item(d);
        var g = f;
        g.bx.e(this.gh);
        f.a1(c);
        if (this.ct(g)) {
            return;
        }
        if (this.pr == null) {
            this.pr = new CategoryFrame(3);
        }
        this.pr.u();
        this.sh(this.pr, g);
        this.sj(this.pr, g);
    };
    FinancialSeries.prototype.an = function (a) {
        if (this.pq == a) {
            return this.qc;
        }
        if (this.qc == a) {
            return this.pq;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.pq);
        return b != null ? b.preferredCategoryMode(this) : this.py;
    };
    Object.defineProperty(FinancialSeries.prototype, "py", {
        get: function () {
            return this.px;
        },
        set: function (a) {
            var b = this.py;
            if (a != b) {
                this.px = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.py));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialSeries.prototype.get_dx = function () {
        return true;
    };
    FinancialSeries.prototype.l5 = function (a, b) {
        _super.prototype.l5.call(this, a, b);
        this.sw = a;
    };
    FinancialSeries.prototype.sk = function () {
        this.fs = this.qj == null || this.qj.count == 0 ? NaN : this.qj.item(this.qj.count - 1);
    };
    FinancialSeries.prototype.hj = function (a) {
        if (this.qb != null && a != null) {
            if (this.qd == null || this.qd.propertyName != this.qb.dateTimeMemberPath) {
                this.qd = new FastReflectionHelper(false, this.qb.dateTimeMemberPath);
            }
            var b = this.qd.getPropertyValue(a);
            if (typeCast(Date_$type, b) !== null) {
                return dateToStringFormat(b, this.qb.itemLabelFormat());
            }
        }
        return _super.prototype.hj.call(this, a);
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:ru:sl', [2, null], 'HighMemberPath:rx:sm', [2, null], 'IsCustomCategoryStyleAllowed:qw:sn', [0, false], 'IsTransitionInEnabled:qx:so', [0, false], 'LowMemberPath:r2:sp', [2, null], 'NegativeBrush:sw:sq', [Brush.$, null], 'OpenMemberPath:r6:sr', [2, null], 'TransitionInMode:p1:ss', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:sa:st', [2, null], 'XAxis:pq:su', [CategoryAxisBase.$, null], 'YAxis:qc:sv', [NumericYAxis.$, null]]);
    return FinancialSeries;
}(Series));
export { FinancialSeries };
/**
 * @hidden
 */
var FinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
export { FinancialCalculationSupportingCalculations };
/**
 * @hidden
 */
var DataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
export { DataSourceSupportingCalculation };
/**
 * @hidden
 */
var FinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
export { FinancialCalculationDataSource };
/**
 * @hidden
 */
var FinancialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bz = null;
        _this.bx = null;
        _this.b1 = 0;
        _this.b1 = -1;
        _this.bz = a;
        _this.bx = _this.by();
        return _this;
    }
    FinancialSeriesView.prototype.b0 = function (a) {
        if (this.b1 != a.t) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.b2 = function (a) {
        this.b1 = a.t;
    };
    FinancialSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bz.pq.b9) {
            a += "<span>${itemLabel}</span><br/>";
        }
        else if (this.bz.pq.fj != null) {
            a += "<span>${item." + this.bz.pq.fj + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var b = this.e.a4.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        var c = new SRProvider(this.w);
        var d = c.b1("financialSeries_Open");
        var e = c.b1("financialSeries_High");
        var f = c.b1("financialSeries_Low");
        var g = c.b1("financialSeries_Close");
        d = stringIsNullOrEmpty(d) ? "Open" : d;
        e = stringIsNullOrEmpty(e) ? "High" : e;
        f = stringIsNullOrEmpty(f) ? "Low" : f;
        g = stringIsNullOrEmpty(g) ? "Close" : g;
        a += ">" + this.bz.hp + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bz.r6 + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bz.rx + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bz.r2 + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bz.ru + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bz.sa)) {
            var h = c.b1("financialSeries_Volume");
            h = stringIsNullOrEmpty(h) ? "Volume" : h;
            a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bz.sa + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.or = a;
        this.e.gj = 5;
        this.e.gk = 2;
        this.e.gl = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));
export { FinancialSeriesView };
//# sourceMappingURL=FinancialEventArgs_combined.js.map
