/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { TrendLineType_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { PriceDisplayType_$type } from "./PriceDisplayType";
import { enumGetBox, EnumUtil, typeCast, fromEnum, runOn, Point_$type, markType, markDep } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { RectUtil } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { AxisRange } from "./AxisRange";
import { ScalerParams } from "./ScalerParams";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { Pool$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { RectangleGeometry } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { FinancialPriceBucketCalculator } from "./FinancialPriceBucketCalculator";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinancialPriceSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeries, _super);
    function FinancialPriceSeries() {
        var _this = _super.call(this) || this;
        _this.ab = FinancialPriceSeries.$;
        _this.pu = new CategoryFrame(5);
        _this.pw = new CategoryFrame(5);
        _this.ps = new CategoryFrame(5);
        return _this;
    }
    FinancialPriceSeries.prototype.get_dl = function () {
        return true;
    };
    FinancialPriceSeries.prototype.bu = function () {
        return new FinancialPriceSeriesView(this);
    };
    FinancialPriceSeries.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        this.s1 = a;
    };
    Object.defineProperty(FinancialPriceSeries.prototype, "tl", {
        get: function () {
            return this.c(FinancialPriceSeries.tb);
        },
        set: function (a) {
            this.h(FinancialPriceSeries.tb, a);
        },
        enumerable: false,
        configurable: true
    });
    FinancialPriceSeries.prototype.kk = function (a, b, c, d) {
        _super.prototype.kk.call(this, a, b, c, d);
        if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
            this.pq.i$i();
        }
        this.s1.bx.e(this.gh);
        if (this.s1.b7) {
            this.s1.b5.g$e(a, b, c, d);
        }
        if (this.qc != null) {
            this.qc.cv();
        }
        this.l0(true);
    };
    FinancialPriceSeries.prototype.bo = function () {
        if (this.bp == 0) {
            return 1;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    FinancialPriceSeries.prototype.pb = function (a) {
        if (this.ps == null || this.ps.f.count == 0) {
            return Rect.empty;
        }
        var b = this.ox(a);
        var c = this.bx.bv;
        var d = this.bx.bu;
        var e = this.getEffectiveViewport1(this.bx);
        var f = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
        var g = f[0];
        var h = f[1];
        var i = Math.abs(b.x - g[0]);
        var j = Math.abs(b.x - h[0]);
        var k = this.s3(this.p7, e);
        k = Math.max(k, 3);
        var l = (k - 1) / 2;
        if (i < j) {
            var m = g[0] - l;
            var n = g[0];
            var o = g[0] + l;
            var p = g[1];
            var q = g[2];
            var r = g[3];
            var s = g[4];
            var t = Math.min(Math.min(Math.min(p, q), r), s);
            var u = Math.max(Math.max(Math.max(p, q), r), s);
            return new Rect(0, m, t, Math.abs(o - m), u - t);
        }
        else {
            var v = h[0] - l;
            var w = h[0];
            var x = h[0] + l;
            var y = h[1];
            var z = h[2];
            var aa = h[3];
            var ab = h[4];
            var ac = Math.min(Math.min(Math.min(y, z), aa), ab);
            var ad = Math.max(Math.max(Math.max(y, z), aa), ab);
            return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
        }
    };
    FinancialPriceSeries.prototype.s0 = function (a, b) {
        var c = a[0] - b;
        var d = a[0];
        var e = a[0] + b;
        var f = a[1];
        var g = a[2];
        var h = a[3];
        var i = a[4];
        var j = Math.min(Math.min(Math.min(f, g), h), i);
        var k = Math.max(Math.max(Math.max(f, g), h), i);
        var l = Math.min(g, h);
        var m = Math.max(g, h);
        var n = Math.min(f, i);
        var o = Math.max(f, i);
        if (this.s2 == 1) {
            var p = new Array(3);
            var q = new Rect(0, c, f, b, 0);
            var r = new Rect(0, d, i, b, 0);
            var s = new Rect(0, d, l, 0, m - l);
            p[0] = q;
            p[1] = r;
            p[2] = s;
            return p;
        }
        else {
            var t = new Array(2);
            var u = new Rect(0, d, l, 0, m - l);
            var v = new Rect(0, c, n, b * 2, o - n);
            t[0] = u;
            t[1] = v;
            return t;
        }
    };
    FinancialPriceSeries.prototype.ak = function (a) {
        var b = new List$1(Rect.$, 0);
        var c = this.ox(a);
        var d = this.bx.bv;
        var e = this.bx.bu;
        var f = this.getEffectiveViewport1(this.bx);
        var g = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
        var h = g[0];
        var i = g[1];
        var j = Math.abs(c.x - h[0]);
        var k = Math.abs(c.x - i[0]);
        var l = this.s3(this.p7, f);
        l = Math.max(l, 3);
        var m = (l - 1) / 2;
        if (j < k) {
            return this.s0(h, m);
        }
        else {
            return this.s0(i, m);
        }
    };
    FinancialPriceSeries.prototype.ep = function (a, b) {
        if (this.es(a, b)) {
            return true;
        }
        return false;
    };
    FinancialPriceSeries.prototype.es = function (a, b) {
        var c = this.pc(a);
        if (c.isEmpty) {
            return false;
        }
        var d = RectUtil.r(c, (this.fl / 2) + this.fz(b));
        if (d.containsPoint(a)) {
            var e = this.al(a);
            if (e != null) {
                for (var f = 0; f < e.length; f++) {
                    var g = e[f];
                    var h = RectUtil.r(g, (this.fl / 2) + this.fz(b));
                    if (h.containsPoint(a)) {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    FinancialPriceSeries.prototype.lm = function (a, b, c, d) {
        switch (b) {
            case FinancialSeries.$$p[9]:
                this.s1.cd();
                if (this.ca != null) {
                    this.ca.jp();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.s1.b5 = CategoryTrendLineManagerFactory.a(this.s1.b5, this.pq, this.mr, this, this.ck);
                }
                break;
        }
        _super.prototype.lm.call(this, a, b, c, d);
        if (this.s1.b7 && this.s1.b5 != null && this.s1.b5.g$b(a, b, c, d)) {
            this.l0(false);
            this.k7();
        }
        switch (b) {
            case FinancialPriceSeries.$$p[0]:
                if (this.mr != null) {
                    this.ta();
                    this.me();
                    this.ps.w();
                    this.sj(this.ps, this.s1);
                }
                this.k7();
                break;
            case "ActualHighlightingMode":
                this.l0(true);
                break;
            case "TrendLineBrush":
                this.md();
                break;
            case "TrendLineType":
                this.k7();
                break;
            case FinancialSeries.$$p[5]:
            case FinancialPriceSeries.$$p[1]:
                this.lj();
                break;
        }
    };
    FinancialPriceSeries.prototype.ta = function () {
        this.s1.ch();
        if (this.bw != null) {
            this.bw.ch();
        }
    };
    FinancialPriceSeries.prototype.ap = function (a) {
        if (a != null && a == this.qc && this.ql != null && !isNaN_(this.ql.minimum) && this.qk != null && !isNaN_(this.qk.maximum)) {
            return new AxisRange(this.ql.minimum, this.qk.maximum);
        }
        return null;
    };
    FinancialPriceSeries.prototype.aq = function (a) {
        if (a.isEmpty && this.ca != null) {
            a = this.ca.pg;
        }
        if (this.ql == null || this.qk == null) {
            return null;
        }
        var b = this.o7(this.bx);
        var c = new ScalerParams(0, a, this.ca.pv, this.pq.cc, this.getEffectiveViewport());
        var d = (this.pq.eb(b.left, c));
        var e = (this.pq.eb(b.right, c));
        if (this.pq.cc) {
            var f = d;
            d = e;
            e = f;
        }
        var g = null;
        if (this.pq.ch) {
            g = this.pq;
            d = g.i$f(d);
            e = g.i$f(e);
        }
        else {
            d = Math.floor(d);
            e = Math.ceil(e);
        }
        d = Math.max(0, Math.min(this.ql.count - 1, d));
        e = Math.max(0, Math.min(this.ql.count - 1, e));
        var h = 1.7976931348623157E+308;
        var i = -1.7976931348623157E+308;
        for (var j = truncate(d); j <= truncate(e); j++) {
            var k = j;
            if (g != null) {
                k = g.i$b._inner[j];
            }
            var l = this.ql.item(k);
            if (this.ql.mayContainUnknowns) {
                if (isInfinity(l) || isNaN_(l)) {
                    continue;
                }
            }
            var m = this.qk.item(k);
            if (this.qk.mayContainUnknowns) {
                if (isInfinity(m) || isNaN_(m)) {
                    continue;
                }
            }
            h = Math.min(h, l);
            i = Math.max(i, m);
        }
        var n = new AxisRange(h, i);
        n = this.ao(n, this.qc, a);
        return n;
    };
    FinancialPriceSeries.prototype.f2 = function () {
        return Series.f3(this.qm, typeCast(ISortingAxis_$type, this.pq));
    };
    FinancialPriceSeries.prototype.eh = function (a) {
        var b = this.ch != null ? this.ch.indexOf(a) : -1;
        var c = this.bx.bv;
        c = c.copy();
        var d = this.bx.bu;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.o9(this.bx);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.pq != null) {
                var g = new ScalerParams(0, e, e, this.pq.cc, f);
                var h = this.pq.d8(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.qc != null && this.ql != null && this.qk != null && b < this.ql.count && b < this.qk.count) {
                var i = new ScalerParams(0, e, e, this.qc.cc, f);
                i.b = this.f2();
                var j = this.qc.d8(this.ql.item(b), i);
                var k = this.qc.d8(this.qk.item(b), i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.b5.ap(this.ca, c, true);
        }
        return b >= 0;
    };
    FinancialPriceSeries.prototype.e3 = function (a, b, c) {
        var d = _super.prototype.e3.call(this, a, b, c);
        if (this.qm == null || this.qj == null || this.qk == null || this.ql == null) {
            d = false;
        }
        return d;
    };
    FinancialPriceSeries.prototype.sh = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.sh.call(this, a, b);
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pq;
        var g = this.qc;
        var h = new ScalerParams(0, c, d, f.cc, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, g.cc, e);
            $ret.b = _this.f2();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.pq);
        if (k != null && (k.i$b == null || k.i$b.count != this.ch.count)) {
            return;
        }
        j = this.rh(c, d, e);
        var l = typeCast(FinancialPriceSeriesView.$, b);
        var m = this.gh;
        if (this.trendLineType != 0) {
            var n = new Array(this.ch.count);
            var o = 0;
            try {
                for (var _b = __values(fromEnum(this.q8)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var p = _c.value;
                    n[o] = p;
                    o++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (this.s1.b7) {
                this.s1.b5.prepareLineCore(a.p, this.trendLineType, boxArray$1(n), this.trendLinePeriod, function (q) { return _this.pq.d8(q, h); }, function (q) { return _this.qc.d8(q, i); }, ((function () {
                    var $ret = new TrendResolutionParams();
                    $ret.c = b.bx.b;
                    $ret.d = b.bx.c;
                    $ret.e = b.bx.d;
                    $ret.a = j;
                    $ret.b = m;
                    $ret.f = d;
                    return $ret;
                })()));
            }
        }
        var q = this.pq.eb(2, h) - this.pq.eb(1, h);
        for (var r = b.bx.c; r <= b.bx.d; ++r) {
            var s = void 0;
            if (k == null) {
                s = b.bx.getBucket(r);
            }
            else {
                var t = k.i$b._inner[r];
                var u = k.i$d(t);
                var v = this.qm.item(t);
                var w = this.qk.item(t);
                var x = this.ql.item(t);
                var y = this.qj.item(t);
                var z = v;
                var aa = w;
                var ab = x;
                var ac = y;
                var ad = u;
                while (r < b.bx.d) {
                    t = k.i$b._inner[r + 1];
                    ad = k.i$d(t);
                    if (ad - u > q * m) {
                        break;
                    }
                    r++;
                    aa = Math.max(aa, this.qk.item(t));
                    ab = Math.min(ab, this.ql.item(t));
                    ac = this.qj.item(t);
                }
                var ae = NaN;
                if (!isNaN_(u)) {
                    ae = this.pq.d8(u, h);
                }
                s = [ae, z, aa, ab, ac];
            }
            if (!isNaN_(s[0])) {
                if (k != null) {
                    s[0] = s[0] + j;
                }
                else {
                    s[0] = f.d8(s[0], h) + j;
                }
                s[1] = g.d8(s[1], i);
                s[2] = g.d8(s[2], i);
                s[3] = g.d8(s[3], i);
                s[4] = g.d8(s[4], i);
                a.f.add(s);
            }
        }
        return;
    };
    FinancialPriceSeries.prototype.kh = function (a, b) {
        _super.prototype.kh.call(this, a, b);
        var c = typeCast(FinancialPriceSeriesView.$, b);
        c.cb();
        if (a) {
            c.b6.count = 0;
        }
        if (c.b7 && c.b5 != null) {
            c.b5.g$d();
        }
    };
    FinancialPriceSeries.prototype.mm = function (a, b) {
        _super.prototype.mm.call(this, a, b);
        if (this.ca != null) {
            this.ca.jp();
        }
    };
    FinancialPriceSeries.prototype.pg = function () {
        if (this.pq != null && this.pq.categoryMode == 0) {
            var a = this.getEffectiveViewport1(this.bx);
            var b = this.s3(this.p7, a) / 2;
            return new Thickness(1, b, 0, b, 0);
        }
        return _super.prototype.pg.call(this);
    };
    FinancialPriceSeries.prototype.get_cy = function () {
        return true;
    };
    FinancialPriceSeries.prototype.sj = function (a, b) {
        _super.prototype.sj.call(this, a, b);
        if (this.pq == null || this.qc == null) {
            return;
        }
        var c = false;
        if (b.b0(a)) {
            c = true;
            b.b2(a);
        }
        this.pz.a0(this, this.qy(), runOn(this, this.pi), this.rn(b), this.rp(b));
        var d = false;
        var e = this.pz.b;
        if (e != null) {
            d = true;
        }
        var f = typeCast(FinancialPriceSeriesView.$, b);
        f.ca();
        f.b8 = false;
        if (f.b7) {
            f.b5.g$d();
        }
        if (this.trendLineType != 0) {
            f.b5.g$g(a.p);
        }
        if (d) {
            this.s9(a, b, c);
        }
        else {
            f.b6.count = 0;
            this.s8(a, b);
        }
    };
    FinancialPriceSeries.prototype.f1 = function () {
        var a = this.getEffectiveViewport1(this.bx);
        return this.s3(this.p7, a);
    };
    FinancialPriceSeries.prototype.s9 = function (a, b, c) {
        var d = this.s2;
        var e = this.getEffectiveViewport1(b);
        var f = this.s3(b, e);
        var g = (f - 1) / 2;
        var h = typeCast(FinancialPriceSeriesView.$, b);
        h.b8 = true;
        var i = a.f;
        var j = 0;
        var k = this.ch.count;
        var l = this.pq;
        var m = new ScalerParams(0, b.bv, b.bu, l.cc, e);
        var n = this.of;
        var o = this.sw;
        if (o == null) {
            o = n;
        }
        var p = this.oi;
        var q = this.tm;
        if (q == null) {
            q = p;
        }
        var _loop_1 = function (r) {
            var s = i._inner[r][0] - g;
            var t = i._inner[r][0];
            var u = i._inner[r][0] + g;
            var v = i._inner[r][1];
            var w = i._inner[r][2];
            var x = i._inner[r][3];
            var y = i._inner[r][4];
            if (isNaN_(v) || isNaN_(w) || isNaN_(x) || isNaN_(y)) {
                return "continue";
            }
            var z = h.b6.item(j);
            j++;
            var aa = v < y;
            var ab = new PathGeometry();
            if (c) {
                switch (d) {
                    case 0:
                        if (aa) {
                            var ac = v;
                            v = y;
                            y = ac;
                        }
                        var ad = new PathFigure();
                        ad._startPoint = { $type: Point_$type, x: t, y: x };
                        ad._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        var ae = new PathFigure();
                        ae._startPoint = { $type: Point_$type, x: s, y: y };
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: y };
                            return $ret;
                        })()));
                        var af = new PathFigure();
                        af._startPoint = { $type: Point_$type, x: t, y: y };
                        af._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        ab.c.add(ad);
                        ab.c.add(ae);
                        ab.c.add(af);
                        break;
                    case 1:
                        var ag = new PathFigure();
                        ag._startPoint = { $type: Point_$type, x: s, y: v };
                        ag._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        var ah = new PathFigure();
                        ah._startPoint = { $type: Point_$type, x: t, y: x };
                        ah._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        var ai = new PathFigure();
                        ai._startPoint = { $type: Point_$type, x: t, y: y };
                        ai._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ab.c.add(ag);
                        ab.c.add(ah);
                        ab.c.add(ai);
                        break;
                }
            }
            if (aa) {
                this_1.pz.ak = o;
                this_1.pz.ag = o;
                this_1.pz.ah = q;
                this_1.pz.al = q;
                this_1.pz.f = true;
            }
            else {
                this_1.pz.ak = n;
                this_1.pz.ag = n;
                this_1.pz.ah = p;
                this_1.pz.al = p;
                this_1.pz.f = false;
            }
            this_1.sg(i, r, k, l, m, b.q);
            if (d == 1) {
                this_1.pz.ad(z, true, false, false, false);
            }
            else {
                this_1.pz.ad(z, false, false, false, false);
            }
            if (c) {
                z.ak = ab;
            }
        };
        var this_1 = this;
        for (var r = 0; r < i.count; ++r) {
            _loop_1(r);
        }
        h.b6.count = j;
        h.cc();
    };
    FinancialPriceSeries.prototype.s3 = function (a, b) {
        var c = this.pq.ki(a.bv, a.bu, b);
        c = Math.max(c, this.gh * 0.9);
        c = Math.max(c, 3);
        return c;
    };
    FinancialPriceSeries.prototype.s8 = function (a, b) {
        var c = this.s2;
        var d = this.getEffectiveViewport1(b);
        var e = this.s3(b, d);
        var f = (e - 1) / 2;
        var g = typeCast(FinancialPriceSeriesView.$, b);
        var h = g.ck();
        var i = g.cj();
        var j = a.f;
        var _loop_2 = function (k) {
            var l = j._inner[k][0] - f;
            var m = j._inner[k][0];
            var n = j._inner[k][0] + f;
            var o = j._inner[k][1];
            var p = j._inner[k][2];
            var q = j._inner[k][3];
            var r = j._inner[k][4];
            if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                return "continue";
            }
            var s = o < r;
            var t = s ? i : h;
            switch (c) {
                case 0:
                    if (s) {
                        var u = o;
                        o = r;
                        r = u;
                    }
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new RectangleGeometry();
                        $ret.e = new Rect(0, l, r, n - l, o - r);
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    break;
                case 1:
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: l, y: o };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: n, y: r };
                        return $ret;
                    })()));
                    break;
            }
        };
        for (var k = 0; k < j.count; ++k) {
            _loop_2(k);
        }
    };
    FinancialPriceSeries.prototype.hn = function (a, b) {
        if (this.s1.b7 && a == this.s1.b5.g$j) {
            return null;
        }
        return _super.prototype.hn.call(this, a, b);
    };
    FinancialPriceSeries.prototype.md = function () {
        _super.prototype.md.call(this);
        if (this.g9 < 0) {
            return;
        }
        this.s1.ci();
    };
    FinancialPriceSeries.prototype.kr = function (a) {
        _super.prototype.kr.call(this, a);
        if (this.s1.b7) {
            this.a6.exportTrendlineData(this, a, this.s1.b5.g$j);
        }
    };
    FinancialPriceSeries.prototype.oq = function () {
        return this.tm;
    };
    FinancialPriceSeries.prototype.l5 = function (a, b) {
        _super.prototype.l5.call(this, a, b);
        this.tm = b;
    };
    FinancialPriceSeries.prototype.a8 = function (a) {
        if (this.s2 == 0) {
            return 3;
        }
        else if (this.s2 == 1) {
            return 2;
        }
        return a;
    };
    FinancialPriceSeries.$t = markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialPriceSeries.tb = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialPriceSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:s2:tc', [PriceDisplayType_$type, enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:tm:td', [Brush.$, null], 'TrendLineType::tj', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::ti', [1, 1.5], 'TrendLinePeriod::th', [1, 7], 'TrendLineBrush::te', [Brush.$, null], 'TrendLineZIndex:s5:tk', [1, 1001], 'TrendLineDashArray:tn:tf', [DoubleCollection.$], 'TrendLineDashCap:to:tg', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialPriceSeries;
}(FinancialSeries));
export { FinancialPriceSeries };
/**
 * @hidden
 */
var FinancialPriceSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeriesView, _super);
    function FinancialPriceSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b3 = null;
        _this.b6 = null;
        _this.b9 = null;
        _this.cn = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.cm = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.b4 = null;
        _this.cl = new Path();
        _this.b8 = false;
        _this.b3 = a;
        _this.b9 = new List$1(Path.$, 0);
        _this.b6 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.co);
            $ret.activate = runOn(_this, _this.ce);
            $ret.disactivate = runOn(_this, _this.cg);
            $ret.destroy = runOn(_this, _this.cf);
            return $ret;
        })());
        return _this;
    }
    FinancialPriceSeriesView.prototype.co = function () {
        var a = new Path();
        this.b9.add(a);
        a._visibility = 1;
        return a;
    };
    FinancialPriceSeriesView.prototype.ce = function (a) {
        a._visibility = 0;
    };
    FinancialPriceSeriesView.prototype.cg = function (a) {
        a._visibility = 1;
    };
    FinancialPriceSeriesView.prototype.cf = function (a) {
        this.b9.remove(a);
    };
    FinancialPriceSeriesView.prototype.by = function () {
        return new FinancialPriceBucketCalculator(this);
    };
    FinancialPriceSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.b3.s2 = Defaults.g;
            this.b3.sw = Defaults.ah;
            this.b3.tm = Defaults.ai;
            this.b3.gh = Defaults.k;
            this.b3.gm = Defaults.l;
            this.b3.oo = this.b3.oi;
        }
    };
    Object.defineProperty(FinancialPriceSeriesView.prototype, "b5", {
        get: function () {
            if (this.b4 == null) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
            return this.b4;
        },
        set: function (a) {
            this.b4 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialPriceSeriesView.prototype, "b7", {
        get: function () {
            return this.b4 != null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialPriceSeriesView.prototype.ch = function () {
        if (this.b3.s2 == 1) {
            this.cn._stroke = this.e.of;
        }
        else {
            this.cn._stroke = this.e.oi;
        }
        if (this.b3.s2 == 1) {
            this.cm._stroke = this.bz.sw;
        }
        else {
            this.cm._stroke = this.b3.tm;
        }
    };
    FinancialPriceSeriesView.prototype.cb = function () {
        this.aq();
        this.b6.count = 0;
        this.ca();
    };
    FinancialPriceSeriesView.prototype.ca = function () {
        var a = typeCast(GeometryGroup.$, this.cn.ak);
        var b = typeCast(GeometryGroup.$, this.cm.ak);
        Extensions.d(a);
        Extensions.d(b);
    };
    FinancialPriceSeriesView.prototype.ck = function () {
        this.aq();
        return typeCast(GeometryGroup.$, this.cn.ak);
    };
    FinancialPriceSeriesView.prototype.cj = function () {
        this.aq();
        return typeCast(GeometryGroup.$, this.cm.ak);
    };
    FinancialPriceSeriesView.prototype.ci = function () {
        this.b3.tl = null;
        if (this.b3.trendLineBrush != null) {
            this.b3.tl = this.b3.trendLineBrush;
        }
        else {
            this.b3.tl = this.b3.of;
        }
    };
    FinancialPriceSeriesView.prototype.bb = function () {
        _super.prototype.bb.call(this);
        this.cn.ac = this.e.fl;
        this.cn.ai = this.e.os;
        this.cn.ad = this.e.ot;
        if (this.b3.s2 == 1) {
            this.cn._stroke = this.e.of;
        }
        else {
            this.cn._stroke = this.e.oi;
            this.cn._fill = this.e.of;
        }
        this.cm.ac = this.e.fl;
        this.cm.ai = this.e.os;
        this.cm.ad = this.e.ot;
        if (this.b3.s2 == 1) {
            this.cm._stroke = this.bz.sw;
        }
        else {
            this.cm._stroke = this.b3.tm;
            this.cm._fill = this.bz.sw;
        }
    };
    FinancialPriceSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        var a = this.bo();
        this.cn.ac = this.e.fl + 3;
        if (this.b3.s2 == 1) {
            this.cn._stroke = a;
        }
        else {
            this.cn._stroke = a;
            this.cn._fill = a;
        }
        this.cm.ac = this.e.fl + 3;
        if (this.b3.s2 == 1) {
            this.cm._stroke = a;
        }
        else {
            this.cm._stroke = a;
            this.cm._fill = a;
        }
    };
    FinancialPriceSeriesView.prototype.ac = function (a) {
        return this.b9._inner[a];
    };
    FinancialPriceSeriesView.prototype.ab = function (a) {
        var b = this.b9._inner[a];
        this.cl._visibility = b._visibility;
        this.cl.ak = b.ak;
        var c = this.bp(a);
        this.cl._fill = c;
        this.cl._stroke = c;
        this.cl.ac = this.e.fl + 3;
        return this.cl;
    };
    FinancialPriceSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (this.b8) {
                for (var c = 0; c < this.b9.count; c++) {
                    var d = this.aa(c, b);
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
            else {
                a.s(this.cn);
                a.s(this.cm);
            }
        }
    };
    FinancialPriceSeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (this.b3.trendLineType != 0 && !b) {
                var c = this.b5.g$j;
                c.ac = this.b3.trendLineThickness;
                c._stroke = this.b3.tl;
                c.ai = this.b3.tn;
                c.ad = this.b3.to;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    FinancialPriceSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        if (this.b3.qy()) {
            for (var b = 0; b < this.b9.count; b++) {
                var c = this.b9._inner[b];
                if (c._fill == this.b3.sw) {
                    this.e.a6.exportPathData(a, c, "negativePathShape" + b, ["Negative"]);
                }
                else {
                    this.e.a6.exportPathData(a, c, "positivePathShape" + b, ["Positive", "Main"]);
                }
            }
        }
        else {
            this.e.a6.exportPathData(a, this.cn, "positivePathShape", ["Positive", "Main"]);
            this.e.a6.exportPathData(a, this.cm, "negativePathShape", ["Negative"]);
        }
    };
    FinancialPriceSeriesView.prototype.cc = function () {
        this.aq();
    };
    FinancialPriceSeriesView.prototype.cd = function () {
        if (this.b7) {
            this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
        }
    };
    FinancialPriceSeriesView.$t = markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
    return FinancialPriceSeriesView;
}(FinancialSeriesView));
export { FinancialPriceSeriesView };
//# sourceMappingURL=FinancialPriceSeries_combined.js.map
