/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
var HorizontalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAnchoredCategorySeries, _super);
    function HorizontalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.t0 = null;
        _this.tw = null;
        _this.t2 = null;
        _this.ty = 0;
        return _this;
    }
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "t1", {
        get: function () {
            var _this = this;
            if (this.t0 == null) {
                this.t0 = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
            }
            return this.t0;
        },
        enumerable: false,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.prototype.ke = function () {
        _super.prototype.ke.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalAnchoredCategorySeries.prototype.bo = function () {
        if (this.bp == 0) {
            return 1;
        }
        else {
            return _super.prototype.bo.call(this);
        }
    };
    HorizontalAnchoredCategorySeries.prototype.q2 = function () {
        return this.tw;
    };
    HorizontalAnchoredCategorySeries.prototype.rn = function () {
        return this.t2;
    };
    HorizontalAnchoredCategorySeries.prototype.pd = function (a) {
        if (this.q3 == null || this.q3.m.count == 0 || !this.hasMarkers || !this.pt()) {
            return Rect.empty;
        }
        return this.t1.d$d(this, this.q3.m, a, runOn(this, this.ue));
    };
    HorizontalAnchoredCategorySeries.prototype.ue = function (a) {
        return this.sv.c9(a);
    };
    HorizontalAnchoredCategorySeries.prototype.t6 = function (a, b, c) {
        return this.t1.d$c(this, this.rn(), a, b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
        return this.t1.d$a(this, this.q3.f, this.r3(this.bx), this.r4(this.bx), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ai = function (a) {
        return this.t1.d$b(this, this.q3.f, this.r3(this.bx), this.r4(this.bx), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ep = function (a, b) {
        if (this.eo(a, b)) {
            return true;
        }
        if (this.pu(a, b)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
    };
    HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var a = this.getEffectiveViewport1(this.bx);
        return this.q2().getCategorySize(this.bx.bv, this.bx.bu, a);
    };
    HorizontalAnchoredCategorySeries.prototype.f8 = function (a, b, c) {
        if (this.ca == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bx);
        var e = this.q2();
        var f = new ScalerParams(0, this.ca.pg, this.bx.bu, e.cc, d);
        var g = this.q8.r(e, this.ca.pg, this.bx.bu, d);
        return this.ga(this.valueColumn, a, e, f, g, runOn(this, this.r1), b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.g6 = function (a, b) {
        return this.g7(a, b, this.q2(), runOn(this, this.r1), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.g4 = function (a, b) {
        return this.g5(a, b, this.q2(), runOn(this, this.r1), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.fu = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.fv(a, b, this.q2(), d, e, this.valueColumn.count, runOn(this, this.r1));
    };
    HorizontalAnchoredCategorySeries.prototype.o2 = function (a, b, c) {
        if (this.q2() == null || this.rn() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.o4(a, b, c, this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.rn(), this.q2(), null, null, null);
    };
    HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.tw;
    };
    HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.t2;
    };
    HorizontalAnchoredCategorySeries.prototype.te = function (a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.tf = function (a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.rx = function () {
        return this.t2 != null && this.t2.cv();
    };
    HorizontalAnchoredCategorySeries.prototype.ua = function (a) {
        this.tw = a;
    };
    HorizontalAnchoredCategorySeries.prototype.ub = function (a) {
        this.t2 = a;
    };
    HorizontalAnchoredCategorySeries.prototype.qw = function (a, b) {
        return this.ss(a, b, this.tw);
    };
    HorizontalAnchoredCategorySeries.prototype.lm = function (a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.ua(this.xAxis);
                if (this.sv.c3) {
                    this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.tw, this.mr, this, this.ck);
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.tw, this.mr, this, this.ck);
                }
                break;
        }
        _super.prototype.lm.call(this, a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.kl(typeCast(Axis.$, c));
                    this.lr(typeCast(Axis.$, d));
                    this.ua(this.xAxis);
                    this.rc.cr.g(this.gh);
                    this.l0(false);
                    this.k7();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.kl(typeCast(Axis.$, c));
                    this.lr(typeCast(Axis.$, d));
                    this.ub(this.yAxis);
                    this.rc.cr.g(this.gh);
                    this.rx();
                    this.l0(false);
                    this.k7();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.le(true);
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.kk = function (a, b, c, d) {
        _super.prototype.kk.call(this, a, b, c, d);
        if (this.tw != null && typeCast(ISortingAxis_$type, this.tw) !== null) {
            this.tw.i$i();
        }
        switch (a) {
            case 4:
                if (this.tw != null) {
                    this.tw.cv();
                }
                if (this.t2 != null && !this.t2.cv()) {
                    this.l0(true);
                }
                break;
            case 1:
                if (this.tw != null) {
                    this.tw.cv();
                }
                if (this.t2 != null && !this.t2.cv()) {
                    this.l0(true);
                }
                break;
            case 0:
                if (this.tw != null) {
                    this.tw.cv();
                }
                if (this.t2 != null && !this.t2.cv()) {
                    this.l0(true);
                }
                break;
            case 2:
                if (this.s7 != null && this.sv.cr.d > 0 && this.t2 != null && !this.t2.cv()) {
                    this.l0(true);
                }
                break;
            case 3:
                if (d == this.s7) {
                    if (this.tw != null) {
                        this.tw.cv();
                    }
                    if (this.t2 != null && !this.t2.cv()) {
                        this.l0(true);
                    }
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.t4 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b9) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.t5 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "tz", {
        get: function () {
            return this.ty;
        },
        set: function (a) {
            var b = this.tz;
            if (a != b) {
                this.ty = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.tz));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.ry;
        },
        enumerable: false,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    HorizontalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::uc', [CategoryAxisBase.$, null], 'YAxis::ud', [NumericYAxis.$, null]]);
    return HorizontalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { HorizontalAnchoredCategorySeries };
//# sourceMappingURL=HorizontalAnchoredCategorySeries.js.map
