/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "igniteui-angular-core";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
var NumericYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericYAxis, _super);
    function NumericYAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericYAxis.$;
        _this.j6 = _this.j4();
        return _this;
    }
    NumericYAxis.prototype.a3 = function () {
        return new NumericYAxisView(this);
    };
    NumericYAxis.prototype.au = function () {
        return new VerticalAxisLabelPanel();
    };
    NumericYAxis.prototype.get_cj = function () {
        return true;
    };
    NumericYAxis.prototype.d7 = function () {
        return this.js.height;
    };
    NumericYAxis.prototype.d8 = function (a, b) {
        if (this.l5 != null) {
            return this.l5.p(a, b);
        }
        return this.l4.p(a, b);
    };
    NumericYAxis.prototype.g5 = function (a, b, c, d) {
        if (this.l5 != null) {
            this.l5.v(a, b, c, d);
            return;
        }
        this.l4.v(a, b, c, d);
    };
    NumericYAxis.prototype.g4 = function (a, b, c, d, e) {
        if (this.l5 != null) {
            this.l5.u(a, b, c, d, e);
            return;
        }
        this.l4.u(a, b, c, d, e);
    };
    NumericYAxis.prototype.eb = function (a, b) {
        if (this.l5 != null) {
            return this.l5.q(a, b);
        }
        return this.l4.q(a, b);
    };
    NumericYAxis.prototype.g6 = function (a, b, c, d) {
        if (this.l5 != null) {
            this.l5.j(a, b, c, d);
            return;
        }
        this.l4.j(a, b, c, d);
    };
    NumericYAxis.prototype.mm = function (a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.ma(a, this);
        var d = this.ma(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.pw = new Rect(0, this.bh.pw.x, d, this.bh.pw.width, c - d);
    };
    NumericYAxis.prototype.j4 = function () {
        var _this = this;
        var a = _super.prototype.j4.call(this);
        a.b.c = function (b) {
            if (_this.ay == null || _this.ay.visibility == 0) {
                _this.av.bc = b;
                if (_this.ay != null && (_this.ay.location == 7 || _this.ay.location == 6)) {
                    _this.bh.jq();
                }
            }
        };
        a.k = function (b, c, d) { return _this.g8(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.g9(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.cd, d);
            return _this.d8(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.h1(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = _this.ay != null && (_this.ay.location == 7 || _this.ay.location == 3) ? b.z.right : b.z.left;
            var c = b.y;
            var d = new ScalerParams(0, b.aa, b.z, _this.cd, c);
            if (_this.ai != null && _this.ai.bh != null) {
                var e = b.n;
                var f = b.r;
                var g = _this.hv(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    };
    NumericYAxis.prototype.j7 = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.j7.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.cc, c);
        var h = NaN;
        var i = NaN;
        if (!this.cc && b.top == 0) {
            i = this.ku;
        }
        else if (this.cc && b.bottom == 1) {
            h = this.ku;
        }
        if (isNaN_(h)) {
            h = this.eb(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.eb(e.top, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.ky = j;
        this.kx = k;
        var l = ((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    };
    NumericYAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = this.js;
        var d = this.jn();
        var e = this.jm();
        var f = this.j6.c(a, c, b, d, e);
        if (f != null) {
            this.kt = f.f.m;
            this.kw = f.f.l;
        }
    };
    NumericYAxis.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        if (b.height != a.height) {
            this.cv();
        }
    };
    NumericYAxis.prototype.get_a1 = function () {
        return 1;
    };
    Object.defineProperty(NumericYAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    NumericYAxis.prototype.j9 = function () {
        if (this.kk) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.l3) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    };
    NumericYAxis.prototype.j$c = function (a, b) {
        return this.eb.apply(this, arguments);
    };
    NumericYAxis.prototype.j$b = function (a, b) {
        return this.d8.apply(this, arguments);
    };
    NumericYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.g4.apply(this, arguments);
    };
    NumericYAxis.prototype.j$e = function (a, b, c, d) {
        this.g5.apply(this, arguments);
    };
    NumericYAxis.prototype.j$f = function (a, b, c, d) {
        this.g6.apply(this, arguments);
    };
    Object.defineProperty(NumericYAxis.prototype, "j$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericYAxis;
}(StraightNumericAxisBase));
export { NumericYAxis };
/**
 * @hidden
 */
var NumericYAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericYAxisView, _super);
    function NumericYAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bi = null;
        _this.bi = a;
        return _this;
    }
    NumericYAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.jb = AxisDefaults.h;
    };
    NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
    return NumericYAxisView;
}(StraightNumericAxisBaseView));
export { NumericYAxisView };
//# sourceMappingURL=NumericYAxis_combined.js.map
