/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Describes available display types of financial price series.
 */
export var PriceDisplayType = /*@__PURE__*/ (function (PriceDisplayType) {
    /**
     * Displays prices as a Japanese Candlestick.
     */
    PriceDisplayType[PriceDisplayType["Candlestick"] = 0] = "Candlestick";
    /**
     * Displays prices as an OHLC bar.
     */
    PriceDisplayType[PriceDisplayType["OHLC"] = 1] = "OHLC";
    return PriceDisplayType;
})({});
/**
 * @hidden
 */
export var PriceDisplayType_$type = markEnum('PriceDisplayType', 'Candlestick,0|OHLC,1');
//# sourceMappingURL=PriceDisplayType.js.map
