import { __extends } from "tslib";
import { IgxAssigningCategoryStyleEventArgsBase } from "./igx-assigning-category-style-event-args-base";
import { AssigningCategoryMarkerStyleEventArgs as AssigningCategoryMarkerStyleEventArgs_internal } from "./AssigningCategoryMarkerStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series.
*/
var IgxAssigningCategoryMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxAssigningCategoryMarkerStyleEventArgs, _super);
    function IgxAssigningCategoryMarkerStyleEventArgs() {
        return _super.call(this) || this;
    }
    IgxAssigningCategoryMarkerStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryMarkerStyleEventArgs_internal();
    };
    Object.defineProperty(IgxAssigningCategoryMarkerStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgxAssigningCategoryMarkerStyleEventArgs;
}(IgxAssigningCategoryStyleEventArgsBase));
export { IgxAssigningCategoryMarkerStyleEventArgs };
//# sourceMappingURL=igx-assigning-category-marker-style-event-args.js.map
