import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOption_$type } from './FinancialChartRangeSelectorOption';
import { ensureEnum } from "igniteui-angular-core";
var IgxFinancialChartRangeSelectorOptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxFinancialChartRangeSelectorOptionCollection, _super);
    function IgxFinancialChartRangeSelectorOptionCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxFinancialChartRangeSelectorOptionCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(FinancialChartRangeSelectorOption_$type, item);
    };
    IgxFinancialChartRangeSelectorOptionCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorOption_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgxFinancialChartRangeSelectorOptionCollection;
}(IgCollection));
export { IgxFinancialChartRangeSelectorOptionCollection };
//# sourceMappingURL=igx-financial-chart-range-selector-option-collection.js.map
