import { ensureBool } from "igniteui-angular-core";
/**
 * Contains PieChart label click event data.
*/
var IgxLabelClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgxLabelClickEventArgs() {
    }
    Object.defineProperty(IgxLabelClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxLabelClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxLabelClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxLabelClickEventArgs.prototype, "item", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.item;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxLabelClickEventArgs.prototype, "allowSliceClick", {
        /**
         * Gets and sets whether or not the owning pie chart should fire its SliceClick event
        */
        get: function () {
            return this.i.allowSliceClick;
        },
        set: function (v) {
            this.i.allowSliceClick = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgxLabelClickEventArgs;
}());
export { IgxLabelClickEventArgs };
//# sourceMappingURL=igx-label-click-event-args.js.map
