import { __extends } from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStackedLineSeriesComponent } from "./igx-stacked-line-series-component";
import { IgxHorizontalStackedSeriesBaseComponent } from "./igx-horizontal-stacked-series-base-component";
import { IgxStackedSeriesBaseComponent } from "./igx-stacked-series-base-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { Stacked100LineSeries } from "./Stacked100LineSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent stacked100 line series.
*/
var IgxStacked100LineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxStacked100LineSeriesComponent, _super);
    function IgxStacked100LineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxStacked100LineSeriesComponent.prototype.createImplementation = function () {
        return new Stacked100LineSeries();
    };
    Object.defineProperty(IgxStacked100LineSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxStacked100LineSeriesComponent.prototype, "isPercentBased", {
        get: function () {
            return this.i.s3;
        },
        enumerable: false,
        configurable: true
    });
    IgxStacked100LineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxStacked100LineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100LineSeriesComponent, selector: "igx-stacked-100-line-series", providers: [{ provide: IgxStackedLineSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxStacked100LineSeriesComponent;
}(IgxStackedLineSeriesComponent));
export { IgxStacked100LineSeriesComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-stacked-100-line-series',
                    template: "",
                    providers: [{ provide: IgxStackedLineSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; } });
//# sourceMappingURL=igx-stacked-100-line-series-component.js.map
