import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { CategoryItemHighlightType } from "./CategoryItemHighlightType";
import { MarkerType } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected get_c5(): boolean;
    constructor();
    protected bu(): SeriesView;
    lh(a: SeriesView): void;
    protected qm: CategoryItemHighlightLayerView;
    qq: Series;
    q4: string;
    qu: boolean;
    qn: CategoryItemHighlightType;
    qp: MarkerType;
    ro: Brush;
    rp: Brush;
    rd: DataTemplate;
    qw: number;
    qt: boolean;
    protected p3(a: Series, b: boolean): void;
    protected pq(a: Series): boolean;
    protected p5(a: Frame, b: SeriesView): void;
    private qs;
    private qr;
    protected lm(a: any, b: string, c: any, d: any): void;
    private qv;
    private ra;
    q8(a: Point, b: CategoryItemHighlightLayerFrame, c: Series): void;
    private qo;
    q9(a: Rect, b: CategoryItemHighlightLayerFrame, c: Series): void;
    protected p8(a: Frame, b: SeriesView): void;
    rb(a: ItemHighlightFrameRect, b: ContentControl): void;
    rc(a: ItemHighlightFrameRect, b: Rectangle): void;
    protected eg(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryItemHighlightLayer);
    protected b4: CategoryItemHighlightLayer;
    b6: Pool$1<Rectangle>;
    b5: Pool$1<ContentControl>;
    as(): void;
    protected b7: List$1<ContentControl>;
    protected b8: List$1<Rectangle>;
    private ck;
    private ce;
    private cg;
    private cf;
    private ch;
    private b9;
    private cb;
    private ca;
    ci(a: Brush): Brush;
    cj(a: Brush): Brush;
    cd(a: Rectangle, b: number, c: number, d: number, e: number): void;
    cc(a: ContentControl, b: number, c: number): void;
    protected bh(a: any, b: number): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
