import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { SeriesView } from "./SeriesView";
import { Type } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Pool$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { RadialFrame } from "./RadialFrame";
import { RadialBaseView } from "./RadialBaseView";
import { List$1 } from "igniteui-angular-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class RadialPieSeries extends AnchoredRadialSeries {
    static $t: Type;
    protected get_dy(): boolean;
    protected get_dw(): boolean;
    protected bu(): SeriesView;
    lh(a: SeriesView): void;
    tf: RadialPieSeriesView;
    constructor();
    tg: number;
    th: number;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    kh(a: boolean, b: SeriesView): void;
    f1(): number;
    protected get_cy(): boolean;
    r4(a: RadialFrame, b: RadialBaseView): void;
    private tn;
    private tm;
    protected lm(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialPieSeriesView extends AnchoredRadialSeriesView {
    static $t: Type;
    protected c0: RadialPieSeries;
    constructor(a: RadialPieSeries);
    c1: Pool$1<Path>;
    as(): void;
    protected c2: List$1<Path>;
    c8(): Path;
    c3(a: Path): void;
    c5(a: Path): void;
    c4(a: Path): void;
    protected be(a: any, b: number): void;
    protected ac(a: number): any;
    private c7;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    c6(): void;
    al(a: any): void;
}
