import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { ContourValueResolver } from "./ContourValueResolver";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { List$1 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterContourSeries extends ScatterTriangulationSeries {
    static $t: Type;
    protected get_du(): boolean;
    constructor();
    hk(a: any, b: string): any;
    private q1;
    protected bu(): SeriesView;
    q9: string;
    private q4;
    get q5(): IFastItemColumn$1<number>;
    set q5(a: IFastItemColumn$1<number>);
    protected lm(a: any, b: string, c: any, d: any): void;
    kh(a: boolean, b: SeriesView): void;
    l1(a: boolean): void;
    lz(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected rc(a: SeriesView): void;
    q3: ValueBrushScale;
    q2: ValueBrushScale;
    protected md(): void;
    private rd;
    private qz;
    get q0(): ContourValueResolver;
    set q0(a: ContourValueResolver);
    private re;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    at(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterContourSeriesView extends SeriesView {
    static $t: Type;
    private bz;
    private by;
    constructor(a: ScatterContourSeries);
    protected b1: List$1<Path>;
    private b8;
    private b4;
    private b5;
    private b6;
    private b0;
    private bx;
    b2(a: List$1<List$1<List$1<Point>>>, b: number[]): void;
    protected be(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a6(a: RenderingContext, b: boolean): void;
    b3(a: boolean): void;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
    b7(a: Point, b: boolean): Path;
}
