import { StackedBarSeries } from "./StackedBarSeries";
import { IStacked100Series } from "./IStacked100Series";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategorySeriesView } from "./CategorySeriesView";
import { StackedBarSeriesView } from "./StackedBarSeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
/**
 * @hidden
 */
export declare class Stacked100BarSeries extends StackedBarSeries implements IStacked100Series {
    static $t: Type;
    protected get_s3(): boolean;
    constructor();
    ac(): void;
    protected bu(): SeriesView;
    t7: Stacked100BarSeriesView;
    lh(a: SeriesView): void;
    sv(): CategorySeriesView;
    protected tj(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class Stacked100BarSeriesView extends StackedBarSeriesView {
    static $t: Type;
    c6: Stacked100BarSeries;
    constructor(a: Stacked100BarSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
