import { StackedColumnSeries } from "./StackedColumnSeries";
import { IStacked100Series } from "./IStacked100Series";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategorySeriesView } from "./CategorySeriesView";
import { StackedColumnSeriesView } from "./StackedColumnSeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
/**
 * @hidden
 */
export declare class Stacked100ColumnSeries extends StackedColumnSeries implements IStacked100Series {
    static $t: Type;
    protected get_s3(): boolean;
    constructor();
    ac(): void;
    protected bu(): SeriesView;
    t7: Stacked100ColumnSeriesView;
    lh(a: SeriesView): void;
    sv(): CategorySeriesView;
    protected tj(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class Stacked100ColumnSeriesView extends StackedColumnSeriesView {
    static $t: Type;
    c5: Stacked100ColumnSeries;
    constructor(a: Stacked100ColumnSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
