import { IgRect } from "igniteui-angular-core";
import { FunnelSliceEventArgs as FunnelSliceEventArgs_internal } from "./FunnelSliceEventArgs";
/**
 * Information about the clicked slice.
*/
export declare class IgxFunnelSliceEventArgs {
    protected createImplementation(): FunnelSliceEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): FunnelSliceEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The index of the slice.
    */
    get index(): number;
    set index(v: number);
    static ngAcceptInputType_index: number | string;
    /**
     * The bounds of the slice.
    */
    get bounds(): IgRect;
    set bounds(v: IgRect);
    static ngAcceptInputType_bounds: IgRect | string;
    /**
     * The data item for the clicked slice.
    */
    get item(): any;
    set item(v: any);
}
