import { IgDataTemplate } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { IgxStyle } from "igniteui-angular-core";
import { MarkerType } from "./MarkerType";
import { StackedSeriesCreatedEventArgs as StackedSeriesCreatedEventArgs_internal } from "./StackedSeriesCreatedEventArgs";
/**
 * Provides data for IgxDataChartComponent stacked series.
*/
export declare class IgxStackedSeriesCreatedEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): StackedSeriesCreatedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the series brush.
    */
    get brush(): string;
    set brush(v: string);
    /**
     * Gets or sets the series legend item template.
    */
    get legendItemTemplate(): IgDataTemplate;
    set legendItemTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the series legend item badge templae.
    */
    get legendItemBadgeTemplate(): IgDataTemplate;
    set legendItemBadgeTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the visibility of the series legend.
    */
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(v: Visibility);
    static ngAcceptInputType_legendItemVisibility: Visibility | string;
    /**
     * Gets or sets the series outline brush.
    */
    get outline(): string;
    set outline(v: string);
    /**
     * Gets the index of the series.
    */
    get index(): number;
    static ngAcceptInputType_index: number | string;
    /**
     * Gets or sets the series outline thickness.
    */
    get thickness(): number;
    set thickness(v: number);
    static ngAcceptInputType_thickness: number | string;
    /**
     * Gets or sets the series title.
    */
    get title(): any;
    set title(v: any);
    /**
     * Gets or sets the series marker brush.
    */
    get markerBrush(): string;
    set markerBrush(v: string);
    /**
     * Gets or sets the series marker outline.
    */
    get markerOutline(): string;
    set markerOutline(v: string);
    /**
     * Gets or sets the series marker style.
    */
    get markerStyle(): IgxStyle;
    set markerStyle(v: IgxStyle);
    /**
     * Gets or sets the series marker template.
    */
    get markerTemplate(): IgDataTemplate;
    set markerTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the series marker type.
    */
    get markerType(): MarkerType;
    set markerType(v: MarkerType);
    static ngAcceptInputType_markerType: MarkerType | string;
    /**
     * Gets or sets the series marker thickness.
    */
    get markerThickness(): number;
    set markerThickness(v: number);
    static ngAcceptInputType_markerThickness: number | string;
}
